<%@page import="java.util.ResourceBundle"%>

<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.util.*"%>
<%@page import="com.sas.solutions.cpb.screendefs.Field"%>
<%@page import="com.sas.oprisk.server.ApplicationProperties"%>
<%@page import="com.sas.solutions.cpb.util.FieldUtil"%>

<%
/**
 * An example custom component to allow the user to choose a color
 * and store it in the UI context as a String in the form "#RRGGBB".
 */
final ComponentFieldRenderer.ComponentInfo componentInfo
      = ComponentFieldRenderer.getComponentInfo(request);
final Field field = componentInfo.getField();
final String safeFieldName = HTMLUtil.getSafeFieldName(field.getName());
final UIContext uiContext = RequestUtil.getUIContext(request);
Object value = uiContext.getValue(field);

// retrieve the application resource bundle
final ResourceBundle bundle = ApplicationProperties.getBundle();

// format for use as the name of an HTML input field
String fieldName = FieldUtil.formatFieldName(field.getName());

// get the localized label for the field
String label = FieldUtil.getLabel(field, uiContext, true);

// if the current value isn't a String, don't use it
String color = value instanceof String ? (String)value : "";
%>
<div class="section" style="padding:5px">
<div id="colorPicker<%=fieldName%>"></div>
<script type="text/javascript">
function colorClicked_<%= safeFieldName %>(td)
{
   var color = td.getAttribute('color_<%= safeFieldName %>');
   elementById("<%=fieldName%>").value = color;
   elementById("<%="colorBox" + fieldName%>").style.background = color;
}
var colorCodes = ['FF', 'CC', '99', '66', '33', '00'];
var codeCount = colorCodes.length;
var html = "<table>";
for (var r = 0; r < codeCount; r++)
{
   html += "<tr>";
   for (var g = 0; g < codeCount; g++)
   {
      for (var b = 0; b < codeCount; b++)
      {
         var color = "#" + colorCodes[r] + colorCodes[g] + colorCodes[b];
         html += "<td style='cursor:default;background-color:" + color + "' "
                   + "onclick='colorClicked_<%= safeFieldName %>(this)' "
                   + "color_<%= safeFieldName %>='" + color + "'>"
              + "&nbsp;&nbsp;&nbsp;</td>";
      }
   }
   html += "</tr>";
}
html += "</table>";
elementById("colorPicker<%=fieldName%>").innerHTML = html;
</script>
<br/>
<%
// output the required and error indicators 
HTMLUtil.writeFieldIndicators(fieldName,
   FieldUtil.isRequired(field, uiContext),
   false, // this field will never be confidential
   RequestUtil.isFieldValueInvalid(fieldName, pageContext),
   uiContext.getLocale(),
   out);
%>

<%-- output the label --%>
<span class="fieldlabel"><%=label%></span>

<%-- display the previously selected color --%>
<img src="<%=bundle.getString("application.colorbox.image")%>"
     id="colorBox<%=fieldName%>" alt=""
     style="background-color:<%= StringUtil.escapeHTML(color) %>;
            vertical-align:middle;margin-bottom:.25em;border:0 solid black"/>

<%-- output an HTML input so that it will be submitted with the form --%>
<input id="<%=fieldName%>" type="text" name="<%=fieldName%>"
       value="<%=color%>"/>

</div>
