<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.*" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceSession" %>
<%@page import="org.apache.commons.lang.StringUtils"%>
<%@page import="com.sas.solutions.cpb.web.util.CPBWebConstants"%>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   MonitorContext mcontext = MonitorContext.getMonitorContext(request);
   List sourceSystems = mcontext.getSourceSystemCodeTable(locale, psession);
   request.setAttribute("sourceSystems", sourceSystems);
%>
<mon:Page template="popup">

<mon:Head>

<mon:include js="/script/checkboxRadioUtil.js" />

<script type="text/javascript">

function doSave(button) {
   var f = document.forms.attachmentFormEx;
   try {
      lock(button);
      f.submit();
   } catch (ex) {
      document.forms.attachmentFormEx.location.focus();
      alert("<fmt:message key='attachmentFormEx.error.locationInvalid.txt' />");
      unlock(button);
   }
}


function cancelPopup() {
   window.close();
}

function initializeLinksOnly() {
   var value = "LNK";
   
   // disable them as well as hide them, so the value doesn't get submitted
   setVisible("attachment_location", "<%= AttachmentTypeCd.file.value %>" == value);    
   setEnabled("attachment_location", "<%= AttachmentTypeCd.file.value %>" == value);    
   setVisible("attachment_urlTxt", "<%= AttachmentTypeCd.link.value %>" == value);   
   setEnabled("attachment_urlTxt", "<%= AttachmentTypeCd.link.value %>" == value);   
}


function typeChanged() {
   var value = getSelectedRadioValue("attachmentFormEx", "attachmentTypeCd");
   if (value == null) {
      var field = document.forms.attachmentFormEx.elements["attachmentTypeCd"];
      if (field) {
         value = field.value;
      }
   }
   
   // disable them as well as hide them, so the value doesn't get submitted
   setVisible("attachment_location", "<%= AttachmentTypeCd.file.value %>" == value);    
   setEnabled("attachment_location", "<%= AttachmentTypeCd.file.value %>" == value);    
   setVisible("attachment_urlTxt", "<%= AttachmentTypeCd.link.value %>" == value);   
   setEnabled("attachment_urlTxt", "<%= AttachmentTypeCd.link.value %>" == value);   
}

</script>
</mon:Head>

<mon:Body>

<html:form action="/SaveAttachment.do" enctype="multipart/form-data">

<mon:Content>
  <html:hidden property="handle" />
  <html:hidden property="attachmentRk" />
  <html:hidden property="attachedTo" />
  <html:hidden property="groupNo" />
  <html:hidden property="baseObjectHandleString" />
  <html:hidden property="linksAllowed" />
  <html:hidden property="linksOnly" />
  <html:hidden property="immediateSave" />

<% 
   String uiContextId = request.getParameter(CPBWebConstants.PARAM_UI_CONTEXT_ID);
   if (StringUtils.isNotEmpty(uiContextId)) { 
%>  
      <input type="hidden" name="<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>" value="<%= StringUtil.escapeHTML(uiContextId) %>" />
<% } %>

<table width="100%">
<tr id="attachment_attachmentId">
  <td style="white-space: nowrap;">
  <c:if test="${not attachmentFormEx.linksOnly}">
	<mon:label key="attachment.field.attachmentId.displayName.txt" 
		property="attachmentId" separatorVisible="true" />
  </c:if>
  <c:if test="${attachmentFormEx.linksOnly}">
	<mon:label key="attachment.linksOnly.field.attachmentId.displayName.txt" 
		property="attachmentId" separatorVisible="true" />
</c:if>
  </td>
  <td width="100%" class="field">
	<% if (ConfigDataProperties.isUserDefinedIDAllowed()) { %>
		<mon:text property="attachmentId" maxlength="32" />
	<% } else { %>
		<c:out value="${attachmentFormEx.attachmentId}" />
		<html:hidden property="attachmentId" />
	<% } %>
  </td>
</tr>
<tr id="attachment_sourceSystemCd">
  <th class="fieldlabel" style="white-space: nowrap;">
     <mon:label key="attachment.field.sourceSystemCd.displayName.txt" 
	    property="sourceSystemCd" separatorVisible="true" />
  </th>
  <td>
     <mon:select property="sourceSystemCd">
    	<html:options 
        	name="request"
        	collection="sourceSystems" 
        	property="code" 
        	labelProperty="description" />
     </mon:select>
    </td>
</tr>
<tr id="attachment_attachmentNm">
  <td style="white-space: nowrap;">
  <c:if test="${not attachmentFormEx.linksOnly}">
	<mon:label key="attachment.field.attachmentNm.displayName.txt" 
		property="attachmentNm" separatorVisible="true" />
	</c:if>
	<c:if test="${attachmentFormEx.linksOnly}">
	<mon:label key="attachment.linksOnly.field.attachmentNm.displayName.txt" 
		property="attachmentNm" separatorVisible="true" />
	</c:if>
  </td>
  <td>
	<mon:text property="attachmentNm" />
  </td>
</tr>

	<c:if test="${attachmentFormEx.linksAllowed && not attachmentFormEx.linksOnly}">
	<tr id="attachment_attachmentTypeCd">
		<th class="fieldlabel" style="white-space: nowrap;"><mon:label property="attachmentTypeCd" separatorVisible="true"
	       		key="attachment.field.attachmentTypeCd.displayName.txt" /></th>
		<td>
	      <fieldset class="screen-reader-only">
	      <legend><mon:label property="attachmentTypeCd" separatorVisible="true"
	            key="attachment.field.attachmentTypeCd.displayName.txt" /></legend>
			<mon:radio property="attachmentTypeCd" value="<%= AttachmentTypeCd.file.value %>" onclick="typeChanged()">
				<fmt:message key="AttachmentTypeCd.file.displayName.txt" />
			</mon:radio>
			&nbsp;
			<mon:radio property="attachmentTypeCd" value="<%= AttachmentTypeCd.link.value %>" onclick="typeChanged()">
				<fmt:message key="AttachmentTypeCd.link.displayName.txt" />
			</mon:radio>
	      </fieldset>
	   </td>
	</tr>
	</c:if>
	
	<c:if test="${attachmentFormEx.linksAllowed && attachmentFormEx.linksOnly}">
	 <input type="hidden" name="attachmentTypeCd" value="<%= AttachmentTypeCd.link.value %>" />
	</c:if>
	
	<c:if test="${not attachmentFormEx.linksAllowed}">
	  <input type="hidden" name="attachmentTypeCd" value="<%= AttachmentTypeCd.file.value %>" />
	</c:if>

	
	
<tr id="attachment_location">
  <td style="white-space: nowrap;">
	<mon:label key="attachment.field.location.displayName.txt" requiredField="true"
		property="location" separatorVisible="true" />
  </td>
  <td>
	<html:file property="location" />
  </td>
</tr>

<tr id="attachment_urlTxt">
  <td style="white-space: nowrap;">
	<mon:label key="attachment.field.urlTxt.displayName.txt" requiredField="true"
		property="urlTxt" separatorVisible="true" />
  </td>
  <td>
	<html:text property="urlTxt" maxlength="1000" style="width:97%" />
  </td>
</tr>

<c:choose>
<c:when test="${attachmentFormEx.linksAllowed && attachmentFormEx.linksOnly}">
	<script type="text/javascript">
		initializeLinksOnly();
	</script>
</c:when>
<c:otherwise>
	<script type="text/javascript">
	typeChanged();
	</script>
</c:otherwise>
</c:choose>

</table>

</mon:Content>

<mon:PopupButtonBar>
   <mon:Button type="submit" onclick="doSave(this)">
      <fmt:message key='application.ok.txt' />
   </mon:Button>
     
   <mon:Button type="button" onclick="cancelPopup();">
      <fmt:message key='cancelButton.txt' />
   </mon:Button>
</mon:PopupButtonBar>

</html:form>

<script type="text/javascript">
document.forms.attachmentFormEx.attachmentNm.focus();
</script>

</mon:Body>

</mon:Page>