<%@ page import="com.sas.oprisk.server.Attachment" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.attachments.*" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceSession" %>
<%@ page import="org.apache.commons.lang.*" %> 
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.attachments.actions.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.solutions.cpb.web.util.CPBWebConstants"%><mon:setBundle />

<%
	java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   final AttachmentsTableTag.AttachmentsModel attModel = (AttachmentsTableTag.AttachmentsModel)request.getAttribute("attModel");
	final AttachmentContainer ac = attModel.getAttachmentContainer();
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final MonitorContext mc = MonitorContext.getMonitorContext(request);
	final Integer groupNo = attModel.getGroupNo();
	String groupNoStr = "";
	//final String entryName=attModel.isLinksOnly()? AttachmentQueryAction.TABLE_LINKS : AttachmentQueryAction.TABLE_ATTACHMENTS;
	
	if (groupNo != null) groupNoStr = ParsingUtils.formatInteger(groupNo, request.getLocale());
	final String entryName = AttachmentQueryAction.getEntryName(groupNoStr, attModel.isLinksOnly());
%>

<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />
<mon:include js="/dwr/interface/CommonService.js" />
   
<script type="text/javascript">

<c:if test="${not attachmentsScriptWritten}">
	<c:set var="attachmentsScriptWritten" value="true" scope="request" />


// keeps track of all the attachment tables on the page
var attInfos = new Array();

<%-- Create a new Attachment --%>
function addAttachment(tpHandle, handle, groupNo,linksOnly) {

   popupAnchor = "#attachments" + tpHandle;
   openModal(
      "<%= request.getContextPath() %>" 
      + "/Attachment.do?method=add"
      + "&attachedTo=" + tpHandle
      + "&baseObjectHandleString=" + handle 
      + "&linksAllowed=<c:out value='${attModel.linksAllowed}' />" 
      + "&linksOnly=" + linksOnly 
      + "&immediateSave=<c:out value='${attModel.immediateSave}' />" 
<% if (StringUtils.isNotEmpty(attModel.getUiContextId())) { %>
      + "&<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>=<%= attModel.getUiContextId() %>" 
<% } %>
      + "&groupNo="+groupNo, 
      "attachmentPopup", "width=640,height=570,scrollbars,resizable");
}

<%-- View Attachment --%>
function viewAttachment(attachmentHandle, acHandle, url, pointInTime) {
   if (url == "") {
      viewFile(attachmentHandle, acHandle, pointInTime);
   } else { 
      viewURL(url);
   }
}
var popupName = "opRiskPopup";
function viewFile(attachmentHandle, acHandle, pointInTime) {
   var popupWin = window.open("<%= request.getContextPath() %>" 
      + "/Attachment.do?method=view"
      + "&attachmentHandle=" + attachmentHandle
      + "&attachedTo=" + acHandle
<% if (StringUtils.isNotEmpty(attModel.getUiContextId())) { %>
      + "&<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>=<%= attModel.getUiContextId() %>" 
<% } %>      
      + (pointInTime  ? "&pointInTime=" + pointInTime : ""), popupName);
   popupWin.focus();
}

function viewURL(url) {
   // escape any spaces
   var urlTxt = url.replace(/ /g, '%20');
   var popupWin = window.open(urlTxt, popupName);
   popupWin.focus(); 
}

<%-- Remove Attachment --%>
function removeAttachment(attachmentHandle, attachmentName, tableId,entryName) {
   var attInfo = attInfos[tableId];
   var msg = attInfo.confirmDeleteMsg;
   msg = formatMessage(msg, unescape(attachmentName));
   if (confirm(msg)) {
      CommonService.deleteAttachment(
         attachmentHandle, attInfo, getAttachmentParams(attInfo,entryName), 
         function(pageMod) {
        	   PageModification.handle(tableId, pageMod);
         }
      );
   }
}

function getAttachmentParams(attInfo,entryName) {
   return attInfo.minimal 
      ? getParamsExcludeTable(document.forms[0])
      : getParamsForTable(document.forms[0], entryName);
}

<%-- Refresh Attachments Table --%>
function refreshAttachments(tableId, saved, entryName) {
   var attInfo = attInfos[tableId];
   
   // Executes the remote java method and then executes the specified
   // javascript with the returned result.
   
  
   CommonService.refreshAttachments(
      attInfo, saved, getAttachmentParams(attInfo,entryName),
      function(pageMod) {
         closeModal("attachmentPopup");
         PageModification.handle(tableId, pageMod);
      }
   );
}
</c:if>

attInfos['<c:out value='${attModel.tableId}' />'] = {
   acHandle: '<c:out value='${attModel.attachmentContainer.taggedPointerHandle}' />',
   readOnly: <c:out value='${attModel.readOnly}' />,
   minimal: <c:out value='${attModel.minimal}' />,
   moreThanOneAllowed: <c:out value='${attModel.moreThanOneAllowed}' />,
   linksAllowed: <c:out value='${attModel.linksAllowed}' />,
   linksOnly: <c:out value='${attModel.linksOnly}' />,
   immediateSave: <c:out value='${attModel.immediateSave}' />,
   refreshMethod: '<c:out value='${attModel.refreshMethod}' />',
   groupNo: <c:if test="${empty attModel.groupNo}">null</c:if><c:if test="${not empty attModel.groupNo}"><c:out value='${attModel.groupNo }' /></c:if>,
   pointInTime: '<c:out value='${attModel.pointInTime}' />',
   uiContextId: '<c:out value='${attModel.uiContextId}' />',
   confirmDeleteMsg: unescape('<c:if test="${attModel.linksOnly}"><%= ParsingUtils.escape(bundle.getString("attachment.okToDeleteLink.fmt.txt")) %></c:if><c:if test="${not attModel.linksOnly}"><%= ParsingUtils.escape(bundle.getString("attachment.okToDeleteAttachment.fmt.txt")) %></c:if>')
};


</script>

<div id="<c:out value='${attModel.tableId}' />">
<jsp:include page = "AttachmentsContent.jsp" />
</div>
