<%@ page import="com.sas.oprisk.server.Attachment" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.attachments.*" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceSession" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.attachments.actions.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.CustomTableComponent"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.server.cpb.MonitorUIDefinitionType"%>
<%@page import="com.sas.solutions.cpb.web.util.RequestUtil"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.util.HTMLUtil"%><mon:setBundle />

<%
try {
	java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   final AttachmentsTableTag.AttachmentsModel attModel = (AttachmentsTableTag.AttachmentsModel)request.getAttribute("attModel");
	final AttachmentContainer ac = attModel.getAttachmentContainer();
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final MonitorContext mc = MonitorContext.getMonitorContext(request);
	final Integer groupNo = attModel.getGroupNo();
	//final String entryName=attModel.isLinksOnly()? AttachmentQueryAction.TABLE_LINKS : AttachmentQueryAction.TABLE_ATTACHMENTS;
	String groupNoStr = "";
	if (groupNo != null) groupNoStr = groupNo.toString();
	final String entryName = AttachmentQueryAction.getEntryName(groupNoStr, attModel.isLinksOnly());
	
   final String exportAttachmentUrl = request.getContextPath() + "/AttachmentQuery.do"
      + "?acHandle=" + (ac != null ? ac.getTaggedPointerHandle().toString() : "") 
      + "&entryId=" + entryName
      + "&groupNo=" + groupNoStr
      + (attModel.getPointInTime() == null ? "" : "&pointInTime=" + attModel.getPointInTime());
	
   // localized strings used in this jsp
   String attachmentActions = bundle.getString("attachment.column.actions.txt");
   String attachmentSSC = bundle.getString("attachment.field.sourceSystemCd.displayName.txt");
   String contentType = bundle.getString("attachment.field.contentType.displayName.txt");
   String fileName = bundle.getString("attachment.field.fileNm.displayName.txt");
   String attachmentId = bundle.getString("attachment.field.attachmentId.displayName.txt");	   
   String attachmentName = bundle.getString("attachment.field.attachmentNm.displayName.txt");
   String attachmentType = bundle.getString("attachment.field.attachmentTypeCd.displayName.txt");	

   // Replace with these values if LinksOnly is true
   if (attModel.isLinksOnly())
   {
	   attachmentId = bundle.getString("attachment.linksOnly.field.attachmentId.displayName.txt");
	   attachmentName = bundle.getString("attachment.linksOnly.field.attachmentNm.displayName.txt");
	   attachmentType = bundle.getString("attachment.linksOnly.field.attachmentTypeCd.displayName.txt");
   }
     
   String title = "";
   String fieldName = "comments";
   boolean required = false;
   boolean invalid = false;
   
   // if this is being used in a CPB screen, we can get some extra info
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   if (componentInfo != null && MonitorUIDefinitionType.COMP_ATTACHMENTS.equals(componentInfo.getComponent().getName())) {
      title = CustomTableComponent.getLabel(request);
      fieldName = componentInfo.getField().getName();
      required = componentInfo.isRequired();
      invalid = RequestUtil.isFieldValueInvalid(fieldName, pageContext);
   }
%>

<a name="<c:out value='${attModel.tableId}' />"></a>

<c:if test="${not attModel.minimal}">

   <%-- Render the attachments as a Custom Table --%>

   <mon:tableComponent entryName="<%=  entryName%>" id='<%= entryName + "Entry" %>' wizCursor="${attModel.refreshMethod}" 
      exportXlsUrl="<%= exportAttachmentUrl %>" required="<%= required %>" valid="<%= !invalid %>">
      <mon:title><%= title %></mon:title>
<%
      final AttachmentEntry entry = (AttachmentEntry)pageContext.findAttribute(entryName +"Entry");
      Attachment attachment = (entry == null) ? null : entry.getAttachment();
      final String escName = attachment == null ? null : ParsingUtils.escape(ParsingUtils.escape(attachment.getAttachmentNm()));
%>
       
       <c:if test="${!attModel.readOnly}">
<%       
       final String addHref = ac == null ? "#" :
          "javascript:addAttachment('" + ac.getTaggedPointerHandle() 
             + "', '" + ac.getHandleString() 
             + "', '" + groupNoStr +"'"
             +  ",'" +  attModel.isLinksOnly()
             + "')";
%>
		<c:if test="${not attModel.linksOnly}">
         	<mon:action href="<%= addHref %>">
         		<fmt:message key='attachment.button.addAttachment.txt'/>
         	</mon:action>
        </c:if>
        
        <c:if test="${attModel.linksOnly}">
	     	<mon:action href="<%= addHref %>">
	     		<fmt:message key='attachment.button.addLink.txt'/>
	     	</mon:action>
	    </c:if>
   
         <mon:fixedColumn width='1%' title='<%= bundle.getString("application.remove.txt") %>' before="false" >
            <a href="javascript:removeAttachment('<%= attachment.getHandleString() %>', '<%= escName %>', '<%= attModel.getTableId() %>','<%=entryName %>')" ><img
               border="0" src="<fmt:message key='application.remove.image' />"  
               alt="<fmt:message key='application.remove.txt'/>" 
               title="<fmt:message key='application.remove.txt'/>"/>
            </a>
         </mon:fixedColumn>
      </c:if>
   </mon:tableComponent>

<script type="text/javascript">
   // override the submit function to use ajax
   getTableComponent('<%=entryName + "_"%>' ).submit = function() {
      refreshAttachments("<c:out value='${attModel.tableId}' />", false,"<%=entryName %>");      
   };
</script>

</c:if>	<%-- not attModel.minimal --%>

<c:if test="${attModel.minimal}">

   <%-- Render the attachments as minimal list --%>

   <c:set var="hasAttachments" value="false" />
	<c:forEach items="${attModel.attachments}" var="attachmentEntry" varStatus="status"><c:if test="${status.index > 0}">, </c:if>
		<c:set var="hasAttachments" value="true" />
<%
      final AttachmentEntry entry = (AttachmentEntry)pageContext.findAttribute("attachmentEntry");
      Attachment a = (entry == null) ? null : entry.getAttachment();
      
      // double escape name because it is going in an href
      final String escName = ParsingUtils.escape(ParsingUtils.escape(a.getAttachmentNm()));
      
		final String ssc = mc.getSourceSystemDescription(
			a.getSourceSystemCd(), request.getLocale(), psession);
		String tip = attachmentId + ": " + a.getAttachmentId() + "\n"
			+ attachmentSSC + ": " + ssc + "\n"
			+ attachmentType + ": " + bundle.getString(a.getAttachmentTypeCd().getDisplayNameKey());
		if (AttachmentTypeCd.file.equals(a.getAttachmentTypeCd())) {
			tip += "\n" + fileName + ": " + a.getFileNm();
			tip += "\n" + contentType + ": " + a.getContentType();
		}
%>   
		
<% 
   final String url = a.getUrlTxt() == null ? "" : a.getUrlTxt();
   final String viewLink = (ac == null) ? "" :     
      "javascript:viewAttachment('" + a.getHandleString() + "', '"
         + ac.getTaggedPointerHandle() + "', '" + StringUtil.escapeJSForHTMLAttribute(url) + "'"
         + (attModel.getPointInTime() == null ? "" : ", '" + attModel.getPointInTime() + "'") + ")";
%>
      <a href="<%= viewLink %>" 
      	><c:out value="${attachmentEntry.attachment.attachmentNm}" /></a
      	><c:if test="${!attModel.readOnly}">
            [<a href="javascript:removeAttachment('<c:out value="${attachmentEntry.attachment.handleString}" />', '<%= escName %>', '<c:out value="${attModel.tableId}" />', '<%=entryName %>')" ><img
		         src="<fmt:message key='application.delete.image' />" border="0" align="absmiddle"
		         alt="<fmt:message key='attachment.button.deleteAttachmentAltText.txt' />"
		         title="<fmt:message key='attachment.button.deleteAttachmentAltText.txt' />" /></a>]</c:if></c:forEach>
   <c:if test="${!attModel.readOnly and (attModel.moreThanOneAllowed or (empty attModel.attachments))}">
	   <c:if test="${hasAttachments}">&nbsp;<b>|</b>&nbsp;</c:if>
      [<a href="javascript:addAttachment('<c:out value='${attModel.attachmentContainer.taggedPointerHandle}' />', '<c:out value='${attModel.attachmentContainer.handleString}' />', '<%=groupNoStr %>', '<c:out value='${attModel.linksOnly}' />')" >
      <fmt:message key='application.add.txt' /></a>]
   </c:if>
</c:if>	<%-- attModel.minimal --%>

<%
   } catch (Throwable t) {
      t.printStackTrace();
   }
%>