<%@ page import="com.sas.oprisk.monitor.web.tags.treechooser.*" %>
<%@ page import="java.util.Map" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<mon:setBundle />
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<mon:html>
<%-- ****************************************************************** --%>
<%-- Selectable view component for SearchTreeChooser tag --%>
<%-- ****************************************************************** --%>

<head>
<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
%>
   <sas:InitializeComponents/>
   <sas:StyleSheet styleNames="SAS Style,orm,orm_IE,custom,CPB,CPBDialog,CPBSpellChecker"/>
   
   <%@ include file="/tiles/layout/styleAndScriptIncludes.jsp" %>
   <mon:include flush="true" />
   <style type="text/css">
    html, body, iframe { margin:0; padding:0; height:100%; }
    iframe { margin:0; padding:0; display:block; width:100%; height:100%; border:none; }
   </style>
</head>

<body onkeydown="doKeyFilter(event)" onload="init()" dir='<%= layoutDirection %>'>

<%-- JavaScript event handlers do nothing in readOnly mode --%>
<script type="text/javascript">

function init() {
	resizeTree();
	syncShowInactive();
   var selectedCheckboxLink = document.getElementById("selectedCheckboxLink");
   if (selectedCheckboxLink && isVisible(selectedCheckboxLink))
   {
      try {
         selectedCheckboxLink.focus();
      } catch (e) { /* do nothing */ };
   }
   // For Firefox 3.6, 4 to expand the iframes properly in the ora chooser popup.  IE 9 and Chrome 12 are fine without this.
   window.setTimeout(function(){top.PageLayout.handleWindowOnResize();}, 500);
}

function showPleaseWait() {
   document.body.innerHTML = "<div><fmt:message key='application.wait.txt' /></div>";
}

function resizeTree() {
	var div = elementById("content");
	var body = div.parentElement;
	if (body) {
		var html = body.parentElement;
		if (html.clientWidth >= 6) {
			body.style.width = html.clientWidth - 6;
		}
	}
}

function refreshForm(args) {
   var f = document.forms.searchTreeChooserForm;
   f.method.value = 'display';

   if (args !== undefined)
   {
	   f.method.value = 'saveFilter';
      
      for (var key in args)
      {
          var elem = f.elements[key];

          if (!elem)
          {
              elem = document.createElement("input");
              elem.type = "hidden";
              elem.name = key;
              f.appendChild(elem);
          }
          
          elem.value = args[key];
      }
   }
   
   this.window.setTimeout(showPleaseWait, 1000);
   f.submit();
}
function submitToAction( actionName, currentNode ) {
<c:if test="${!readOnly}" >
   document.forms.searchTreeChooserForm.method.value = actionName;
   document.forms.searchTreeChooserForm.currentNode.value = unescape(currentNode);
   this.window.setTimeout(showPleaseWait, 1000);
   document.forms.searchTreeChooserForm.submit();
</c:if>
}
function select( selectMethod, id, name, node, locPath ) {
<c:if test="${(!readOnly) && selectable}" >
   var localId = unescape(id);
   var localName = unescape(name);
   var localNode = unescape(node);
   var localPath = unescape(locPath);

	var result = parent[selectMethod](localId, localName, localNode, localPath);
	if (result == false) {
		return;
	}

   document.forms.searchTreeChooserForm.selectedNode.value = localNode;
   document.forms.searchTreeChooserForm.selectedNodeHandle.value = localId;
   if ( id != '' ) {
      document.forms.searchTreeChooserForm.method.value = 'select';
   }
   else {
      document.forms.searchTreeChooserForm.method.value = 'unSelect';
   }
   this.window.setTimeout(showPleaseWait, 1000);
   document.forms.searchTreeChooserForm.submit();
</c:if>
}

function syncShowInactive() {
<%
	if (ConfigDataProperties.getDimensionDeactivationUIEnabled().booleanValue()) {
%>
   var f = document.forms.searchTreeChooserForm;
   var methodName = f.treeName.value + "_updateCheckbox";
   parent[methodName]("true" == f.showInactive.value);
<%
	}
%>
}

</script>

<%-- Since the links do nothing in readOnly mode, they should not look like links --%>
<c:if test="${readOnly}" >
   <style type="text/css">
      a {cursor:not-allowed;}
      a:link {text-decoration:none; color:black;}
      a:visited {text-decoration:none; color:black;}
   </style>
</c:if>

<div id="content" style="padding:0px;">

<html:form action="/SearchTreeChooser">

   <html:hidden property="method"/>
   
   <input type="hidden" name="selectedNodeHandle" value='<%= StringUtil.escapeHTML(request.getParameter("selectedNodeHandle")) %>' />

   <html:hidden property="maxItems"/>
   <html:hidden property="selectMethod"/>
   <html:hidden property="dimensionNodeClassName"/>
   <html:hidden property="treeName"/>

   <html:hidden property="nextIndex"/>
   <html:hidden property="prevIndex"/>

   <html:hidden property="currentNode"/>
   <html:hidden property="selectedNode"/>
   <html:hidden property="showRoot"/>
   
   <html:hidden property="showDescendantsOfConstrainedObjects"/>
   <html:hidden property="showInactive"/>

   <html:hidden property="secureObjectClass"/>
   <html:hidden property="secureAction"/>
   <html:hidden property="constrain"/>
   <html:hidden property="previouslySelectedNodes"/>
   <html:hidden property="parentArea"/>
   <html:hidden property="feature"/>

   <html:hidden property="leafOnly"/>
   <html:hidden property="nonLeafOnly"/>
   <html:hidden property="readOnly"/>
   <html:hidden property="selectable"/>

   <%-- ***************** Expanded folders ****************** --%>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
<td align="<%= layoutDirection.getLeft() %>" valign="top">
   <c:if test="${(empty currentNode.children) and (empty nodeList)}">
   	<p><fmt:message key="displayTable.empty.fmt.txt"/></p>
   </c:if>

   <c:forEach var="node" varStatus="status" items="${nodeList}" >
      <c:set var="depth" value="${status.count}" />
      
      <div style="padding-<%= layoutDirection.getLeft() %>: <c:out value='${(depth - 1) * 25}px' />">

         <div style="padding-<%= layoutDirection.getLeft() %>: 5em; text-indent: -5em;">
      
      <%
         SubtreeCodec node = (SubtreeCodec)pageContext.getAttribute("node");
         String id = ParsingUtils.escape(node.getId());
         String path = ParsingUtils.escape(node.getAbsolutePath());
         String localizedPath = ParsingUtils.escape(node.getLocalizedPath(psession));
         String name = ParsingUtils.escape(node.getName());
         String localizedName = HTMLUtils.escapeHTML(node.getNodeSBO().getNameWithStatus(request.getLocale()));
      %>

      <a name="<%= localizedName %>" />

      <c:if test="${!node.leaf}">
         <%-- COLLAPSE button and non-leaf icon --%>
           <a href="#" onclick="submitToAction('collapse','<%= path %>');return false;" >
            <img src="<fmt:message key='application.collapse.image' />" 
            <c:if test="${(!readOnly) && selectable}" >                   
                 alt="<fmt:message key='application.collapse.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
            </c:if>
                 border="0" /></a>

         <%-- Non-leaf node SELECT link --%>
         <c:if test="${selectable && node.selectable && !leafOnly}">
            <c:if test="${ !(selectedNode == node) }">            
               <a href="#" onclick="select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '<%= id %>', '<%= name %>', '<%= path %>', '<%= localizedPath %>');return false;" >
                  <img src="<fmt:message key='application.unselectedcheckbox.image' />" 
                  <c:if test="${(!readOnly) && selectable}" >                  
                       alt="<fmt:message key='application.unselectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
                  </c:if>                  
                       border="0" /></a>
            </c:if>

            <c:if test="${selectedNode == node}">            
               <a id="selectedCheckboxLink" href="javascript:select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '', '', '')" >
                  <img src="<fmt:message key='application.selectedcheckbox.image' />" 
                  <c:if test="${(!readOnly) && selectable}" >                  
                       alt="<fmt:message key='application.selectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
                  </c:if>                  
                       border="0" /></a>
            </c:if>
         </c:if>
      </c:if>

      <c:if test="${node.leaf}">

         <%-- No collapse button and leaf icon --%>
          <a href="#" onclick="submitToAction('collapse','<%= path %>');return false;"  >
            <img src="<fmt:message key='application.noexpand.image' />" 
                 alt="<fmt:message key='application.noexpand.txt' />"
                 border="0" /></a>

         <%-- Leaf node SELECT link --%>
         <c:if test="${selectable && node.selectable && !nonLeafOnly}">
            <c:if test="${ !(selectedNode == node) }">            
            <a href="#" onclick="select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '<%= id %>', '<%= name %>', '<%= path %>', '<%= localizedPath %>');return false;" >
                  <img src="<fmt:message key='application.unselectedcheckbox.image' />" 
                  <c:if test="${(!readOnly) && selectable}" >
                       alt="<fmt:message key='application.unselectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
                  </c:if>
                     border="0" /></a>
            </c:if>
	
	        <c:if test="${selectedNode == node}">            
	           <a id="selectedCheckboxLink" href="javascript:select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '', '', '')" >
	              <img src="<fmt:message key='application.selectedcheckbox.image' />" 
	              <c:if test="${(!readOnly) && selectable}" >
	                   alt="<fmt:message key='application.selectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
	              </c:if>
	                   border="0" /></a>
	        </c:if>
	     </c:if>
         <c:if test="${!selectable}">
            <img src="<fmt:message key='application.noexpand.image' />" 
                 alt="<fmt:message key='application.noexpand.txt' />" />
         </c:if>
      </c:if>

         <span alt="<c:out value='${node.description}'/>" id="<%= StringUtil.escapeHTML(node.getId()) %>"
   	      title="<c:out value='${node.description}'/>"><%= localizedName %></span>
         </div>
         
      </div>
   </c:forEach>

   <%-- ****************** Tree nodes *******************--%>

   <c:forEach var="child" items="${currentNode.children}" >
      <div style="padding-<%= layoutDirection.getLeft() %>: <c:out value='${(depth) * 25}px' />">

         <div style="padding-<%= layoutDirection.getLeft() %>: 5em; text-indent: -5em;">

      <%
         SubtreeCodec child = (SubtreeCodec)pageContext.getAttribute("child"); 
         String id = ParsingUtils.escape(child.getId());
         String path = ParsingUtils.escape(child.getAbsolutePath());
         String localizedPath = ParsingUtils.escape(child.getLocalizedPath(psession));
         String name = ParsingUtils.escape(child.getName());  
         String localizedName = HTMLUtils.escapeHTML(child.getNodeSBO().getNameWithStatus(request.getLocale()));
      %>

      <c:if test="${!child.leaf}">
         <%-- EXPAND button and non-leaf icon --%>
         <a href="#" onclick="submitToAction('expand','<%= path %>');return false;" >
            <img src="<fmt:message key='application.expand.image' />" 
            <c:if test="${(!readOnly) && selectable}" >                  
                 alt="<fmt:message key='application.expand.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
            </c:if> 
                 border="0" /></a>
      </c:if>

      <c:if test="${child.leaf}">
         <%-- No expand button and leaf icon --%>
         <img src="<fmt:message key='application.noexpand.image' />" 
              alt="<fmt:message key='application.noexpand.txt' />" 
              border="0" />
      </c:if>


      <%-- Non-leaf node SELECT link --%>
    <c:if test="${selectable && child.selectable && !((child.leaf && nonLeafOnly) || (!child.leaf && leafOnly))}">
      <c:if test="${ !(selectedNode == child) }">
        <a href="#" onclick="select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '<%= id %>','<%= name %>', '<%= path %>', '<%= localizedPath %>');return false;">
            <img src="<fmt:message key='application.unselectedcheckbox.image' />" 
            <c:if test="${(!readOnly) && selectable}" >
                 alt="<fmt:message key='application.unselectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
            </c:if> 
                 border="0" /></a>
      </c:if>

      <c:if test="${selectedNode == child}">
         <a id="selectedCheckboxLink" href="javascript:select('<c:out value="${searchTreeChooserForm.selectMethod}" />', '','', '')">
            <img src="<fmt:message key='application.selectedcheckbox.image' />"
            <c:if test="${(!readOnly) && selectable}" > 
                 alt="<fmt:message key='application.selectedcheckbox.fmt.txt'><fmt:param value='<%= localizedName %>' /></fmt:message>"
            </c:if> 
                 border="0" /></a>
      </c:if>
    </c:if>
    
      <span alt="<c:out value='${child.description}'/>" id="<%= StringUtil.escapeHTML(child.getId()) %>"
	      title="<c:out value='${child.description}'/>"><%= localizedName %></span>
      </div>
      
   </div>
   </c:forEach>
   
</td>
   <%-- ***************** Next, Show Selected, and Prev links ****************** --%>
<td align="<%= layoutDirection.getRight() %>" valign="top" width="15">
   <div style="text-align:<%= layoutDirection.getRight() %>;width:100%;">
      <c:choose>
         <c:when test="${!empty searchTreeChooserForm.prevIndex}" >
            <a href="javascript:submitToAction('pagePrev',document.forms.searchTreeChooserForm.currentNode.value)" >
                <fmt:message key='prev.txt' />&nbsp;|&nbsp;
            </a>
         </c:when>
      </c:choose>
      <c:if test="${selectable}">
	      <c:if test="${ (!empty searchTreeChooserForm.selectedNode) and !readOnly }">
	         <a href="javascript:submitToAction('showSelected',document.forms.searchTreeChooserForm.currentNode.value)" />
	         <img border="0" src="<fmt:message key='application.showselected.image'/>"
	         	  alt="<fmt:message key='showSelected.txt'/>"
	         	  title="<fmt:message key='showSelected.txt'/>"/></a>
	      </c:if>
      </c:if>
   </div>
</td>
</tr>
</table>
      <c:choose>
         <c:when test="${!empty pageNextParams}" >
            <a href="javascript:submitToAction('pageNext',document.forms.searchTreeChooserForm.currentNode.value)" >
            &nbsp;|&nbsp;<fmt:message key='next.txt' />
            </a>
         </c:when>
      </c:choose>

</html:form>

</div>

</body>
</mon:html>