<%@ page import="com.sas.solutions.cpb.runtime.*" %><%@ 
    page import="com.sas.solutions.cpb.web.tag.field.*" %><%@ 
    page import="com.sas.solutions.cpb.screendefs.*" %><%@ 
    page import="com.sas.oprisk.monitor.web.cpb.runtime.*" %><%@ 
    page import="com.sas.oprisk.monitor.web.cpb.runtime.component.*" %><%@
    page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext" %><%@
    page import="com.sas.oprisk.framework.server.objects.Do" %><%@ 
    page import="com.sas.oprisk.server.util.*" %><%@ 
    page import="java.util.*" %><%@ 
    page import="com.sas.solutions.cpb.util.*" %><%@ 
    page import="com.sas.solutions.cpb.web.util.*" %><%@ 
    page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="org.apache.commons.lang.StringUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>
<mon:setBundle />

<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final MonitorUIContext uiContext = (MonitorUIContext)RequestUtil.getUIContext(request);
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);  
   
   final Field field = componentInfo.getField();
   final String fieldName = field.getName();
   final AbstractCurrencyComponent cc =  
      (AbstractCurrencyComponent)componentInfo.getComponent();
   final Locale locale = uiContext.getLocale();

   String amtFieldName = cc.getAmountFieldName(field, uiContext);
   String baseAmtFieldName = cc.getBaseAmountFieldName(field, uiContext);
   String currencyCdFieldName = cc.getCurrencyCdFieldName(field, uiContext);
   String convDtFieldName = cc.getConversionDtFieldName(field, uiContext);
   
   // TODO: what about ClassCastException?
   String currencyCd = StringUtils.trimToEmpty((String)uiContext.getValue(currencyCdFieldName));
   //Date convDt = (Date)uiContext.getValue(convDtFieldName);

   String amt = uiContext.getLastRequestValue(amtFieldName);
   if (amt == null) {
      amt = AbstractCurrencyComponent.getFormattedCurrencyAmount(amtFieldName, uiContext, currencyCd);
   }
   String baseAmt = uiContext.getLastRequestValue(baseAmtFieldName);
   
   if (baseAmt == null) {
      baseAmt =  AbstractCurrencyComponent.getFormattedCurrencyAmount(baseAmtFieldName, uiContext, currencyCd);
   }

   String amtLabel = FieldUtil.getLabel(field, amtFieldName, uiContext, true);
   String baseCurrCd = CurrencyUtils.getBaseCurrencyCode(psession);
   String baseCurrInd = " (" + baseCurrCd + ")";
   
   String baseAmtLabel = amtLabel.endsWith(":")
      ? amtLabel.substring(0, amtLabel.length()-1) + baseCurrInd + ":"
      : amtLabel + baseCurrInd;
      
   String encAmtFieldName = amtFieldName == null ? "" : amtFieldName.replace('.', '_');
   String convertFuncName = "convertAmountToBase_" + encAmtFieldName;
   String onchangeFuncName = "valueChanged_" + encAmtFieldName;
   
   boolean confidential = uiContext.isFieldConfidential(field);
%>

<mon:include js="/dwr/interface/CommonService.js" />
<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />

<script type="text/javascript">

// This function is called whenever one of the currency values changes.
function <%= onchangeFuncName %>() {
   <%-- 
        If base is editable, no auto-conversion is done, so we immediately
        signal a change occurred (for CPB's sake).  If base is NOT editable,
        an autoconversion is triggered, which will then signal a change
        occurred when it returns.
   --%>
   <% if (cc.isAllowEditOfBaseAmount(field, uiContext)) { %> 
      <c:if test="${componentInfo.field.hasOnChangeActions}">
         cpb.fieldValueChanged("<c:out value='${componentInfo.field.name}' />"); 
      </c:if>
   <% } else { // auto convert only for non-editing mode %>
      <%= convertFuncName %>();
   <% } %>
}

// this function will convert amt to baseAmt if amt is not null and baseAmt is null
// or convert baseAmt to Amt is baseAmt is not null and amt is null
function <%= convertFuncName %>() {

   var f = document.forms['<%= componentInfo.getFormName() %>'];
   <% if (!cc.isAllowEditOfBaseAmount(field, uiContext)) { %>

      // for non editing mode, always convert from original amount to base amount. 
      f['<%= baseAmtFieldName %>'].value = ""; 
   <% } else { %>
         // check whether they are null or both not empty
         
        var aValue = f['<%=amtFieldName %>'].value + 0;
        var bValue = f['<%= baseAmtFieldName %>'].value + 0;
        if(aValue == 0 && bValue == 0) {
            alert("<fmt:message key="application.convert.valueRequired.txt"/>"); 
            return;
        }
        if(aValue != 0 && bValue != 0) {
            alert("<fmt:message key="application.convert.bothExist.txt"/>"); 
            return;
        }
         
   <% } %>
<%
   Date dateFromUICtx = (Date)uiContext.getValue(convDtFieldName);
   String dateFromUICtxStr = dateFromUICtx == null ? "" : DateTimeUtils.formatShortDate(dateFromUICtx, locale);
%>
   
   var dateFromUIContext = '<%= dateFromUICtxStr %>';
   
   var currQuad = {
      amt: f['<%= amtFieldName %>'].value,
      baseAmt: f['<%= baseAmtFieldName %>'].value,
      currCd: f['<%= currencyCdFieldName %>'].value,
      dt: (f['<%= convDtFieldName %>'] == undefined) 
          ? dateFromUIContext : f['<%= convDtFieldName %>'].value
   };
//      dt: f['<%= convDtFieldName %>'].value
   
   CommonService.twoWayConvertCurrency(
      currQuad, 
      function(newCurrQuad) {
         // update the value of the base amt field
         
         <%    if (!cc.isAllowEditOfBaseAmount(field, uiContext)) { %>
            elementById('<%= baseAmtFieldName %>_span').innerHTML = newCurrQuad.baseAmt;
         <% } else { %>
            f['<%= baseAmtFieldName %>'].value  = newCurrQuad.baseAmt;
            f['<%= amtFieldName %>'].value      = newCurrQuad.amt;
         <% } %>
         <%-- signal a change occurred when we return from autoconversion --%>
         <c:if test="${componentInfo.field.hasOnChangeActions}">
            cpb.fieldValueChanged("<c:out value='${componentInfo.field.name}' />"); // signal a change occurred
         </c:if>
      }
   );   
}

</script>

<%-- the ScreenTag already output the leading <tr><td> --%>

<span class="fieldind">
<%
   HTMLUtil.writeFieldIndicators(
      fieldName,
      componentInfo.isRequired(),
      confidential,
      RequestUtil.isFieldValueInvalid(amtFieldName, pageContext), 
      locale, out);
%></span>
</td>

<th class="fieldlabel"><%= amtLabel %></th>
   <td class="field">
<% if (componentInfo.isReadOnly()) { %>
      <%= StringUtil.escapeHTML(ParsingUtils.format(amt)) %>&nbsp;<%= StringUtil.escapeHTML(currencyCd) %>
<% } else { %>
      <input type="text" name="<%= amtFieldName %>" value="<%= StringUtil.escapeHTML(ParsingUtils.format(amt)) %>" 
          onchange="<%= onchangeFuncName %>()" />&nbsp;<%
      AbstractCurrencyComponent.writeCurrencyCdSelect(
         currencyCdFieldName, currencyCd, !componentInfo.isEnabled(), pageContext, psession);
      if (cc.isAllowEditOfBaseAmount(field, uiContext)) {    
%>
      <input type="button" value="<fmt:message key='application.convert.txt' />" onclick="<%= convertFuncName %>()"/>
      <span class="instructions">&nbsp;&nbsp;
                        <fmt:message key="application.convert.directions.txt"/>
                    </span>
<%    } %>
   <script type="text/javascript">document.forms['<%= componentInfo.getFormName() %>']['<%= currencyCdFieldName %>'].onchange = <%= onchangeFuncName %>;</script>
<% } %>
   </td>
</tr>

<tr id="<%= fieldName + "_baseAmt" %>">
   <td class="fieldind"><%
   HTMLUtil.writeFieldIndicators(
      baseAmtFieldName,
      cc.isAllowEditOfBaseAmount(field, uiContext) && componentInfo.isRequired(),
      confidential,
      RequestUtil.isFieldValueInvalid(baseAmtFieldName, pageContext), 
      locale, out);
%></td>
   <th class="fieldlabel"><%= baseAmtLabel %></th>
   <td class="field">
<%
   if (componentInfo.isReadOnly() || !cc.isAllowEditOfBaseAmount(field, uiContext)) {
%>
         <span id="<%= baseAmtFieldName %>_span"><%= StringUtil.escapeHTML(ParsingUtils.format(baseAmt)) %></span>
         <input type="hidden" name= "<%= baseAmtFieldName %>" value="<%= StringUtil.escapeHTML(ParsingUtils.format(baseAmt)) %>"/>
<%  } else { %>
      <input type="text" id="<%= baseAmtFieldName %>" name= "<%= baseAmtFieldName %>" 
             value="<%= StringUtil.escapeHTML(ParsingUtils.format(baseAmt)) %>" onchange="<%= onchangeFuncName %>()" />
<%} %> 

   
<%-- the ScreenTag will output the trailing </td></tr> --%>