<%-- MENU: Business Structure > Dimension[Control Type] > Go > Control Type[any] > Edit

Testing requires that a screen definition file such as Control.xml be modified and reloaded.
E.g., change:

   <field name="ControlAssertions" type="checkbox" required="false"
          values="getControlTypeAssertions()">
       <label><message key="control.assertions.txt" /></label>
   </field>

to:

   <field name="ControlAssertions" type="component"
          component-name="DualListSelector" values="getControlTypeAssertions()">
       <label><message key="control.assertions.txt" /></label>
   </field>
   
 --%>
<%@page import="java.util.*" %>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.runtime.UIDefinitionType"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.solutions.cpb.web.util.*"%>
<%@page import="com.sas.solutions.cpb.screendefs.Field"%>
<%@page import="com.sas.solutions.cpb.expr.Expression"%>
<%@page import="org.apache.struts.util.LabelValueBean"%>
<%@page import="com.sas.solutions.cpb.web.util.HTMLUtil"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.ChoiceFieldUtil"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.DualListSelectorModel"%>
<%@include file="/tiles/taglibs.jsp" %>
<mon:setBundle />
<%
   final ComponentFieldRenderer.ComponentInfo componentInfo = ComponentFieldRenderer.getComponentInfo(request);
   final Field field = componentInfo.getField();
   final String safeFieldName = HTMLUtil.getSafeFieldName(field.getName());
   final boolean isReadOnly = componentInfo.isReadOnly();
   final UIContext uiContext = RequestUtil.getUIContext(request);
   final Object selectedValuesObj = uiContext.getValue(field);
   final Set selectedValuesSet = DualListSelectorModel.getSelectedValuesAsSet(selectedValuesObj);

   final String context  = request.getContextPath();
   final int rows = Math.max(field.getRows(), 5);
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
   
   String dualListSelectorId =
      "DualListSelector_" +
      componentInfo.getFormName() + '_' +
      safeFieldName;
   
   Expression expr = field.getValues();
   List labelValues;
   if (expr == null)
   {
      final Locale locale = request.getLocale();
      labelValues = ChoiceFieldUtil.getDefaultChoices(field, uiContext, locale);
      if (labelValues == null)
         labelValues = new ArrayList();
   }
   else
      labelValues = (List)expr.evaluate(uiContext);
   
   float lineHeight = 1.25f;
%>
<script type="text/javascript">
var DUAL_LIST_SELECT
function dualListSelector_<%= safeFieldName %>() {
   var form = document.forms['<%= componentInfo.getFormName() %>'];
   var url = '<%=context%>/DualListSelector.do'
      + '?<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>=' + form['<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>'].value
      + '&<%= CPBWebConstants.PARAM_SCREEN_ID %>='     + form['<%= CPBWebConstants.PARAM_SCREEN_ID %>'].value
      + '&<%= CPBWebConstants.PARAM_FIELD_NAME %>=<%= field.getName() %>'
      + '&dualListSelectorId=<%= dualListSelectorId %>'
      + '&safeFieldName=<%= safeFieldName %>';
   openModal(url, "_blank", "width=750,height=500,scrollbars,resizable");
}
</script>
<div width="100%">
   <div id="<%= dualListSelectorId %>" style="width:<%= isReadOnly ? 35 : 30 %>em;height:<%= rows * lineHeight %>em;overflow:auto;border:2px inset white;padding:0 2px;float:<%=layoutDirection.getLeft()%>">
<%
   for (int i = 0; i < labelValues.size(); i++)
   {
      LabelValueBean lv = (LabelValueBean)labelValues.get(i);
      if ((selectedValuesSet != null) && selectedValuesSet.contains(lv.getValue()))
      {
%>
         <div style="white-space: nowrap; line-height: <%=lineHeight%>em"><%= StringUtil.escapeHTML(lv.getLabel())%></div>
         <input type="hidden" name="<%= safeFieldName %>" value="<%=HTMLUtil.escapeHTML(lv.getValue())%>" />
<%
      }
   }
%>
   </div>
<%
   if (!isReadOnly)
   {
%>
      <div style="padding-<%=layoutDirection.getLeft()%>:2em;white-space:nowrap;float:<%=layoutDirection.getLeft()%>">
      <% if (selectedValuesSet != null || labelValues.size() > 0) { %>
      <a href="javascript:dualListSelector_<%= safeFieldName %>();">
      <% } else { %>
      <div style="opacity:0.5;-ms-filter:'alpha (opacity=50)';filter:alpha (opacity=50);float:<%=layoutDirection.getLeft()%>">
      <% } %>
         <img border="0" src="<fmt:message key='application.edit.image'/>"/>
         <fmt:message key='application.button.edit.txt' />
      <% if (selectedValuesSet != null) { %>
      </a>
      <% } else { %>
      </div>
      <% } %>
      </div>
<%
   }
%>
   <div style="clear:both"></div>
</div>
