<%@ page import="java.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
%>

<c:set var="template" >
   <%="true".equals(request.getParameter("popup")) ? "popup" : "details"%>
</c:set>

<mon:Page template="${template}">
   <mon:Head>
      
   </mon:Head>
   <mon:Body>        
         <c:if test="${template != 'popup'}">
            <mon:ToolBar>
               <mon:Button name="ok" onclick="breadcrumb()">
                  <fmt:message key='application.ok.txt' />
               </mon:Button>            
            </mon:ToolBar>
         </c:if>
         
         <mon:Content>
            <table>
               <tr>
                  <th class="fieldlabel" style="white-space: nowrap;">
                     <fmt:message key="role.displayName.txt" />:
                  </th>
                  <td class="field">
                     <c:out value="${role}" />
                  </td>
               </tr>
               <tr>
                  <th class="fieldlabel" style="white-space: nowrap;">
                     <fmt:message key="ora.location.txt" />:
                  </th>
                  <td class="field">
                     <c:out value="${area}" escapeXml="false" />
                  </td>
               </tr>
            </table>

            <mon:table width="100%" class="displayTable" cellspacing="0" name="assessors" id="assessor">
               <mon:title><fmt:message key="Assessments.questionnaires.assessors.txt"/></mon:title>
            
               <display:column title='<%= bundle.getString("user.displayName.txt") %>'>
            <%
               final User user = (User)assessor;
               out.print(StringUtil.escapeHTML(user.toString(locale, psession)));
            %> 
               </display:column>
            </mon:table>
         </mon:Content> 
         
         <c:if test="${template == 'popup'}">
            <mon:PopupButtonBar>
               <mon:Button name="ok" onclick="window.close()">
                  <fmt:message key='application.ok.txt' />
               </mon:Button>            
            </mon:PopupButtonBar>
         </c:if>      
   </mon:Body>
</mon:Page>