<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.base.MonitorRequestUtils" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.server.base.RiskExSourceCd" %>
<%@ page import="com.sas.oprisk.server.RiskInstanceEx" %>
<%@ page import="com.sas.oprisk.server.logical.DimensionalArea"%>
<%@ page import="org.apache.commons.lang.StringUtils"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.*"%>
<%@ page import="com.sas.oprisk.monitor.web.table.QueryParameters"%>
<%@ page import="com.sas.oprisk.server.util.OraUtils"%>

<%@page import="com.sas.oprisk.monitor.web.ora.actions.OraAction"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.DimensionalLocationComponent"%><mon:setBundle />

<%    
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";

   String curUser = request.getParameter("currentSelectedExpertUser");
       
   final String action = "/" + MonitorRequestUtils.getParameterOrAttribute("qAction", request);
   
   final String asblTypeCd = StringUtil.makeValidJSIdentifier(ParsingUtils.format(request.getParameter("assessableTypeCd")));

   // get query parameters, see if we are selecting risks (vs. controls)
   final QueryParameters qparms = (QueryParameters) request.getAttribute("TCQueryParameters");
   final boolean selectingRisks = "com.sas.oprisk.server.RiskInstanceEx".equals(qparms.getClassName());

   boolean invalidLocation = false;
   
   // retrieve the assessment area
   DimensionalArea asmtArea = null;
   boolean canCreateRisks = false;
   boolean isAsmtTemplate = false;
   Map objAreas = null;
   final String asmtHandleStr = StringUtils.isEmpty(request.getParameter("asmtHandle")) 
      ? request.getParameter("asmtTemplateHandle") : request.getParameter("asmtHandle");
   if (!StringUtils.isEmpty(asmtHandleStr) && selectingRisks) {   // only care about this for risks
      final Assessment asmt = AssessmentAction.getAssessment(asmtHandleStr, request, psession);
      if (asmt != null) {
         asmtArea = OraAction.getDimensionalArea(request.getParameter("location"), request);
         canCreateRisks = RiskInstance.object.can(Do.CREATE, asmtArea, psession);   // check for create permission
         isAsmtTemplate = Boolean.TRUE.equals(asmt.getTemplateFlg());   // from template wizard?
         
         List objects = qparms.getObjectList();
         objAreas = AreaMappedObjectUtils.bulkFetchLocation(objects, psession);  // bulk fetch ORAs
      }
   }
%>

<mon:Page template="popup">
   <mon:Head>
      
   </mon:Head>
   <mon:Body>      
      <html:form action="<%= action %>">               
         
         <mon:Content>
            <c:if test="${not invalidAsmtArea}">

            <mon:include js="/script/checkboxRadioUtil.js" />
               
            <script type="text/javascript">
            
            function doAddSelections(bClose) {
               var selections = addAndContinue();
               if (selections == null) {
                  alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
               } else {
                  window.opener.add<%= asblTypeCd %>Assessables(selections, document.forms[0].currentSelectedExpertUser.value);
                  if (bClose) { window.close(); }
               }
            }
            
            function addAndContinue() {
               var values = getSelectedCheckboxValues(document.forms[0], "asblHandle");
               return (values.length == 0) ? null : values;
            }
            
            function createNewFrom(handle, riskName) {
               var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "Assessment.createRiskCopy.confirm.message.fmt.txt")) %>");
               msg = formatMessage(msg, unescape(riskName));
               if (confirm(msg)) {
                  window.opener.add<%= asblTypeCd %>Assessables(new Array(handle), document.forms[0].currentSelectedExpertUser.value, true);
               }
            }
            
            function viewRiskInstance(iHandle) {
               viewInstance("RiskInstance", iHandle);
            }
            
            function viewControlInstance(iHandle) {
               viewInstance("ControlInstance", iHandle);
            }
            
            function viewCauseInstance(iHandle) {
               viewInstance("CauseInstance", iHandle);
            }
            
            function viewInstance(forward, iHandle) {
               var url ="<%= request.getContextPath() %>" 
                  + "/" + forward + ".do?method=select"
                  + "&popup=true"
                  + "&readOnly=true"
                  + "&handle=" + iHandle;
               openModal(url, "viewer",
                  "width=800,height=600,resizable=yes,status=yes,scrollbars=yes");
            }
            
            function popupCloser_refresh() {
               // do nothing
            }
            
            </script>
            
            <input type="hidden" name="qAction" value="<c:out value='${param.qAction}' />" />
            <c:if test="${not empty param.asmtHandle}">
               <input type="hidden" name="asmtHandle" value="<c:out value='${param.asmtHandle}' />" />
            </c:if>
            <c:if test="${not empty param.asmtTemplateHandle}">
               <input type="hidden" name="asmtTemplateHandle" value="<c:out value='${param.asmtTemplateHandle}' />" />
            </c:if>
            <c:if test="${not empty param.location}">
               <input type="hidden" name="location" value="<c:out value='${param.location}' />" />
            </c:if>
            <c:if test="${param.assessors == null}">
               <input type="hidden" name="currentSelectedExpertUser" />
            </c:if>
            <c:if test="${param.assessors != null}">
               <input type="hidden" name="assessors" value="<c:out value='${param.assessors}' />" />
               <input type="hidden" name="assessableTypeCd" value="<%= asblTypeCd %>" />
               <fmt:message key="AssessmentWizard.scoping.section.assessor.txt" />:
              
            <% 
               final List expertUserBeans = (List) request.getAttribute("expertUsers");
            %>
               <select name="currentSelectedExpertUser">
            <%
               out.print("<option value=''>" +  bundle.getString("application.noDefaultDropDownSelection.txt") + "</option>"  );
               if (expertUserBeans!=null){ 
                  for (final Iterator ei = expertUserBeans.iterator(); ei.hasNext(); ) {
                     final org.apache.struts.util.LabelValueBean eub = 
                        (org.apache.struts.util.LabelValueBean) ei.next();
                     out.print("<option value='" + StringUtil.escapeHTML(eub.getValue()) + "'");
                     if (eub.getValue().equals(curUser)) {
                        out.print(" selected");
                     } 
                     out.print(">");
                     out.print(StringUtil.escapeHTML(eub.getLabel()) + "</option>");
                  }
               }
            %>      
               </select>
               
               <p/>   
            </c:if>
                
            <%
              boolean hasChecks = false;
            %>
            
            <mon:tableComponent id="assessable">
            <%
               boolean selectAllowed = true;
               String escName = null;
               if (selectingRisks) { 
            %>
               <mon:filter>
                  <span class="infoMessage"><img align="absmiddle" src="<%= request.getContextPath() %>/images/MessageInform_16.gif">
                  <% if (isAsmtTemplate) { %>
                     <fmt:message key="AssessmentTemplate.canSelectRisksWithin.txt"/>         
                  <% } else { %>
                     <fmt:message key="Assessment.canSelectRisksWithin.txt"/>         
                  <% } %>
                  </span><br /><br />
               </mon:filter>
            <%
                  final RiskInstanceEx ri = (RiskInstanceEx)pageContext.findAttribute("assessable");
            
                  if (ri != null && objAreas != null) {
                     // double escape because it will be used in an href
                     escName = ParsingUtils.escape(ParsingUtils.escape(ri.getRiskNm()));
                     
                     final DimensionalArea riArea = (DimensionalArea)objAreas.get(ri.getRiskRk());
                     selectAllowed = riArea != null && 
                        OraUtils.isRiskAreaWithinAssessmentArea(riArea, asmtArea, psession);
                  }
               }
            %>
                <mon:fixedColumn width="10" title="<%= selColTitle %>">
            <%
               if (selectAllowed) {
                  hasChecks = true;
            %>
                   <input type="checkbox" name="asblHandle" value="<c:out value="${assessable.taggedPointerHandle}" />" />
            <% } %>
                </mon:fixedColumn>
            <% if (selectingRisks && canCreateRisks) { %>
                <mon:fixedColumn title='<%= bundle.getString("Assessment.createRiskCopy.txt") %>' 
                  before="false" cssClass="centered" width="10%">
                     &nbsp;<a href="javascript:createNewFrom('<c:out value="${assessable.taggedPointerHandle}" />', '<%= escName %>')"
                        ><img border="0"
                            src="<%= request.getContextPath() %>/<fmt:message key='application.createNewFrom.image'/>" 
                           alt="<fmt:message key='Assessment.createRiskCopy.txt'/>"
                           title="<fmt:message key='Assessment.createRiskCopy.txt'/>"
                     /></a>&nbsp;
                </mon:fixedColumn>
            <% } %>
            </mon:tableComponent>
            
            <script type="text/javascript">
               new CheckboxGroup("queryForm", "asblHandle", "selectAll");
            <% if (!hasChecks) { %>
               document.forms.queryForm.selectAll.style.display = "none";
            <% } %>
            </script>              
            </c:if>
         </mon:Content>   
         
         <mon:PopupButtonBar>
            <c:if test="${not invalidAsmtArea}">                                                    
               <mon:Button name="add" onclick="doAddSelections(false)">
                  <fmt:message key='application.button.add.txt' />
               </mon:Button>
               <mon:Button name="addAndClose" onclick="doAddSelections(true)">
                  <fmt:message key='application.button.addAndClose.txt' />
               </mon:Button>
            </c:if>
            
            <mon:Button name="close" onclick="window.close()">
                     <fmt:message key='closeButton.txt' />
                  </mon:Button>
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>
