<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>

<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final MonitorContext monitorContext = MonitorContext.getMonitorContext(request);
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">
      <%@ include file="questionnairesScript.jspf" %>
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/Assessments?method=open">      
         <mon:ToolBar>
            <mon:Button name="okButton" onclick="breadcrumb('assessmentsForm', 2)">
               <fmt:message key='application.ok.txt' />
            </mon:Button>                        
         </mon:ToolBar>
         
         <mon:Content>
            <html:hidden property="handle" />
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="answerSheets" id="entry">
            <%
               AssessmentAnswerSheet answerSheet = (AssessmentAnswerSheet)pageContext.findAttribute("entry");
               if(answerSheet != null) {
               DimensionalArea location = answerSheet.getLocation(psession);
               AnswerSheetStatus answerSheetStatus = answerSheet.getAnswerSheetStatus(psession);
               
               RoleHandle roleHandle = answerSheet.getRoleHandle();
               String roleHandleStr = (roleHandle == null) ? "" : roleHandle.toString();
               Role role = answerSheet.getRole(psession);
               String roleName = (role == null) ? "" : role.getRoleNm();   
            %>
               <mon:title><fmt:message key="AssessmentWizard.step.questionnaires.txt"/></mon:title>   
              
               <display:column width="1%">
                  &nbsp;<a href="#" onclick="return showContextMenu('<%=answerSheet.getHandleString()%>', '<%= answerSheetStatus.value %>', '<%= roleHandleStr %>', '<%= location.getHandleString() %>')"
                     ><img border="0" 
                         src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     /></a>&nbsp;</display:column>
                     
               <display:column title='<%= bundle.getString("application.id.txt") %>'>
                  <a href="javascript:viewQuestionnaire('<%=answerSheet.getHandleString()%>')"
                     ><%= StringUtil.escapeHTML(answerSheet.getAnswerSheetId()) %></a>
               </display:column>
            
               <display:column title='<%= bundle.getString("assessmentAnswerSheet.field.sourceSystemCd.displayName.txt") %>'>
                  <a href="javascript:viewQuestionnaire('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(monitorContext.getSourceSystemDescription(answerSheet.getSourceSystemCd(), locale, psession)) %>
                  </a>
               </display:column>
            
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.role.txt") %>'>
                  <a href="javascript:viewQuestionnaire('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(roleName) %>
                  </a>
               </display:column>
               
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.scope.txt") %>'>
                  <a href="javascript:viewQuestionnaire('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(location.toString(psession)) %>
                  </a>
               </display:column>
               
               <display:column title='<%= bundle.getString("application.status.txt") %>'>
                  <%= bundle.getString(answerSheetStatus.getDisplayNameKey()) %>
               </display:column> 
               
            <% } %>  
            </mon:table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>