/** the class declaration */
InstancesChooserDialog = {};

/**
 * initializes properties of the dialog
 * @param {Object} args an object containing properties
 */
InstancesChooserDialog.initialize = function(args)
{
   for (var key in args)
   {
      InstancesChooserDialog[key] = args[key];
   }
}

InstancesChooserDialog.addHiddenInput = function(form, name, value)
{
   var inputElement = opener.document.createElement("input");
   inputElement.type = "hidden";
   inputElement.name = name;
   inputElement.value = value;
   form.appendChild(inputElement);
}

/**
 * handles when the save button is clicked
 */
InstancesChooserDialog.save = function()
{
   var opener = ModalDialog.getOpener();
   
   if (!opener)
   {
      window.close();
      return;
   }
   
   /*
    * If this dialog was configured with a form and property then dynamically
    * create hidden input fields with the given property name for each selected
    * handle.
    */
   if (InstancesChooserDialog.form && InstancesChooserDialog.property)
   {
      var instancesForm = document.getElementById("queryForm");
      var openerForm = opener.document.forms[InstancesChooserDialog.form];
      var parameters = InstancesChooserDialog.parameters;
      
      if (parameters)
      {
         for (var key in parameters)
         {
            InstancesChooserDialog.addHiddenInput(openerForm, key, parameters[key]);
         }
      }
      
      var checkboxElementList = instancesForm.elements["handleList"];
      
      if (checkboxElementList != null)
      {
         if (checkboxElementList.length === undefined)
         {
            checkboxElementList = [checkboxElementList];
         }
         
         for (var i = 0; i < checkboxElementList.length; i++)
         {
            var checkbox = checkboxElementList[i];
            
            if (checkbox.checked)
            {
               InstancesChooserDialog.addHiddenInput(openerForm,
                  InstancesChooserDialog.property, checkbox.value);
            }
         }
      }
   }

   if (InstancesChooserDialog.onsave)
   {
      ModalDialog.detachFromOpenerUntilReload();
      opener.eval(InstancesChooserDialog.onsave);
   }
}

/**
 * This method closes this dialog cleanly.
 */
InstancesChooserDialog.close = function()
{
   ModalDialog.close();
}