<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.framework.server.objects.BusinessObjectList" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>

<%
   AssessmentWizardModel model = AssessmentWizardModel.getInstance(request);
   boolean readOnly = model.isReadOnly();
   PersistenceSession psession = model.getPersistenceSession();
   Locale locale = request.getLocale();
   MonitorContext monitorContext = MonitorContext.getMonitorContext(request);
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   
   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
   final String USER_POSITION_SEP = "_";
   final String INSTANCE_ROLE_SEP = ",";
%>
<mon:Page template="wizard">

   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      
      <script type="text/javascript">
      var USER_POSITION_SEP = "<%= USER_POSITION_SEP %>";
      var INSTANCE_ROLE_SEP = "<%= INSTANCE_ROLE_SEP %>";
      
      <%@ include file="/tiles/CSA/assessment/questionnairesScript.jspf" %>
      
      function doQnr(method, parameters) {
         if (method == "export") {
            viewUrl("<%= request.getContextPath() %>/Questionnaire.do"
               + "?method=" + method + parameters, window);
         } else {
            forwardToQnr(method, parameters);
         }
      }
      
      function forwardToQnr(method, parameters) {
         var path = "/Questionnaire.do?method=" + method + parameters;
         goWizard("forward&path=" + escape(path), "previous");
      }
      
      /**
       * Respond to user (un)selecting a position; cascade through instance selections.
       */
      function onPositionClick(clickedObj) {
         for (i = 0; i < document.forms.assessmentWizardForm.elements.length; i++) {
            var item = document.forms.assessmentWizardForm.elements[i];
            if ((item.name == "scoredInstances") && (item.type == "checkbox")) {
               var pNode = item.parentNode;
               var keyPair = pNode.id.split(USER_POSITION_SEP);
               if (keyPair[0] == clickedObj.value) {
                  item.checked = clickedObj.checked;
               }
           }
         }
      }
      
      /**
       * Respond to user (un)selecting an instance; propogate to position selection
       */
      function syncPositionSelection(clickedObj) {
         var allSelected = false;
         var clickedKeyPair = clickedObj.parentNode.id.split(USER_POSITION_SEP);
         
         // check to see if at least one is selected.
         for (i = 0; i < document.forms.assessmentWizardForm.elements.length; i++) {
            var item = document.forms.assessmentWizardForm.elements[i];
            if ((item.type == "checkbox") && (item.name == "scoredInstances")) {
               var pNode = item.parentNode;
               var keyPair = pNode.id.split(USER_POSITION_SEP);
               if ((keyPair[0] == clickedKeyPair[0]) && (item.checked)) {
                   allSelected = true;
                   break;
               }
           }
         }
         // propogate to the parent checkbox
         for (i = 0; i < document.forms.assessmentWizardForm.elements.length; i++) {
            var item = document.forms.assessmentWizardForm.elements[i];
            if ((item.type == "checkbox") && (item.name == "positions")) {
               if (item.value == clickedKeyPair[0]) {
                  item.checked = allSelected;
               }
            }
         }
      }
      
      </script>
   
   </mon:Head>
   
   <mon:Body>
      
      <html:form action="/AssessmentWizard">
      
      <mon:ToolBar/>
      
      <mon:Content>
         
         <input type="hidden" name="positions_isSet" value="true" />
         <input type="hidden" name="scoredInstances_isSet" value="true" />
           
         <mon:maintainWizardState/>
              
         <mon:DimAreaChooser 
            property="location"
            excludedDimensions="RiskEventType"
            readOnly="true"
            feature="Assessment"
         />
               
         <br/>
         
         <div class="mainTable">
         
         <table class="tableheader" width="100%" cellspacing="0" cellpadding="0">
            <tr>
               <td class='sectionheadertext'><fmt:message key="AssessmentWizard.step.questionnaires.txt" /></td>
            </tr>
         </table>
         
         <table width="100%" class="displayTable" cellspacing="0" id="answerSheet">
         <%
            String idTitle = bundle.getString("application.id.txt");
            String sourceSystemTitle = bundle.getString("assessmentAnswerSheet.field.sourceSystemCd.displayName.txt");
            String roleTitle = bundle.getString("AssessmentWizard.positions.role.txt");
            String scopeTitle = bundle.getString("AssessmentWizard.positions.scope.txt");
            String statusTitle = bundle.getString("application.status.txt");
         %>
         <thead>
            <tr>
               <th width="16"></th>
               <th abbr="<%= idTitle %>"><%= idTitle %></th>
               <th abbr="<%= sourceSystemTitle %>"><%= sourceSystemTitle %></th>
               <th abbr="<%= roleTitle %>"><%= roleTitle %></th>
               <th abbr="<%= scopeTitle %>"><%= scopeTitle %></th>
               <th abbr="<%= statusTitle %>"><%= statusTitle %></th>
            </tr>
         </thead>
         <tbody>
         <%
            final List answerSheetList = (List) request.getAttribute("answerSheetList");
            
            Iterator iter = answerSheetList.iterator();
            
            while (iter.hasNext())
            {
               AssessmentAnswerSheet answerSheet = (AssessmentAnswerSheet)iter.next();
               DimensionalArea location = answerSheet.getLocation(psession);
               AnswerSheetStatus answerSheetStatus = answerSheet.getAnswerSheetStatus(psession);
               RoleHandle roleHandle = answerSheet.getRoleHandle();
               String roleHandleStr = (roleHandle == null) ? "" : roleHandle.toString();
               Role role = answerSheet.getRole(psession);
               String roleName = (role == null) ? "" : role.getRoleNm();
         %>  
            <tr class="dataRow1_tableRow">
         
               <!-- Icon -->
               <td width="1%">
                   &nbsp;<a href="#" onclick="return showContextMenu('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>', '<%= StringUtil.escapeJSForHTMLAttribute(answerSheetStatus.value) %>', '<%= StringUtil.escapeJSForHTMLAttribute(roleHandleStr) %>', '<%= StringUtil.escapeJSForHTMLAttribute(location.getHandleString()) %>')"
                   ><img border="0" 
                         src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                         alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                         title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     /></a>&nbsp;</td>
                     
                <!-- Id -->   
                <td><a href="javascript:viewQuestionnaire('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>')"><%= StringUtil.escapeHTML(answerSheet.getAnswerSheetId()) %></a></td>
         
                <!-- Source System Code -->
                <td>
                  <a href="javascript:viewQuestionnaire('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>')">
                     <%= StringUtil.escapeHTML(monitorContext.getSourceSystemDescription(answerSheet.getSourceSystemCd(), locale, psession)) %>
                  </a>
                </td>       
               
                <!-- Role -->
                <td>
                  <a href="javascript:viewQuestionnaire('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>')">
                     <%= StringUtil.escapeHTML(roleName) %>
                  </a>
                </td>
         
                <!-- Scope -->
                <td>
                  <a href="javascript:viewQuestionnaire('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>')">
                     <%= StringUtil.escapeHTML(location.toString(psession)) %>
                  </a>
                </td>
                
                <!-- Status -->
                <td>
                  <a href="javascript:viewQuestionnaire('<%= StringUtil.escapeJSForHTMLAttribute(answerSheet.getHandleString()) %>')">
                     <%= StringUtil.escapeHTML(bundle.getString(answerSheetStatus.getDisplayNameKey())) %>
                  </a>
                </td>
            </tr>
         <%
            }
         %>
         </tbody>
         </table>
         
         </div>
      
      </mon:Content>
   
      </html:form>
      
   </mon:Body>
   
</mon:Page>
