<%@ page import="java.util.*"%>
<%@ include file="/tiles/taglibs.jsp"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag"%>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>

<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);	
   
   boolean readOnly = ((Boolean)request.getAttribute("readOnly")).booleanValue();
   boolean isFresh = ((Boolean)request.getAttribute("isFresh")).booleanValue();
   String defaultResponseScale = (String)request.getAttribute("defaultResponseScale");
%>
<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">
      var assessableType = '';
         
      function monitorInit()
      {
         initNSMenu();
      
         <c:if test="${readOnly}" >
            // disable all other form fields and buttons
            for(i = 0; i < document.forms.responseScaleTypeFormEx.elements.length; i++) {
               if ((document.forms.responseScaleTypeFormEx.elements[i].type != "hidden") &&
                  (document.forms.responseScaleTypeFormEx.elements[i].type != "button")) {
                 document.forms.responseScaleTypeFormEx.elements[i].disabled = true;
              }
            }
         </c:if>
      }
      
      function editExpression() {
         var f = document.forms.responseScaleTypeFormEx;
         var expVal = f.computationFn.value;
         var assessableTypeVal = f.assessableTypeCd.value;
         if (assessableTypeVal == '') {   
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString("Measures.EmptyAssessableElement.message.txt")) %>");
            alert(msg);
            return;
         }
         expVal = expVal.replace(/\+/g, "%2B");
         openModal(
            "<%= request.getContextPath()+'/' %>" 
            + "ExpressionEdit.do?handle=" + f.handle.value
            + "&expression=" + expVal
            + "&assessableTypeCd=" + assessableTypeVal
            + "&variableName=" + f.variableName.value, "ExpressionEditor", "width=640,height=600,scrollbars,resizable");
      }
      
      function checkForCalculation() {
         var f = document.forms.responseScaleTypeFormEx;
         var expVal = f.computationFn.value;
         var assessableTypeVal = f.assessableTypeCd.value;
         if (expVal != '') {
          var msg = unescape("<%= ParsingUtils.escape(bundle.getString("Measures.EditAssessableElement.message.txt")) %>");
            alert(msg);
            f.assessableTypeCd.value = assessableType;
            return;
         }
      }
      function getExistingAssessableType() {
         var f = document.forms.responseScaleTypeFormEx;
         assessableType = f.assessableTypeCd.value;
      }
      
      function saveMeasure() {
            document.forms.responseScaleTypeFormEx.submit();
      }
      
      function cancel() {
         breadcrumb();
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/MeasureSave">
         <mon:ToolBar>
            <c:if test="${!readOnly}">
               <mon:Button id="submitButton" onclick="saveMeasure();">
                  <fmt:message key='saveButton.txt' />
               </mon:Button>

               <mon:Button id="cancelButton" onclick="cancel();">
                  <fmt:message key='cancelButton.txt' />
               </mon:Button>
            </c:if>
            <c:if test="${readOnly}">
               <mon:Button onclick="cancel();">
                  <fmt:message key='returnButton.txt' />
               </mon:Button>
            </c:if>
         </mon:ToolBar>

         <mon:Content>
            <html:hidden property="handle" />
            <html:hidden property="responseScaleTypeRk" />
            <html:hidden property="controlTestingFlg" />
            <html:hidden property="soxFlg" />
            
            <table width="100%" border="0">
               <tr id="Measure_activeFlg">
                  <td width="25%"><mon:label key="measureEx.field.activeFlg.displayName.txt" property="activeFlg" /></td>
                  <td>
                     <fieldset class="screen-reader-only"><legend><mon:label key="measureEx.field.activeFlg.displayName.txt" property="activeFlg" /></legend>
                        <html:radio property="activeFlg" value="true">
                           <fmt:message key="yesno.yes.txt" />
                        </html:radio>
                        <html:radio property="activeFlg" value="false">
                           <fmt:message key="yesno.no.txt" />
                        </html:radio>
                     </fieldset>
                  </td>
               </tr>

               <tr id="Measure_responseScaleTypeId">
                  <td><mon:label separatorVisible="true" key="responseScaleType.field.responseScaleTypeId.displayName.txt" property="responseScaleTypeId" /></td>
                  <td><mon:text property="responseScaleTypeId" style="width:40%" maxlength="25" /></td>
               </tr>

               <tr id="Measure_sourceSystemCd">
                  <td><mon:label separatorVisible="true" key="responseScaleType.field.sourceSystemCd.displayName.txt" property="sourceSystemCd" /></td>
                  <td><mon:select property="sourceSystemCd">
                     <html:options name="request" collection="sourceSystems" property="code" labelProperty="description" />
                  </mon:select></td>
               </tr>

               <tr id="Measure_nameTxt">
                  <td><mon:label separatorVisible="true" key="businessObjectLocalization.field.nameTxt.displayName.txt" property="nameTxt" /></td>
                  <td><mon:text property="nameTxt" style="width:97%" maxlength="100" /></td>
               </tr>

               <tr id="Measure_descTxt">
                  <td><mon:label separatorVisible="true" key="businessObjectLocalization.field.descTxt.displayName.txt" property="descTxt" /></td>
                  <td><mon:textarea property="descTxt" style="width:97%" rows="8" /></td>
               </tr>


               <tr id="Measure_assessableTypeCd">
                  <td><mon:label property="assessableTypeCd" separatorVisible="true" key="measureEx.field.assessableTypeCd.displayName.txt" requiredField="true" /></td>
                  <td class="field">
<%
   if (Boolean.TRUE.equals(request.getAttribute("isFresh")))
   {
%>
                     <mon:select property="assessableTypeCd" onclick="javascript:getExistingAssessableType()" onchange="javascript:checkForCalculation()">
                     <html:options name="request" collection="assessableTypes" property="value" labelProperty="label" />
                  </mon:select> <%
   }
   else
   {
 %> <html:hidden property="assessableTypeCd" /> <mon:select property="assessableTypeCd" disabled="true">
                     <html:options name="request" collection="assessableTypes" property="value" labelProperty="label" />
                  </mon:select></td>
<%
   }
%>
               </tr>
               <tr id="Measure_variableName">
                  <td><mon:label separatorVisible="true" key="measureEx.field.variableName.displayName.txt" property="variableName" /></td>
                  <td><html:text property="variableName" styleId="variableName" style="width:40%" maxlength="25" /></td>
               </tr>
               <tr id="Measure_currencyFlg">
                  <td style="white-space: nowrap;"><mon:label key="measureEx.field.currencyFlg.displayName.txt" property="currencyFlg" /></td>
                  <td><html:radio property="currencyFlg" value="true">
                     <fmt:message key="yesno.yes.txt" />
                  </html:radio> <html:radio property="currencyFlg" value="false">
                     <fmt:message key="yesno.no.txt" />
                  </html:radio></td>
               </tr>
               <tr id="Measure_defaultFlg">
                  <td style="white-space: nowrap;"><mon:label key="measureEx.field.defaultFlg.displayName.txt" property="defaultFlg" /></td>
                  <td><html:radio property="defaultFlg" value="true">
                     <fmt:message key="yesno.yes.txt" />
                  </html:radio> <html:radio property="defaultFlg" value="false">
                     <fmt:message key="yesno.no.txt" />
                  </html:radio></td>
               </tr>
               <tr id="Measure_computationFn">
                  <td style="white-space: nowrap;"><mon:label separatorVisible="true" key="measureEx.field.computationFn.displayName.txt" property="computationFn" /></td>
                  <td>
                     <html:text property="computationFn" styleId="computationFn" style="width:40%" maxlength="50" readonly="true" />
                     <c:if test="${!readOnly}">
                        <a href="javascript:editExpression()">
                           <img border="0" src="<fmt:message key='application.expressionEditor.image' />"
                              alt="<fmt:message key='application.expressionEditor.tooltip.txt'/>"
                              title="<fmt:message key='application.expressionEditor.tooltip.txt'/>" />
                        </a>
                     </c:if>
                  </td>
               </tr>

               <tr id="Measure_justificationCd">
                  <td><mon:label property="justificationCd" separatorVisible="true" key="measureEx.field.justificationCd.displayName.txt" /></td>
                  <td><mon:select property="justificationCd">
                     <html:options name="request" collection="justificationTypes" property="value" labelProperty="label" />
                  </mon:select></td>
               </tr>

               <c:if test="${!isFresh}">
                  <tr id="Measure_defaultResponseScale">
                     <td><mon:label property="defaultResponseScale" separatorVisible="true" key="measureEx.field.defaultResponseScale.displayName.txt" /></td>
                     <td><input type="text" value="<%= StringUtil.escapeHTML(defaultResponseScale) %>" size="100" maxlength="100" disabled="true" /></td>
                  </tr>
               </c:if>

               <mon:CustFields propertyKey="responseScaleType" format="table" displayHeader="true" />
            </table>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>
