<%@ include file="/tiles/taglibs.jsp"%>

<%@ page import="java.util.*"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.*"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.QuestionnaireModel.*"%>
<%@ page import="com.sas.oprisk.monitor.web.utils.HTMLUtils"%>
<%@ page import="com.sas.oprisk.server.logical.CsaQuestion"%>
<%@ page import="com.sas.oprisk.server.DimensionalPoint"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.QuestionGroupTag"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.QuestionTag"%>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@ page import="com.sas.oprisk.server.AnswerSheetStatus"%>

<%
   final Locale locale = request.getLocale();
            final ResourceBundle bundle = ApplicationProperties
                    .getBundle(locale);
            final PersistenceSession psession = MonitorContext
                    .getPersistenceSession(request);

            final QuestionnaireModel model = (QuestionnaireModel) request
                    .getAttribute("model");
            final boolean workflowExpanded = Boolean.TRUE.equals(request
                    .getAttribute("workflowExpanded"));
            final boolean collapsed = !workflowExpanded;
%>

<mon:Page template="details">
      <mon:Head>
         <script type="text/javascript">    
         
         function monitorInit() {
            initNSMenu();
            
            <c:if test="${model.readOnly}">
               var f = document.forms.questionnaireForm;
            
               // disable all other form fields and buttons
               for(i = 0; i < f.elements.length; i++) {
                  if (f.elements[i].type != "hidden" &&
                        f.elements[i].name != "jumpPrimaryItemIndex" &&
                        (f.elements[i].name && f.elements[i].name.indexOf("actionButton") !== 0)
                        ) {
                     f.elements[i].disabled = true;
                  }
               }
            </c:if>
         }
         
         
         function prevItem() {
            view(<c:out value="${model.itemIndex}" /> - 1);
         }
         
         function nextItem() {
            view(<c:out value="${model.itemIndex}" /> + 1);
         }

         function view(itemIndex) {
            var f = document.forms.questionnaireForm;
            f.action = "<%=request.getContextPath()%>/Questionnaire.do"
               + "?method=<c:out value="${method}" />"
               + "&itemIndex=" + itemIndex;
            f.submit();
         }
         
         function returnToStage(stageIndex) {
            doQnr("returnToStage&targetStageIndex=" + stageIndex);
         }
         
         function viewAssessors() {
            doQnr("viewAssessors&dropBC=true"
               + "&roleHandle=<c:out value='${model.roleHandle}' />"
               + "&areaHandle=<c:out value='${model.dimAreaHandle}' />");
         }
         
         function doImport() {
         <c:if test="${model.canEndEdit}">
            var msg = unescape("<%=ParsingUtils.escape(bundle.getString("Questionnaire.message.import.unsavedChanges.txt"))%>");
            if (!confirm(formatMessage(msg, unescape(name)))) {
               return;
            }
         </c:if>
            doQnr("doImport");
         }
         
         function doQnr(method, anchor) {
            var f = document.forms.questionnaireForm;
            f.action = "<%=request.getContextPath()%>/Questionnaire.do"
               + "?method=" + method
               + "&itemIndex=<c:out value="${model.itemIndex}" />"
               + "&pointInTime=<%=model.getPointInTime()%>";
            if (typeof(anchor) != 'undefined') {
               f.action += anchor;
            }
            f.submit();
         }
         
         function setWorkflowExpanded(expanded) {
            var f = document.forms.questionnaireForm;
            f.workflowExpanded.value = expanded;
         }
         
         function popupCloser_refresh() {
            doQnr("view", popupAnchor);
         }
         
         <%-- forward to specified page --%>
         function forward(path) {
            doQnr("forward&path=" + escape(path));
         }
         </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/Questionnaire">
         <mon:ToolBar>
            <c:if test="${not model.preview}">
                  <c:if test="${model.canEdit}">
                     <mon:Button name="actionButtonOpen" onclick="doQnr('edit')">
                        <fmt:message key="application.button.open.txt" />
                     </mon:Button>                     
                  </c:if>
                  <c:if test="${model.canEndEdit}">
                     <mon:Button name="actionButtonClose" onclick="doQnr('endEdit')">
                        <fmt:message key="application.button.close.txt" />
                     </mon:Button>                     
                  </c:if>
                  <c:if test="${model.canSave}">
                     <mon:Button name="actionButtonSave" onclick="doQnr('save')">
                        <c:if test="${model.draft}">
                          <fmt:message key="application.button.saveDraft.txt" />
                        </c:if>
                        <c:if test="${not model.draft}">
                          <fmt:message key="application.button.save.txt" />
                        </c:if>
                     </mon:Button>                     
                  </c:if>
                  <c:if test="${model.canSubmit}">
                     <mon:Button name="actionButtonSubmit" onclick="doQnr('submit')">
                        <fmt:message key="Questionnaire.button.submit.txt" />
                     </mon:Button>                     
                  </c:if>
                  <c:if test="${model.canValidate}">
                     <mon:Button name="actionButtonValidate" onclick="doQnr('validate')">
                        <fmt:message key="application.button.validate.txt" />
                     </mon:Button>                     
                  </c:if>
                  <c:if test="${model.canReturn}">
                     <mon:Button name="actionButtonReturn" onclick="doQnr('returnToStage')">
                        <fmt:message key="application.button.return.txt" />
                     </mon:Button>                     
                  </c:if>
               </c:if>
               <c:if test="${model.canEdit or model.canEndEdit}">
                  <mon:Button name="actionButtonImport" onclick="doImport()">
                     <fmt:message key="application.button.import.txt" />
                  </mon:Button>
               </c:if>
               <c:if test="${not model.preview}">
                  <mon:Button name="actionButtonExport" onclick="doQnr('export')">
                     <fmt:message key="application.button.export.txt" />
                  </mon:Button>
               </c:if>
               <mon:Button name="actionButtonCancel" onclick="doQnr('cancel')">
                  <c:if test="${model.preview}">
                     <fmt:message key="application.ok.txt" />
                  </c:if>
                  <c:if test="${(not model.preview) && model.readOnly}">
                     <fmt:message key="application.button.done.txt" />
                  </c:if>
                  <c:if test="${(not model.preview) && (not model.readOnly)}">
                     <fmt:message key="application.button.cancel.txt" />
                  </c:if>
               </mon:Button>
         </mon:ToolBar>

         <mon:Content>
            <html:hidden property="handle" />
            <html:hidden property="errorCheckingMode" />
            <html:hidden property="workflowExpanded" />
            
         
            <table border="0" cellspacing="0" width="100%">
               <tr>
                  <td width="100%">
                  <table border="0">
                     <c:if test="${not empty model.dueDate}">
                        <tr id="Questionnaire_dueDate">
                           <th style="white-space: nowrap;" class="fieldlabel"><fmt:message
                              key="assessment.field.dueDt.displayName.txt" />:&nbsp;</th>
                           <td class="field" style="white-space: nowrap;"><c:out
                              value="${model.dueDate}" /></td>
                        </tr>
                     </c:if>
                     <c:if test="${not empty model.reportingPeriod}">
                        <tr id="Questionnaire_reportingPeriod">
                           <th style="white-space: nowrap;" class="fieldlabel"><fmt:message
                              key="assessment.field.assessmentPeriod.displayName.txt" />:&nbsp;</th>
                           <td class="field"><c:out
                              value="${model.reportingPeriod}" /></td>
                        </tr>
                     </c:if>
                     <c:if test="${not model.preview}">
                        <tr id="Questionnaire_attachments">
                           <th style="white-space: nowrap;" class="fieldlabel"><fmt:message
                              key="application.Attachments.txt" />:&nbsp;</th>
                           <td><mon:AttachmentsTable
                              attachmentContainer='<%= model.getAnswerSheet() %>'
                              readOnly='<%= model.isReadOnly() %>' minimal='true' />
                           </td>
                        </tr>
                        <%
                           if (LicenseUtils.isEnabled(ProductFeature.IAP, request)) {
                        %>
                        <tr id="Questionnaire_issues">
                           <th style="white-space: nowrap;" class="fieldlabel"><fmt:message
                              key="issueQuery.title" />:&nbsp;</th>
                           <td><mon:IssuesTable
                              primaryBusinessObject='<%= model.getAnswerSheet() %>'
                              readOnly='false'
                              immediateSave='<%= model.isReadOnly() %>'
                              forwardMethod='forward' minimal='true' /></td>
                        </tr>
                        <%
                           }
                        %>
                        <c:if test="${not empty model.roleHandle}">
                           <tr id="Questionnaire_assessors">
                              <td colspan="2"><img border="0"
                                 align="absmiddle"
                                 src="<%=request.getContextPath()%>/<fmt:message key="Assessments.viewAssessors.image" />" />
                              <a href="javascript:viewAssessors()"><fmt:message
                                 key='Assessments.questionnaires.button.viewAssessors.txt' /></a>
                              </td>
                           </tr>
                        </c:if>
                     </c:if>
                  </table>
                  </td>
                  <td>&nbsp;</td>
                  <td valign="top">
                  <table border="0" width="100%">
                     <tr id="Questionnaire_progressIndicator">
                        <td id="Questionnaire_percentComplete_label"
                           style="white-space: nowrap;"><fmt:message
                           key="Questionnaire.questionsCompleted.txt" />:&nbsp;</td>
                        <td style="white-space: nowrap; vertical-align: top;">
                        <%-- begin progress indicator --%>
                        <table cellspacing="0">
                           <tr valign="middle">
                              <td id="Questionnaire_answerCount">
                              <table border="0" cellpadding="0" cellspacing="1"
                                 bgcolor="#999999" width="100">
                                 <tr>
                                    <td bgcolor="#ffcc33"
                                       width="<c:out value="${model.percentComplete}" />"
                                       align="center"><c:if
                                       test="${model.percentComplete > 0}">&nbsp;</c:if>
                                    <c:if test="${model.percentComplete >= 50}">
                                       <c:out value="${model.answeredCount}" />
                                    </c:if></td>
                                    <td bgcolor="#ffffff"
                                       width="<c:out value="${100 - model.percentComplete}" />">
                                    <c:if test="${model.percentComplete < 50}">
                                       <c:out value="${model.answeredCount}" />
                                    </c:if> <c:if test="${model.percentComplete < 100}">&nbsp;</c:if>
                                    </td>
                                 </tr>
                              </table>
                              </td>
                              <td id="Questionnaire_questionCount">&nbsp;<c:out
                                 value="${model.questionCount}" /></td>
                           </tr>
                        </table>
                        <%-- end progress indicator --%></td>
                     </tr>
                     <tr id="Questionnaire_status">
                        <td style="white-space: nowrap;"><fmt:message
                           key="application.status.txt" />:</td>
                        <td class="field" style="white-space: nowrap;"><c:out
                           value="${model.status}" /></td>
                     </tr>
                  </table>
                  </td>
               </tr>
            </table>
         
            <br />
            <div id="Questionnaire_ORAchooser"><mon:DimAreaChooser
               dimensionalAreaHandle="<%= model.getDimAreaHandle() %>"
               readOnly="true" /> <br />
            </div>
            <div id="Questionnaire_validationWorkflow"><c:if
               test="${not empty reviewersBlockModel}">
               <jsp:include page="../../commonBlocks/reviewers.jsp" flush="true">
                  <jsp:param name="scrollable" value="false" />
                  <jsp:param name="collapsed" value="<%= collapsed %>" />
                  <jsp:param name="expandMethod" value="setWorkflowExpanded" />
               </jsp:include>
               <br />
            </c:if></div>
            <c:if test="${empty model.assessedItems}">
               <b><fmt:message key="displayTable.empty.fmt.txt" /></b>
               <p />
            </c:if>
            
<%
if (model.getAssessmentItemBeans().size() > 0)
{
%>
<p><table><tr><td>
<fmt:message key="Questionnaire.assessedItems.txt" />: 
<html:select property="jumpPrimaryItemIndex">
  <html:options 
     collection="assessmentItemBeans"
     labelProperty="label" 
     property="value" />
</html:select>
</td><td>
<mon:Button name="actionButtonGoJump" onclick="view(document.forms.questionnaireForm['jumpPrimaryItemIndex'].selectedIndex)"><fmt:message key='goButton.txt' /></mon:Button>
</td></tr></table></p>
<%
}
%>        
            <div id="Questionnaire_assessedItems"><c:forEach
               items="${model.assessedItems}" var="assessedItem"
               varStatus="status">
         
               <%-- render the questions/answers for this page --%>
               <c:if test="${status.index == model.itemIndex}">
                  <%
                     QuestionnaireModel.AssessedItemModel aim = (QuestionnaireModel.AssessedItemModel) pageContext
                                          .findAttribute("assessedItem");
                                    final String externalId = aim.getPrimaryItem()
                                          .getExternalId();
                                    boolean viewable = aim.isViewable(psession);
                                    pageContext.setAttribute("viewable",
                                          Boolean.valueOf(viewable));
                  %>
                  <table cellpadding="0" cellspacing="1" border="0"
                     class="section" width="100%">
                     <tr>
                        <td class="section">
                        <div class="sectionheader">
                        <div class="sectionheadertext">&nbsp; <img
                           id="item_body_toggle_img"
                           src="<fmt:message key='application.minus.image'/>"
                           border="0" width="9" height="9"> &nbsp; <span
                           id="Questionnaire_assessedItems_sectionHeaderText">
                        <c:choose>
                           <c:when test="${not model.preview }">
                              <span
                                 id="Questionnaire_assessedItems_sectionHeaderTitle1">
                              <%=aim.getLabel() + ":"%> </span>
                              <span
                                 id="Questionnaire_assessedItems_sectionHeaderTitle2">
                              <%=(aim.getInstanceId() != null) ? StringUtil.escapeHTML(aim.getInstanceId()) : ""%>
                              </span>
                           </c:when>
                           <c:otherwise>
                              <span
                                 id="Questionnaire_assessedItems_sectionHeaderTitle1">
                              <c:out value="${assessedItem.primaryItemLabel}" />:
                              </span>
                              <span
                                 id="Questionnaire_assessedItems_sectionHeaderTitle2">
                              <c:out value="${assessedItem.primaryItemPath}" />
                              </span>
                           </c:otherwise>
                        </c:choose> </span>
                        </div><!-- sectionheaderbutton -->
                        </div><!-- sectionheader -->
         
                        <table cellspacing="10" class="sectionbody" id="item_body" width="100%">
                           <tr>
                              <td>
                              <div class="sectionheaderbuttons"><b><%@ include
                                 file="questionnaireNav.jspf"%></b>
                              </div>
                              </td>
                           </tr>
                           <tr>
                              <td class="sectionbody">
         
                              <table border="0" cellspacing="5">
                                 <c:if
                                    test="${assessedItem.context.pathCount > 0}">
                                    <tr
                                       id="Questionnaire_assessmentElementContext">
                                       <td class="fieldlabel"><fmt:message
                                          key="Questionnaire.context.txt" />:</td>
                                       <td class="field"><c:forEach
                                          items="${assessedItem.context.contextPaths}"
                                          var="path">
                                          <c:out value="${path.label}" />
                                          <br />
                                       </c:forEach></td>
                                    </tr>
                                 </c:if>
         
                                 <c:choose>
                                    <c:when
                                       test="${! assessedItem.scoredInstanceTemp}">
                                       <tr id="Questionnaire_assessedItemName">
                                          <td class="fieldlabel"><%=aim.getAssessedItemTitleLabel()%>:</td>
                                          <td class="field"><c:if
                                             test="${not model.preview && viewable}">
                                             <a
                                                href="javascript:doQnr('forward&path=<%=ParsingUtils.escape(ParsingUtils
                                          .escape(aim.getAssessableUri()))%>')">
                                          </c:if> <%=StringUtil.escapeHTML((aim.getInstanceName() != null) ? aim.getInstanceName() : "")%>
                                          <c:if
                                             test="${not model.preview && viewable}">
                                             </a>
                                          </c:if></td>
                                          <tr>
                                             <tr
                                                id="Questionnaire_assessedItemDesc">
                                                <td class="fieldlabel"><%=aim.getAssessedItemDescLabel()%>:</td>
                                                <td><%=StringUtil.escapeHTML((aim.getInstanceDesc() != null) ? aim.getInstanceDesc() : "")%></td>
                                             </tr>
                                    </c:when>
                                    <c:otherwise>
                                       <tr id="Questionnaire_assessedItemName">
                                          <td class="fieldlabel"><%=aim.getAssessedItemTitleLabel()%>:</td>
                                          <td class="field"><%=(aim.getInstanceName() != null) ? aim
                                       .getInstanceName() : ""%>
                                          </td>
                                          <tr>
                                             <tr
                                                id="Questionnaire_assessedItemDesc">
                                                <td class="fieldlabel"><%=aim.getAssessedItemDescLabel()%>:</td>
                                                <td><%=StringUtil.escapeHTML((aim.getInstanceDesc() != null) ? aim.getInstanceDesc() : "")%></td>
                                             </tr>
                                    </c:otherwise>
                                 </c:choose>
                                 <tr id="Questionnaire_assessmentElementPath">
                                    <td class="fieldlabel"><c:out
                                       value="${assessedItem.primaryItemLabel}" />:</td>
                                    <td class="field"><c:if
                                       test="${not empty assessedItem.primaryItemUri && not model.preview}">
                                       <a
                                          href="javascript:doQnr('forward&path=<%=ParsingUtils.escape(ParsingUtils
                                    .escape(aim.getPrimaryItemUri()))%>')">
                                    </c:if> <c:out
                                       value="${assessedItem.primaryItemPath}" />
                                    <c:if
                                       test="${not empty assessedItem.primaryItemUri && not model.preview}">
                                       </a>
                                    </c:if></td>
                                 </tr>
                                 <tr id="Questionnaire_assessmentElementLocation">
                                    <td class="fieldlabel"><fmt:message
                                       key="assessment.field.location.displayName.txt" />:</td>
                                    <td class="field"><c:choose>
                                       <c:when
                                          test="${not empty assessedItem.opRiskLocation}">
                                          <c:out
                                             value="${assessedItem.opRiskLocation}"
                                             escapeXml="false" />
                                       </c:when>
                                       <c:when
                                          test="${not empty assessedItem.opCauseLocation}">
                                          <c:out
                                             value="${assessedItem.opCauseLocation}"
                                             escapeXml="false" />
                                       </c:when>
                                       <c:when
                                          test="${not empty assessedItem.opControlLocation}">
                                          <c:out
                                             value="${assessedItem.opControlLocation}"
                                             escapeXml="false" />
                                       </c:when>
                                    </c:choose></td>
                                 </tr>
                              </table>
         
                              <table cellspacing="0" border="0" width="100%">
                                 <c:forEach
                                    items="${assessedItem.questionGroups}"
                                    var="questionGroup">
                                    <tr>
                                       <td valign="top"><br />
                                       <%
                                          final QuestionnaireModel.QuestionGroupModel qgm = (QuestionnaireModel.QuestionGroupModel) pageContext
                                                                  .findAttribute("questionGroup");
                                                            final AssessmentQuestionGroup qg = qgm
                                                                  .getQuestionGroup();
                                                            String s = "";
         
                                                            QuestionGroupTag.writeGroupStart(qg, bundle,
                                                                  pageContext, model.getPointInTime(),
                                                                  psession, true);
                                                            int aIndex = 0;
                                       %> <c:forEach items="${questionGroup.questions}" var="question">
                                          <%
                                             final QuestionnaireModel.QuestionModel qm = (QuestionnaireModel.QuestionModel) pageContext
                                                                        .findAttribute("question");
                                                                  final AssessmentAnswer answer = qm.getAnswer();
                                                                  final String handle = answer == null
                                                                        ? null
                                                                        : QuestionTag.escapeHandle(answer
                                                                              .getHandleString());
                                                                  String score = null;
                                                                  String justification = null;
                                                                  if (answer != null) {
                                                                     score = (String) model.getValueMap().get(
                                                                           handle);
                                                                     justification = (String) model
                                                                           .getValueMap()
                                                                           .get(QuestionTag.JUSTIFICATION_PREFIX
                                                                                 + handle);
                                                                  }
                                          %>
                                          <mon:question
                                             question="<%= qm.getQuestion() %>"
                                             answer="<%= answer %>"
                                             showResponses="true"
                                             groupIndex="<%= aIndex++ %>"
                                             number="<%= qm.getNumber() %>"
                                             score="<%= score %>"
                                             justification="<%= justification %>"
                                             pointInTime="<%= model.getPointInTime() %>"
                                             showAttachments="true"
                                             readOnly='<%= model.isReadOnly() %>' />
                                       </c:forEach> <%
             QuestionGroupTag.writeGroupEnd(pageContext);
          %>
                                       </td>
                                    </tr>
                                 </c:forEach>
         
                              </table>

<%
List linkedSummary = (List)model.getInstanceHandleToLinkedObjectTableEntry().get(aim.getAssessedItemTaggedPointerHandle());
if (linkedSummary != null && linkedSummary.size() > 0)
{
   request.setAttribute("linkedSummary", linkedSummary);
%>
<p>
<mon:table width="100%" class="displayTable" cellspacing="0" name="linkedSummary" id="link">
  <mon:title>
     <fmt:message key="AssessmentWizard.relatedInstances.txt"/>
  </mon:title>

  <display:column title="<%=bundle.getString(\"AssessmentWizard.relatedInstances.name.txt\")%>" width="70%">
     <a href="javascript:view(<%= ((LinkedObjectTableEntry)link).getIndex() %>);"><%= ((LinkedObjectTableEntry)link).getName() %></a>
  </display:column>
  <display:column title="<%=bundle.getString(\"AssessmentWizard.relatedInstances.type.txt\")%>" width="15%">
     <fmt:message key="<%=((LinkedObjectTableEntry)link).getType() %>"/>
  </display:column>
  <display:column property="answered" title="<%=bundle.getString(\"AssessmentWizard.relatedInstances.answered.questions.txt\")%>" width="5%"/>
  <display:column property="unanswered" title="<%=bundle.getString(\"AssessmentWizard.relatedInstances.unanswered.questions.txt\")%>" width="5%"/>
  <display:column title="<%=bundle.getString(\"AssessmentWizard.relatedInstances.complete.txt\")%>" width="5%">
  <% if (((LinkedObjectTableEntry)link).isComplete()) { %>
     <img src="images/checkmarkGreen.gif" alt="<fmt:message key='yesno.yes.txt'/>" title="<fmt:message key='yesno.yes.txt'/>"/>
  <% } else { %>
     <img src="images/rowDelete.gif" alt="<fmt:message key='yesno.no.txt'/>" title="<fmt:message key='yesno.no.txt'/>"/>
  <% } %>
  </display:column>
</mon:table>
</p>
<%
}
%>                              

                              </td>
                           </tr>
                           <tr>
                              <td>
                              <div class="sectionheaderbuttons"><b><%@ include
                                 file="questionnaireNav.jspf"%></b>
                              </div>
                              </td>
                           </tr>
                        </table>
                        <!-- sectionbody --></td>
                     </tr>
                  </table>
                  <!-- section -->
                  <script type="text/javascript">
                  setCollapsible('item_body', 'item_body_toggle_img');
               </script>
               </c:if>
         
            </c:forEach> <br />
            </div>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>
