<%@page import="java.util.Arrays"%>
<%@page import="com.sas.solutions.cpb.util.StringUtil" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %> 
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%
   String dimensionalArea = request.getParameter("dimensionalArea");
   String handle = request.getParameter("handle");
   String showRelatedMappingsStr = (String)request.getAttribute("showRelatedMappings");
   boolean showRelatedMappings = "true".equals(showRelatedMappingsStr);
   String exportUrl = request.getContextPath() + "/RiskEventTypesChooser.do" +
             "?entryId=riskEventTypes" +
             "&handle=" + StringUtil.encodeURLValue(handle) + 
             "&dimensionalArea=" + StringUtil.encodeURLValue(dimensionalArea);
   if (showRelatedMappings){
      exportUrl += "&showRelatedMappings=" + showRelatedMappingsStr;
   }
%>
<mon:Page template="popup">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <mon:include js="/tiles/CSA/questionnaireTemplateWizard/riskEventTypesChooser.js" />
      <mon:include js="/components/dialogs/ModalDialog.js"/>
      <mon:include js="/ext/cpbcore/browser/Event.js"/>
      
      <script type="text/javascript">
      retChooser.initialize({
         form: "questionnaireTemplateWizardForm",
         onselect: "RiskCauseControlTypes.handleAddSelectedOnClick"
         });
      
      function filterRelatedMappings(showRelatedMappings) {
      // reset paging, otherwise we might get index out of bounds
         document.getElementById("riskEventTypes_TCStart").value = 0;
         refreshForm({showRelatedMappings:showRelatedMappings});
      }
      
      function refreshForm(args) {
         var f = document.forms[0];
         f.method.value = 'display';
      
         if (args !== undefined)
         {
            f.method.value = 'saveFilter';
            
            for (var key in args)
            {
                var elem = f.elements[key];
      
                if (!elem)
                {
                    elem = document.createElement("input");
                    elem.type = "hidden";
                    elem.name = key;
                    f.appendChild(elem);
                }
                
                elem.value = args[key];
            }
         }
         
         this.window.setTimeout(showPleaseWait, 1000);
         f.submit();
      }
      
      function showPleaseWait() {
         document.body.innerHTML = "<div><fmt:message key='application.wait.txt' /></div>";
      }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="RiskEventTypesChooser">               
         
         <mon:Content>
            
            <html:hidden property="dimensionalArea" value="${dimensionalArea}"/>
            <html:hidden property="handle" value="${handle}"/>
         
         <mon:tableComponent id="riskEventType" entryName="riskEventTypes" exportXlsUrl="<%=exportUrl%>" >
         
            <c:set var="checkAll">
                <input type="checkbox" name="checkAll" id="checkAll" title="<fmt:message key="application.selectAll.tooltip.txt" />"/>
            </c:set>
         
            <mon:fixedColumn width='20' title="${checkAll}">
               
               <c:set var="disabled">
                  <c:forEach items="${risks}" var="risk">
                     <c:if test="${risk == riskEventType.handle}">true</c:if>
                  </c:forEach>
               </c:set>
               
               <html:multibox property="risks" value="${riskEventType.handle}" disabled="${disabled}"></html:multibox>
            </mon:fixedColumn>
         
         </mon:tableComponent>
         
         <table width="100%"><tr>
            <td width="100%">
         <input type="checkbox" id='showRelatedMappings' name='showRelatedMappings' value="true" onclick="filterRelatedMappings(!this.checked)" 
         <%= "true".equals(request.getAttribute("showRelatedMappings")) ? "checked" : "" %> />
         <label for='mappings'>
         <fmt:message key="ora.constrainByMappings.txt" />
         </label>
            </td>
         </tr></table>
         
         <script type="text/javascript">
         new CheckboxGroup("riskEventTypesChooser", "risks", "checkAll");
         </script>
         </mon:Content> 
         
         <mon:PopupButtonBar> 
            <mon:Button name="addAndClose" onclick="retChooser.add(); retChooser.close();">
               <fmt:message key='application.button.addAndClose.txt' />
            </mon:Button>            
            
            <mon:Button name="add" onclick="retChooser.add();">
               <fmt:message key='application.button.add.txt' />
            </mon:Button>
         
            <mon:Button name="close" onclick="retChooser.close();">
               <fmt:message key='closeButton.txt' />
            </mon:Button>
         </mon:PopupButtonBar>  
      </html:form>      
   </mon:Body>
</mon:Page>