<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ratingGroups.*" %>
<%@ page import="com.sas.oprisk.server.base.GroupContentsTypeCd" %>

<%
try {
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final String context = request.getContextPath();

   final boolean readOnly = ((Boolean)request.getAttribute("readOnly")).booleanValue();
   
   final RatingGroupModel model = (RatingGroupModel)request.getAttribute("model");
   final AssessableTypeCd assessableTypeCd = model.getAssessableTypeCd();
   final GroupContentsTypeCd contentTypeCd = model.getContentTypeCd();

   final String csaQGHandle = (String)request.getAttribute("csaQGHandle");
   final String exportUrl  = request.getContextPath() + "/RatingGroup.do?method=select&entryId=groupContents&handle=" + StringUtil.encodeURLValue(csaQGHandle);
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">

         var sections = new Array('details', 'translations', 'contents');
         function expandCollapseAll(expand) {
            setVisible("collapseAll", expand);
            setVisible("expandAll", !expand);
         
            for(var i = 0; i < sections.length; i++) {
               setSectionExpanded(sections[i], expand);
            }
         }
      
         function doGroupAction(method) {
            var f = document.forms.ratingGroupForm;
            f.action = 
               "<%= context %>/"
               + "RatingGroup.do?method=" + method;
            f.submit();
         }
         
         function onSelectMeasure(handle) {
            var f = document.forms.ratingGroupForm;
            f.action = 
               "<%= context %>/"
               + "RatingGroup.do?method=viewMeasure"
               + "&measureHandle=" + handle;
            f.submit();
         }
      
         function clickThru(handle) {
            var f = document.forms.ratingGroupForm;
            f.action = 
               "<%= context %>/"
               + "RatingGroup.do?method=drillDown" 
               + "&handle=" + handle;
            f.submit();
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/RatingGroup">      
         <mon:ToolBar>
            <c:if test="${not readOnly}">
               <mon:Button name="actionButtonSave" onclick="doGroupAction('save')">
                  <fmt:message key="application.button.save.txt" />
               </mon:Button>
               <mon:Button name="actionButtonCancel" onclick="doGroupAction('cancel')">
                  <fmt:message key="application.button.cancel.txt" />
               </mon:Button>              
            </c:if>
            <c:if test="${readOnly}">
               <mon:Button name="actionButtonCancel" onclick="doGroupAction('cancel')">
                  <fmt:message key="application.button.done.txt" />
               </mon:Button>              
            </c:if>
         </mon:ToolBar>
         
         <mon:Content>
            <html:hidden property="handle" />
            <input type="hidden" name="csaQGHandle" value="<%= StringUtil.escapeHTML(csaQGHandle) %>" />
           
            <%------------------------------%>
            <%--    Expand/Collapse All   --%>   
            <%------------------------------%>   
            <div id="expandAll">
               <img border="0" id="allnodes_img"
                  alt="<fmt:message key='application.expandAllSections.txt'/>"
                  src="<%=request.getContextPath()%>/<fmt:message key='application.expandAllNodes.image'/>" />
                  &nbsp;<a href="javascript:expandCollapseAll(true)"><fmt:message key='incident.investigate.expandAll.txt' /></a>
            </div>
            <div id="collapseAll" style="display: none;">
               <img border="0" id="allnodes_img"
                  alt="<fmt:message key='application.collapseAllSections.txt'/>"
                  src="<%=request.getContextPath()%>/<fmt:message key='application.collapseAllNodes.image'/>" />
                  &nbsp;<a href="javascript:expandCollapseAll(false)"><fmt:message key='incident.investigate.collapseAll.txt' /></a>
            </div>
            
            <br/>
         
            <mon:section id="details" expandedProperty="detailsExpanded">
            <mon:title><fmt:message key="RatingGroup.section.details.txt" /></mon:title>
         
            <table width="100%" cellpadding="2px">
               <tr>  
                  <td style="white-space: nowrap;">
                     <mon:label key="assessmentQuestionGroup.field.activeFlg.displayName.txt" property="activeFlg"/>
                  </td>
                  <td width="100%">
                     <fieldset class="screen-reader-only">
                     <legend><mon:label key="assessmentQuestionGroup.field.activeFlg.displayName.txt" property="activeFlg"/></legend>
                     <html:radio property="activeFlg" value="true" disabled="<%= readOnly %>">
                        <fmt:message key="application.yes.txt" />
                     </html:radio>    
                     <html:radio property="activeFlg" value="false" disabled="<%= readOnly %>" >
                        <fmt:message key="application.no.txt" />
                     </html:radio>
                     <c:if test="${readOnly}">
                        <html:hidden property="activeFlg"/>
                     </c:if>
                     </fieldset>
                  </td>
               </tr>
               <tr>
                  <td style="white-space: nowrap;">
                     <mon:label key="ratingGroup.field.ratingGroupId.displayName.txt" property="assessmentGroupId"/>:
                  </td>
                  <td>
                     <c:if test="${not readOnly}">
                        <mon:text property="ratingGroupId" style="width:97%" maxlength="32" />                        
                     </c:if>
                     <c:if test="${readOnly}">
                        <c:out value="${ratingGroupForm.assessmentGroupId}" />
                        <mon:hidden property="assessmentGroupId"/>
                     </c:if>
                  </td>
              </tr>
               <tr>
                  <td style="white-space: nowrap;">
                     <mon:label key="assessmentQuestionGroup.field.assessableTypeCd.displayName.txt" property="assessableTypeCd"/>:
                  </td>
                  <td>
                     <c:if test="${not readOnly}">
                        <mon:text property="assessableTypeCd" style="width:97%" maxlength="32" />
                     </c:if>
                     <c:if test="${readOnly}">
                        <fmt:message><%= assessableTypeCd.getDisplayNameKey() %></fmt:message>
                     </c:if>
                  </td>
              </tr>
              <tr>
                  <td style="white-space: nowrap;">
                     <mon:label key="csaQuestionGroup.field.questionGrpShortNm.displayName.txt" property="name"/>
                  </td>
                  <td>
                     <c:if test="${not readOnly}">
                        <mon:text property="name" style="width:97%" maxlength="100" />
                     </c:if>
                     <c:if test="${readOnly}">
                        <c:out value="${ratingGroupForm.name}" />
                     </c:if>
                  </td>
               </tr>
                <tr>
                   <td style="white-space: nowrap;">
                      <mon:label key="csaQuestionGroup.field.questionGrpTxt.displayName.txt" property="text"/>
                   </td>
                   <td>
                      <mon:textarea property="description" rows="4" style="width:97%" disabled="<%= readOnly %>" />
                   </td>
                </tr>
                <tr>
                   <td style="white-space: nowrap;">
                      <mon:label key="csaQuestionGroup.field.helpTxt.displayName.txt" property="helpTxt"/>
                   </td>
                   <td> 
                      <mon:textarea property="helpText" rows="4" style="width:97%" disabled="<%= readOnly %>" />
                   </td>
                </tr>
                <tr>
                   <th class="fieldlabel" style="white-space: nowrap;">
                      <mon:label key="csaQuestionGroup.field.languageCd.displayName.txt" property="languageCd"/>
                   </th>
                 <td>
                      <c:out value="${ratingGroupForm.languageCd}" />
                   </td>
                </tr>
            </table>
         
            </mon:section>
         
            <br/>
           
            <mon:section id="translations" expandedProperty="translationsExpanded">
            <mon:title><fmt:message key="RatingGroup.section.translations.txt" /></mon:title>
         
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.model.translations" id="translation">
               <display:column title='<%= bundle.getString("csaQuestionGroup.field.languageCd.displayName.txt") %>' >
                  <c:out value='${translation.languageCd}'/>
               </display:column>
         
               <display:column title='<%= bundle.getString("businessObjectLocalization.field.nameTxt.displayName.txt") %>'><c:out value='${translation.nameTxt}'/></display:column>
                  
               <display:column title='<%= bundle.getString("businessObjectLocalization.field.descTxt.displayName.txt") %>'><c:out value='${translation.descTxt}'/></display:column>
         
               <display:column title='<%= bundle.getString("businessObjectLocalization.field.helpTxt.displayName.txt") %>'><c:out value='${translation.helpTxt}'/></display:column>
            </mon:table>
           
            </mon:section>
         
            <br/>
         
            <mon:section id="contents" expandedProperty="contentsExpanded">
            <mon:title><fmt:message key="RatingGroup.section.contents.txt" /></mon:title>
         
            <br/>
            <p>
               <fmt:message key="assessmentQuestionGroup.field.groupContentsTypeCd.displayName.txt" />:&nbsp;&nbsp;
               <fmt:message><%= contentTypeCd.getDisplayNameKey() %></fmt:message>
            </p>
         
            <mon:tableComponent id="group" wizCursor="view" entryName="groupContents" exportXlsUrl="<%= exportUrl %>">
         <%    if(contentTypeCd.equals(GroupContentsTypeCd.groups)) { %>
                  <mon:title><fmt:message key="RatingGroups.title" /></mon:title>  
         <%    } else if(contentTypeCd.equals(GroupContentsTypeCd.questions)) { %>
                  <mon:title><fmt:message key="Measures.title" /></mon:title>  
         <%    } %>
            </mon:tableComponent>
         
            </mon:section>
            
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
 
<%
} catch (Exception ex) {
	ex.printStackTrace();
}
%>