<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ratingsTemplate.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ratingGroups.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.ratingsSummary.*" %>
<%@ page import="com.sas.oprisk.server.base.GroupContentsTypeCd" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final String context = request.getContextPath();

   final boolean readOnly = Boolean.TRUE.equals(request.getAttribute("readOnly"));
   
   final RatingsTemplateModel model = (RatingsTemplateModel)request.getAttribute("model");
%>

<mon:Page template="details">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <script type="text/javascript">
      
         function toggleControlRatingsSection() {
            var value = getSelectedRadioValue('ratingsTemplateFormEx', 'controlRatingsFlg');
            setVisible("controlGroups", "true" == value);    
           
         }
         function toggleRiskRatingsSection() {
            var value = getSelectedRadioValue('ratingsTemplateFormEx', 'riskRatingsFlg');
            setVisible("ratingsTemplate", "true" == value);    
         }
      
         function doTemplateAction(method) {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = 
               "<%= context %>/"
               + "RatingsTemplate.do?method=" + method;
            f.submit();
         }
      
         function doGroupAction(method, groupHandle) {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = 
               "<%= context %>/"
               + "RatingsTemplate.do?method=" + method
               + "&groupHandle=" + groupHandle;
            f.submit();
         }
      
         function selectRatingsGroup(groupType) {
            var url = "<%= context %>/RatingGroupChooserQuery.do?"
            + "groupType=" + groupType;
            openModal(url, "policy_popup", "width=750,height=500,scrollbars,resizable");
         }
         
         function doAddGroup(path) {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = "<%= context %>/" + path;
            f.submit();
         }
      
         function doSave() {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = "<%= context %>/RatingsTemplateSave.do?method=save";
            f.submit();
         }
         
         function previewRatingsSection(section) {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = "<%= context %>/RatingsTemplateSave.do?method=preview"
               + "&section=" + section;
            f.submit();
         }
         
         function viewRatingGroup(qgHandle) {
            var f = document.forms.ratingsTemplateFormEx;
            f.action = 
               "<%= context %>/"
               + "RatingsTemplate.do?method=viewRatingGroup"
               + "&aqgHandle=" + qgHandle;
            f.submit();
         }
      
         var sections = new Array();
         function registerSection(sectionId) {
            sections[sections.length] = sectionId;
         }
      
         function expandCollapseAll(expand) {
            setVisible("collapseAll", expand);
            setVisible("expandAll", !expand);
            
            for(var i = 0; i < sections.length; i++) {
               setSectionExpanded(sections[i], expand);
            }
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/RatingsTemplate">      
         <mon:ToolBar>
            <c:if test="${not readOnly}">
               <mon:Button name="actionButtonSave" onclick="doSave()">
                  <fmt:message key="application.button.save.txt" />
               </mon:Button>
               <mon:Button name="actionButtonCancel" onclick="doTemplateAction('cancel')">
                  <fmt:message key="application.button.cancel.txt" />
               </mon:Button>
            </c:if>
            <c:if test="${readOnly}">
               <mon:Button name="actionButtonCancel" onclick="doTemplateAction('cancel')">
                  <fmt:message key="application.button.done.txt" />
               </mon:Button>
            </c:if>
         </mon:ToolBar>
         
         <mon:Content>                      
            <%------------------------------%>
            <%--    Expand/Collapse All   --%>   
            <%------------------------------%>   
            <div id="expandAll" style="display: none;">
               <img border="0" id="allnodes_img"
                  alt="<fmt:message key='application.expandAllSections.txt'/>"
                  src="<%=request.getContextPath()%>/<fmt:message key='application.expandAllNodes.image'/>" />
                  &nbsp;<a href="javascript:expandCollapseAll(true)"><fmt:message key='incident.investigate.expandAll.txt' /></a>
            </div>
            <div id="collapseAll">
               <img border="0" id="allnodes_img"
                  alt="<fmt:message key='application.collapseAllSections.txt'/>"
                  src="<%=request.getContextPath()%>/<fmt:message key='application.collapseAllNodes.image'/>" />
                  &nbsp;<a href="javascript:expandCollapseAll(false)"><fmt:message key='incident.investigate.collapseAll.txt' /></a>
            </div>
            <br/>            
            
               <html:hidden property="handle" />
               <html:hidden property="ratingsTemplateRk" />
            
               <table>
                  <tr id="ratingsTemplate_activeFlg">
                     <th class="fieldlabel" nowrap="true">
                        <mon:label property="activeFlg" key="ratingsTemplate.field.activeFlg.displayName.txt" />
                     </th>
                     <td>
                        <fieldset class="screen-reader-only">
                        <legend><mon:label property="activeFlg" key="ratingsTemplate.field.activeFlg.displayName.txt" /></legend>
                        <html:radio property="activeFlg" value="true" disabled="<%= readOnly %>">
                           <fmt:message key="yesno.yes.txt" />
                        </html:radio>    
                        <html:radio property="activeFlg" value="false" disabled="<%= readOnly %>">
                           <fmt:message key="yesno.no.txt" />
                        </html:radio>
                        </fieldset>
                     </td>
                  </tr>
                  <tr id="ratingsTemplate_ratingsTemplateId">
                     <th class="fieldlabel" nowrap="true">
                        <mon:label property="ratingsTemplateId" separatorVisible="true"
                           key="ratingsTemplate.field.ratingsTemplateId.displayName.txt" />
                     </th>
                     <td class="field">
                        <% if (ConfigDataProperties.isUserDefinedIDAllowed()) { %>
                           <mon:text property="ratingsTemplateId" maxlength="32" readonly="<%= readOnly %>" />
                        <% } else { %>
                           <c:out value="${ratingsTemplateFormEx.ratingsTemplateId}" />
                           <mon:hidden property="ratingsTemplateId" />
                        <% } %>
                     </td>
                  </tr>
                  <tr id="ratingsTemplate_sourceSystemCd">
                       <th class="fieldlabel">
                          <mon:label property="sourceSystemCd" separatorVisible="true" 
                           key="ratingsTemplate.field.sourceSystemCd.displayName.txt" />
                       </th>
                       <td>
                          <mon:select property="sourceSystemCd"
                             disabled="<%= readOnly %>">
                           <html:optionsCollection 
                              name="model"
                              property="sourceSystems" 
                              value="code" 
                              label="description" />
                          </mon:select>
            <% if (readOnly) { %>
                          <mon:hidden property="sourceSystemCd" />
            <% } %>
                       </td>
                  </tr>
                  <tr id="ratingsTemplate_ratingsTemplateNm">
                     <th class="fieldlabel">
                        <mon:label property="ratingsTemplateNm" separatorVisible="true"
                           key="ratingsTemplate.field.ratingsTemplateNm.displayName.txt" />
                     </th>
                     <td class="field">
                        <mon:text property="ratingsTemplateNm" size="75" maxlength="200" readonly="<%= readOnly %>" />
                     </td>
                  </tr>
                  <tr id="ratingsTemplate_ratingsTemplateDesc">
                     <th class="fieldlabel">
                        <mon:label property="ratingsTemplateDesc" separatorVisible="true"
                           key="ratingsTemplate.field.ratingsTemplateDesc.displayName.txt" />
                     </th>
                     <td class="field">
                        <mon:textarea property="ratingsTemplateDesc" readonly="<%=readOnly%>"
                               cols="75" rows="4" />
                     </td>
                  </tr>
               </table>
            
            <% if (RatingsSummaryModel.riskRatingEnabled) {  %>
               <p><h2><fmt:message key="RatingsTemplate.section.riskRatings.txt"/></h2></p>
            
            <%--  if risk rating is the only thing enabled, don't need to ask --%>
            <%    if (RatingsSummaryModel.controlRatingEnabled) {  %>
                  <fieldset>
                  <legend>
                  <fmt:message key='ratingsTemplate.field.riskRatingsFlg.displayName.txt' />
                  </legend>
                  <html:radio property="riskRatingsFlg" value="true" onclick="javascript:toggleRiskRatingsSection();" disabled="<%= readOnly %>">
                     <fmt:message key="yesno.yes.txt" />
                  </html:radio>    
                  <html:radio property="riskRatingsFlg" value="false" onclick="javascript:toggleRiskRatingsSection();" disabled="<%= readOnly %>">
                     <fmt:message key="yesno.no.txt" />
                  </html:radio>
                  </fieldset>
            <%       if (readOnly) { %>
                  <mon:hidden property="riskRatingsFlg" />
            <%       } %>
                  
            <%    } else { %>
                  <input type="hidden" name="riskRatingsFlg" value="true" />
            <%    } %>
               <br/><br/>
               <div id='ratingsTemplate'>
               <mon:section id="ratingTemplate" expanded="true">
                  <mon:title><fmt:message key="RatingsTemplate.riskRatingsGroup.txt"/></mon:title>
               <mon:table width="100%" class="displayTable" cellspacing="0" 
                  name="requestScope.model.riskGroups" id="riskGroup">
                  <mon:title><fmt:message key="RatingsTemplate.riskRatingsGroup.txt"/></mon:title>    
            
                  <c:if test="${not readOnly}">
                     <mon:action href="javascript:selectRatingsGroup('risk');"><fmt:message key='RatingsTemplate.selectRiskRatingsGroup.txt'/></mon:action>
                  </c:if>
                  <mon:action href="javascript:previewRatingsSection('risk');"><fmt:message key='RatingsTemplate.previewRiskRatingsSection.txt' /></mon:action>
              
            <%
                  String viewRgUrl = null;
                  AssessmentQuestionGroup rg = (AssessmentQuestionGroup)riskGroup;
                  if(riskGroup != null) {
                     viewRgUrl = "javascript:viewRatingGroup('" + rg.getHandleString() + "')"; 
                  }
            %>
            
                  <display:column title='<%= bundle.getString("application.row.txt") %>'>
                     <c:out value="${riskGroup_rowNum}"/>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("ratingGroup.field.ratingGroupId.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>"><c:out value='${riskGroup.assessmentGroupId}'/></a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.nameTxt.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>"><%= StringUtil.escapeHTML(rg.getName(psession)) %></a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.descTxt.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>">
                        <%= rg.getDescription(psession) != null
                            ? StringUtil.escapeHTML(rg.getDescription(psession))
                            : ""
                        %>
                     </a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.assessableTypeCd.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>"><%= bundle.getString(rg.getAssessableTypeCd().getDisplayNameKey()) %></a>        
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.groupContentsTypeCd.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>"><%= bundle.getString(rg.getGroupContentsTypeCd().getDisplayNameKey()) %></a>         
                  </display:column>
            
                  <display:column title='<%= bundle.getString("csaQuestionGroup.field.contentsCount.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>">
                        <%= GroupContentsTypeCd.groups.equals(rg.getGroupContentsTypeCd()) 
                            ? rg.getQuestionGroups(psession).size() 
                            : rg.getQuestions(psession).size() 
                        %>
                     </a>         
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.activeFlg.displayName.txt") %>'>
                     <a href="<%= viewRgUrl %>">
                        <c:if test ='${riskGroup.activeFlg}'><%= bundle.getString("yesno.yes.txt") %></c:if>
                        <c:if test ='${!riskGroup.activeFlg}'><%= bundle.getString("yesno.no.txt") %></c:if>
                     </a>
                  </display:column>
            
                  <%-- action columns --%>      
                  <c:if test="${! requestScope.readOnly}">
                  <display:column width='1%' title='<%= bundle.getString("application.remove.tooltip.txt") %>' align='center' headerClass="nwc">
                       <a href="javascript:doGroupAction('removeGroup','<c:out value='${riskGroup.handle}'/>')">
                         <img border="0" src="<fmt:message key='application.remove.image' />"  
                        alt="<fmt:message key='application.remove.tooltip.txt'/>" 
                        title="<fmt:message key='application.remove.tooltip.txt'/>"/>
                       </a>
                  </display:column>
            
                  <c:set var="first" value="${riskGroup_rowNum == 1}"/>
                  <c:set var="last" value="${riskGroup_rowNum == requestScope.model.numRiskGroups}"/>
               
                  <display:column width='1%' title='<%= bundle.getString("application.order.tooltip.txt") %>' align='center' headerClass="nwc">
                     <c:if test="${first}">
                        <img border="0" src="<fmt:message key='application.moveup.disabled.image' />" />&nbsp;
                     </c:if>
                     <c:if test="${not first}">
                        <a href="javascript:doGroupAction('moveGroupUp', '<c:out value="${riskGroup.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.moveup.image' />" 
                           alt="<fmt:message key='application.moveup.tooltip.txt'/>" 
                           title="<fmt:message key='application.moveup.tooltip.txt'/>"/></a>&nbsp;
                     </c:if>
                     <c:if test="${last}">
                        <img border="0" src="<fmt:message key='application.movedown.disabled.image' />" />
                     </c:if>
                     <c:if test="${not last}">
                        <a href="javascript:doGroupAction('moveGroupDown', '<c:out value="${riskGroup.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.movedown.image' />" 
                           alt="<fmt:message key='application.movedown.tooltip.txt'/>" 
                           title="<fmt:message key='application.movedown.tooltip.txt'/>"/></a>
                     </c:if>
                  </display:column>
            
                  </c:if>
            
               </mon:table>
            
               <br />
               
               <table>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label property="overallRiskResponseScaleType" separatorVisible="true" requiredField="true"
                           key="ratingsTemplate.field.overallRiskResponseScaleType.displayName.txt" />
                     </th>
                     <td class="field">
                        <mon:select property="overallRiskResponseScaleType" disabled="<%= readOnly %>">
                           <html:optionsCollection name="model" property="overallRiskResponseScaleTypes" label="label" value="value" />
                        </mon:select>
                        <c:if test="${readOnly}">
                          <html:hidden property="overallRiskResponseScaleType"/>
                       </c:if>
                     </td>
                  </tr>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label property="postMitigationRiskResponseScaleType" separatorVisible="true" requiredField="true" 
                           key="ratingsTemplate.field.postMitigationRiskResponseScaleType.displayName.txt" />
                     </th>
                     <td class="field">
                        <mon:select property="postMitigationRiskResponseScaleType" disabled="<%= readOnly %>">
                           <html:optionsCollection name="model" property="postMitigationRiskResponseScaleTypes" label="label" value="value" />
                        </mon:select>
                         <c:if test="${readOnly}">
                          <html:hidden property="postMitigationRiskResponseScaleType"/>
                       </c:if>
                     </td>
                  </tr>
                </table>
                </mon:section>
                </div>
               <br />
            <% } else { %>
               <input type="hidden" name="riskRatingsFlg" value="false" />
            <%
               }
               
               if (RatingsSummaryModel.controlRatingEnabled) {
            %>
               <p><h2><fmt:message key="RatingsTemplate.section.controlRatings.txt"/></h2></p>
               
            <%--  if control rating is the only thing enabled, don't need to ask --%>
            <%    if (RatingsSummaryModel.riskRatingEnabled) {  %>
                  <fieldset>
                  <legend>
                  <fmt:message key='ratingsTemplate.field.controlRatingsFlg.displayName.txt' />
                  </legend>
                  <html:radio property="controlRatingsFlg" value="true" onclick="javascript:toggleControlRatingsSection();" disabled="<%= readOnly %>">
                     <fmt:message key="yesno.yes.txt" />
                  </html:radio>    
                  <html:radio property="controlRatingsFlg" value="false" onclick="javascript:toggleControlRatingsSection();" disabled="<%= readOnly %>">
                     <fmt:message key="yesno.no.txt" />
                  </html:radio>
                  </fieldset>
            <%       if (readOnly) { %>
                  <mon:hidden property="controlRatingsFlg" />
            <%       } %>
            <%    } else { %>
                  <input type="hidden" name="controlRatingsFlg" value="true" />
            <%    } %>
               <br/><br/>
               <div id="controlGroups">   
               <mon:section expanded="true">
                  <mon:title><fmt:message key="RatingsTemplate.controlRatingsGroup.txt"/></mon:title>
               <mon:table width="100%" class="displayTable" cellspacing="0" 
                  name="requestScope.model.controlGroups" id="controlGroup">
                  <mon:title><fmt:message key="RatingsTemplate.controlRatingsGroup.txt"/></mon:title>    
            
                  <c:if test="${not readOnly}">
                     <mon:action href="javascript:selectRatingsGroup('control');"><fmt:message key='RatingsTemplate.selectControlRatingsGroup.txt'/></mon:action>
                  </c:if>
                  <mon:action href="javascript:previewRatingsSection('control');"><fmt:message key='RatingsTemplate.previewControlRatingsSection.txt' /></mon:action>
              
            <%
                  String viewCgUrl = null;
                  AssessmentQuestionGroup cg = (AssessmentQuestionGroup)controlGroup;
                  if(controlGroup != null) {
                     viewCgUrl = "javascript:viewRatingGroup('" + cg.getHandleString() + "')"; 
                  }
            %>
            
                  <display:column title='<%= bundle.getString("application.row.txt") %>'>
                     <c:out value="${controlGroup_rowNum}"/>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("ratingGroup.field.ratingGroupId.displayName.txt") %>'>
                      <a href="<%= viewCgUrl %>"><c:out value='${controlGroup.assessmentGroupId}'/></a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.nameTxt.displayName.txt") %>'>
                     <a href="<%= viewCgUrl %>"><%= StringUtil.escapeHTML(cg.getName(psession)) %></a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.descTxt.displayName.txt") %>'>
                     <a href="<%= viewCgUrl %>">
                        <%= cg.getDescription(psession) != null
                            ? StringUtil.escapeHTML(cg.getDescription(psession))
                            : ""
                        %>
                     </a>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.assessableTypeCd.displayName.txt") %>'>
                     <a href="<%= viewCgUrl %>"><%= bundle.getString(cg.getAssessableTypeCd().getDisplayNameKey()) %></a>        
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.groupContentsTypeCd.displayName.txt") %>'>
                     <a href="<%= viewCgUrl %>"><%= bundle.getString(cg.getGroupContentsTypeCd().getDisplayNameKey()) %></a>        
                  </display:column>
            
                  <display:column title='<%= bundle.getString("csaQuestionGroup.field.contentsCount.displayName.txt") %>'>
                     <a href="<%= viewCgUrl %>">
                        <%= GroupContentsTypeCd.groups.equals(cg.getGroupContentsTypeCd()) 
                            ? cg.getQuestionGroups(psession).size() 
                            : cg.getQuestions(psession).size() 
                        %> 
                     </a>       
                  </display:column>
            
                  <display:column title='<%= bundle.getString("assessmentQuestionGroup.field.activeFlg.displayName.txt") %>'>
                    
                     <a href="<%= viewCgUrl %>">
                        <c:if test ='${controlGroup.activeFlg}'><%= bundle.getString("yesno.yes.txt") %></c:if>
                        <c:if test ='${!controlGroup.activeFlg}'><%= bundle.getString("yesno.no.txt") %></c:if>
                     </a>
                  </display:column>
            
                  <%-- action columns --%>      
                  <c:if test="${! requestScope.readOnly}">
                  <display:column width='1%' title='<%= bundle.getString("application.remove.tooltip.txt") %>' align='center' headerClass="nwc">
                       <a href="javascript:doGroupAction('removeGroup', '<c:out value='${controlGroup.handle}'/>')">
                         <img border="0" src="<fmt:message key='application.remove.image' />"  
                        alt="<fmt:message key='application.remove.tooltip.txt'/>" 
                        title="<fmt:message key='application.remove.tooltip.txt'/>"/>
                       </a>
                  </display:column>
            
                  <c:set var="first" value="${controlGroup_rowNum == 1}"/>
                  <c:set var="last" value="${controlGroup_rowNum == requestScope.model.numControlGroups}"/>
               
                  <display:column width='1%' title='<%= bundle.getString("application.order.tooltip.txt") %>' align='center' headerClass="nwc">
                     <c:if test="${first}">
                        <img border="0" src="<fmt:message key='application.moveup.disabled.image' />" />&nbsp;
                     </c:if>
                     <c:if test="${not first}">
                        <a href="javascript:doGroupAction('moveGroupUp', '<c:out value="${controlGroup.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.moveup.image' />" 
                           alt="<fmt:message key='application.moveup.tooltip.txt'/>" 
                           title="<fmt:message key='application.moveup.tooltip.txt'/>"/></a>&nbsp;
                     </c:if>
                     <c:if test="${last}">
                        <img border="0" src="<fmt:message key='application.movedown.disabled.image' />" />
                     </c:if>
                     <c:if test="${not last}">
                        <a href="javascript:doGroupAction('moveGroupDown', '<c:out value="${controlGroup.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.movedown.image' />" 
                           alt="<fmt:message key='application.movedown.tooltip.txt'/>" 
                           title="<fmt:message key='application.movedown.tooltip.txt'/>"/></a>
                     </c:if>
                  </display:column>
            
                  </c:if>
            
               </mon:table>
               </mon:section>
               </div>
               
            <% } else { %>
               <input type="hidden" name="controlRatingsFlg" value="false" />
            <% } %>
            
               <input type="hidden" name="causeRatingsFlg" value="false" />
            
            <script type="text/javascript">
            <%--  if risk rating is the only thing enabled, don't need to toggle section --%>
            <%    if (RatingsSummaryModel.controlRatingEnabled) {  %>
            toggleRiskRatingsSection()
            <%    } %>
            <%    if (RatingsSummaryModel.riskRatingEnabled) {  %>
            toggleControlRatingsSection();
            <%    } %>
            </script>
            <c:if test="${not readOnly}">
            <script type="text/javascript">
            setFocus();
            </script>
            </c:if>
                        
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>