<%@ include file="/tiles/taglibs.jsp"%>

<%@ page import="java.util.*"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.*"%>
<%@ page import="com.sas.oprisk.monitor.web.utils.HTMLUtils"%>
<%@ page import="com.sas.oprisk.server.logical.CsaQuestion"%>
<%@ page import="com.sas.oprisk.server.DimensionalPoint"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.QuestionGroupTag"%>
<%@ page import="com.sas.oprisk.monitor.web.tags.QuestionTag"%>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@ page import="com.sas.oprisk.server.AnswerSheetStatus"%>

<%
   final Locale locale = request.getLocale();
			final ResourceBundle bundle = ApplicationProperties
					.getBundle(locale);
			final PersistenceSession psession = MonitorContext
					.getPersistenceSession(request);

			final QuestionnaireModel model = (QuestionnaireModel) request
					.getAttribute("model");
			final boolean workflowExpanded = Boolean.TRUE.equals(request
					.getAttribute("workflowExpanded"));
			final boolean collapsed = !workflowExpanded;
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">    

      function monitorInit() {
         initNSMenu();
         
         <c:if test="${model.readOnly}">
            var f = document.forms.questionnaireForm;
         
            // disable all other form fields and buttons
            for(i = 0; i < f.elements.length; i++) {
               if (f.elements[i].type != "hidden" &&
                   f.elements[i].name.substring(0,12) != "actionButton") {
                  f.elements[i].disabled = true;
               }
            }
         </c:if>
      }
      
      
      function prevItem() {
         view(<c:out value="${model.itemIndex}" /> - 1);
      }
      
      function nextItem() {
         view(<c:out value="${model.itemIndex}" /> + 1);
      }
      
      function view(itemIndex) {
         var f = document.forms.questionnaireForm;
         f.action = "<%=request.getContextPath()%>/Scenario.do"
            + "?method=<c:out value="${method}" />"
            + "&itemIndex=" + itemIndex;
         f.submit();
      }
      
      function returnToStage(stageIndex) {
         doQnr("returnToStage&targetStageIndex=" + stageIndex);
      }
      
      function viewAssessors() {
         doQnr("viewAssessors&dropBC=true"
            + "&roleHandle=<c:out value='${model.roleHandle}' />"
            + "&areaHandle=<c:out value='${model.dimAreaHandle}' />");
      }
      
      function doQnr(method, anchor) {
         var f = document.forms.questionnaireForm;
         f.action = "<%=request.getContextPath()%>/Scenario.do"
            + "?method=" + method
            + "&itemIndex=<c:out value="${model.itemIndex}" />";
         if (typeof(anchor) != 'undefined') {
            f.action += anchor;
         }
         f.submit();
      }
      
      function setWorkflowExpanded(expanded) {
         var f = document.forms.questionnaireForm;
         f.workflowExpanded.value = expanded;
      }
      
      function popupCloser_refresh() {
         var anchor = "#" + popupAnchor.substring(12);
         doQnr("view", anchor);
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/Questionnaire">
         <mon:ToolBar>
            <c:if test="${not model.preview}">
               <c:if test="${model.canEdit}">
                  <mon:Button name="actionButtonOpen" onclick="doQnr('edit')">
                     <fmt:message key="application.button.open.txt" />
                  </mon:Button>
               </c:if>
               <c:if test="${model.canEndEdit}">
                  <mon:Button name="actionButtonClose" onclick="doQnr('endEdit')">
                     <fmt:message key="application.button.close.txt" />
                  </mon:Button>
               </c:if>
               <c:if test="${model.canSave}">
                  <mon:Button name="actionButtonSave" onclick="doQnr('save')">
                     <c:if test="${model.draft}">
                        <fmt:message
                           key="application.button.saveDraft.txt" />
                     </c:if>
                     <c:if test="${not model.draft}">
                        <fmt:message key="application.button.save.txt" />
                     </c:if>
                  </mon:Button>
               </c:if>
               <c:if test="${model.canSubmit}">
                  <mon:Button name="actionButtonSubmit" onclick="doQnr('submit')">
                     <fmt:message key="Questionnaire.button.submit.txt" />
                  </mon:Button>
               </c:if>
               <c:if test="${model.canValidate}">
                  <mon:Button name="actionButtonValidate"
                     onclick="doQnr('validate')">
                     <fmt:message key="application.button.validate.txt" />
                  </mon:Button>
               </c:if>
               <c:if test="${model.canReturn}">
                  <mon:Button name="actionButtonReturn" onclick="doQnr('returnToStage')">
                     <fmt:message key="application.button.return.txt" />
                  </mon:Button>
               </c:if>
            </c:if>
            <c:if test="${not model.preview}">
               <mon:Button name="actionButtonExport" onclick="doQnr('export')">
                  <fmt:message key="application.button.export.txt" />
               </mon:Button>
            </c:if>
            <mon:Button name="actionButtonCancel" onclick="doQnr('cancel')">
               <c:if test="${model.preview}">
                  <fmt:message key="application.ok.txt" />
               </c:if>
               <c:if test="${(not model.preview) && model.readOnly}">
                  <fmt:message key="application.button.done.txt" />
               </c:if>
               <c:if
                  test="${(not model.preview) && (not model.readOnly)}">
                  <fmt:message key="application.button.cancel.txt" />
               </c:if>
            </mon:Button>
         </mon:ToolBar>

         <mon:Content>
            <html:hidden property="handle" />
            <html:hidden property="errorCheckingMode" />
            <html:hidden property="workflowExpanded" />

            <table border="0" cellspacing="0" width="100%">
               <tr>
                  <td width="100%">
                  <table border="0">
                     <c:if test="${not empty model.dueDate}">
                        <tr>
                           <th style="white-space: nowrap;"
                              class="fieldlabel"><fmt:message
                              key="assessment.field.dueDt.displayName.txt" />:&nbsp;</th>
                           <td class="field"
                              style="white-space: nowrap;"><c:out
                              value="${model.dueDate}" /></td>
                        </tr>
                     </c:if>
                     <c:if test="${not empty model.reportingPeriod}">
                        <tr>
                           <th style="white-space: nowrap;"
                              class="fieldlabel"><fmt:message
                              key="assessment.field.assessmentPeriod.displayName.txt" />:&nbsp;</th>
                           <td class="field"><c:out
                              value="${model.reportingPeriod}" /></td>
                        </tr>
                     </c:if>
                     <c:if test="${not model.preview}">
                        <tr>
                           <th style="white-space: nowrap;"
                              class="fieldlabel"><fmt:message
                              key="application.Attachments.txt" />:&nbsp;</th>
                           <td><mon:AttachmentsTable
                              attachmentContainer='<%= model.getAnswerSheet() %>'
                              readOnly='<%= model.isReadOnly() %>'
                              minimal='true' />
                           </td>
                        </tr>
                        <tr>
                           <td colspan="2"><img border="0"
                              align="absmiddle"
                              src="<%=request.getContextPath()%>/<fmt:message key="Assessments.viewAssessors.image" />" />
                           <a href="javascript:viewAssessors()"><fmt:message
                              key='Assessments.questionnaires.button.viewAssessors.txt' /></a>
                           </td>
                        </tr>
                     </c:if>
                  </table>
                  </td>
                  <td>&nbsp;</td>
                  <td valign="top">
                  <table border="0" width="100%">
                     <tr>
                        <td style="white-space: nowrap;"><fmt:message
                           key="Questionnaire.questionsCompleted.txt" />:&nbsp;</td>
                        <td
                           style="white-space: nowrap; vertical-align: top;">
                        <%-- begin progress indicator --%>
                        <table cellspacing="0">
                           <tr valign="middle">
                              <td>
                              <table border="0" cellpadding="0"
                                 cellspacing="1" bgcolor="#999999"
                                 width="100">
                                 <tr>
                                    <td bgcolor="#ffcc33"
                                       width="<c:out value="${model.percentComplete}" />"
                                       align="center"><c:if
                                       test="${model.percentComplete > 0}">&nbsp;</c:if>
                                    <c:if
                                       test="${model.percentComplete >= 50}">
                                       <c:out
                                          value="${model.answeredCount}" />
                                    </c:if></td>
                                    <td bgcolor="#ffffff"
                                       width="<c:out value="${100 - model.percentComplete}" />">
                                    <c:if
                                       test="${model.percentComplete < 50}">
                                       <c:out
                                          value="${model.answeredCount}" />
                                    </c:if> <c:if
                                       test="${model.percentComplete < 100}">&nbsp;</c:if>
                                    </td>
                                 </tr>
                              </table>
                              </td>
                              <td>&nbsp;<c:out
                                 value="${model.questionCount}" /></td>
                           </tr>
                        </table>
                        <%-- end progress indicator --%></td>
                     </tr>
                     <tr>
                        <td style="white-space: nowrap;"><fmt:message
                           key="application.status.txt" />:</td>
                        <td class="field" style="white-space: nowrap;"><c:out
                           value="${model.status}" /></td>
                     </tr>
                  </table>
                  </td>
               </tr>
            </table>

            <br />

            <mon:DimAreaChooser
               dimensionalAreaHandle="<%= model.getDimAreaHandle() %>"
               readOnly="true" />

            <br />

            <c:if test="${not empty reviewersBlockModel}">
               <jsp:include page="../../commonBlocks/reviewers.jsp"
                  flush="true">
                  <jsp:param name="scrollable" value="false" />
                  <jsp:param name="collapsed" value="<%= collapsed %>" />
                  <jsp:param name="expandMethod"
                     value="setWorkflowExpanded" />
               </jsp:include>
               <br />
            </c:if>

            <c:if test="${empty model.assessedItems}">
               <b><fmt:message key="displayTable.empty.fmt.txt" /></b>
               <p />
            </c:if>

            <c:forEach items="${model.assessedItems}" var="assessedItem"
               varStatus="status">

               <%-- render the questions/answers for this page --%>
               <c:if test="${status.index == model.itemIndex}">
                  <%
                     QuestionnaireModel.AssessedItemModel aim = (QuestionnaireModel.AssessedItemModel) pageContext
                  											.findAttribute("assessedItem");
                  									final String externalId = aim
                  											.getPrimaryItem().getExternalId();
                  %>
                  <table cellpadding="0" cellspacing="1" border="0"
                     class="section" width="100%">
                     <tr>
                        <td class="section">
                        <div class="sectionheader">
                        <div class="sectionheadertext">&nbsp;<img
                           id="item_body_toggle_img"
                           src="<fmt:message key='application.minus.image'/>"
                           border="0" width="9" height="9"> &nbsp;<%= StringUtil.escapeHTML(aim.getPrimaryItemLabel()) + ": "
											+ StringUtil.escapeHTML(aim.getPrimaryItemName())%></div>
                        </div>
                        <!-- sectionheader -->

                        <table cellspacing="10" class="sectionbody"
                           id="item_body" width="100%">
                           <tr>
                              <td class="sectionbody">

                              <table border="0" cellspacing="5">
                                 <tr>
                                    <td><c:out
                                       value="${assessedItem.primaryItemLabel}" />:</td>
                                    <td class="field"><c:if
                                       test="${not empty assessedItem.primaryItemUri && not model.preview}">
                                       <a
                                          href="javascript:doQnr('forward&path=<%=ParsingUtils
												.escape(ParsingUtils.escape(aim
														.getPrimaryItemUri()))%>')">
                                    </c:if><c:out
                                       value="${assessedItem.primaryItemPath}" /><c:if
                                       test="${not empty assessedItem.primaryItemUri && not model.preview}">
                                       </a>
                                    </c:if></td>
                                 </tr>
                                 <c:if
                                    test="${not empty assessedItem.primaryItem.description}">
                                    <tr>
                                       <td>&nbsp;</td>
                                       <td><%=StringUtil.escapeHTML(aim.getPrimaryItem()
												.getDescription(locale))%></td>
                                    </tr>
                                 </c:if>
                                 <c:if
                                    test="${assessedItem.context.pathCount > 0}">
                                    <tr>
                                       <td valign="top"><fmt:message
                                          key="Questionnaire.context.txt" />:</td>
                                       <td class="field"><c:forEach
                                          items="${assessedItem.context.contextPaths}"
                                          var="path">
                                          <c:out value="${path}" />
                                          <br />
                                       </c:forEach></td>
                                    </tr>
                                 </c:if>
                              </table>

                              <table cellspacing="0" border="0"
                                 width="100%">

                                 <c:forEach
                                    items="${assessedItem.questionGroups}"
                                    var="questionGroup"
                                    varStatus="qgStatus">
                                    <tr>
                                       <td valign="top"><br />
                                       <%
                                          final QuestionnaireModel.QuestionGroupModel qgm = (QuestionnaireModel.QuestionGroupModel) pageContext
                                       												.findAttribute("questionGroup");
                                       										final AssessmentQuestionGroup qg = qgm
                                       												.getQuestionGroup();

                                       										QuestionGroupTag.writeGroupStart(qg,
                                       												bundle, pageContext,
                                       												model.getPointInTime(),
                                       												psession, false);
                                       										int aIndex = 0;
                                       %> <c:if test="${(qgStatus.index == 0) && hasAttachments}">
                                          <tr>
                                             <td width="100%"
                                                colspan="2"
                                                class="qgrpDescr"
                                                style="padding-top: 0px;">
                                             <span><fmt:message
                                                key="attachment.section.attachments.txt" /></span>:
                                             <mon:AttachmentsTable
                                                attachmentContainer='<%= (AttachmentContainer)request.getAttribute("template") %>'
                                                pointInTime='<%= model.getPointInTime() %>'
                                                readOnly='true'
                                                minimal='true' />
                                             <br />
                                             <br />
                                             </td>
                                          </tr>
                                       </c:if> <c:forEach
                                          items="${questionGroup.questions}"
                                          var="question">
                                          <%
                                             final QuestionnaireModel.QuestionModel qm = (QuestionnaireModel.QuestionModel) pageContext
                                          													.findAttribute("question");
                                          											final AssessmentAnswer answer = qm
                                          													.getAnswer();
                                          											final String handle = answer == null
                                          													? null
                                          													: QuestionTag
                                          															.escapeHandle(answer
                                          																	.getHandleString());
                                          											String score = null;
                                          											String justification = null;
                                          											if (answer != null) {
                                          												score = (String) model
                                          														.getValueMap().get(
                                          																handle);
                                          												justification = (String) model
                                          														.getValueMap()
                                          														.get(QuestionTag.JUSTIFICATION_PREFIX
                                          																+ handle);
                                          											}
                                          %>
                                          <mon:question
                                             question="<%= qm.getQuestion() %>"
                                             answer="<%= answer %>"
                                             showResponses="true"
                                             groupIndex="<%= aIndex++ %>"
                                             number="<%= qm.getNumber() %>"
                                             score="<%= score %>"
                                             justification="<%= justification %>"
                                             pointInTime="<%= model.getPointInTime() %>"
                                             showAttachments="true"
                                             showIds="false"
                                             showNumbers="false"
                                             readOnly='<%= model.isReadOnly() %>' />
                                       </c:forEach> <%
    QuestionGroupTag
 												.writeGroupEnd(pageContext);
 %>
                                       </td>
                                    </tr>
                                 </c:forEach>

                              </table>

                              </td>
                           </tr>
                        </table>
                        <!-- sectionbody --></td>
                     </tr>
                  </table>
                  <!-- section -->
                  <script type="text/javascript">
                     setCollapsible('item_body', 'item_body_toggle_img');
                  </script>
               </c:if>

            </c:forEach>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>

