<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>

<%
   ScenarioWizardModel model = ScenarioWizardModel.getInstance(request);
   boolean readOnly = model.isReadOnly();
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
%>

<mon:Page template="wizard">
   <mon:Head>
      <script type="text/javascript">    

      function addUser() {
         popupAnchor = "#users";
         openModal("<%= request.getContextPath() %>/UserQueryForAssessment.do"
            + "?area=" + document.forms.scenarioWizardForm.location.value,
            "notify_users_popup", "width=750,height=500,scrollbars,resizable");
      }
      
      function removeUser(user) {
         beginWait();
         document.forms.scenarioWizardForm.user.value = user;
         goWizard("removeUser");
      }
      
      function userSelected(user) {
         beginWait();
         document.forms.scenarioWizardForm.user.value = user;
         goWizard("addUser");
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            <input type="hidden" name="user" value="" />
  
            <mon:maintainWizardState/>
                 
            <mon:DimAreaChooser 
               property="location"
               excludedDimensions="RiskEventType"
               readOnly="true"
               feature="Scenario"
            />
                  
            <br/>
            
            <a name="users"></a>
            <mon:table class="displayTable" cellspacing="0" name="users" id="user">
               <mon:title><fmt:message key="notifyList.users.section.txt" /></mon:title>
            <%
               if (!readOnly)
               {
            %>
                  <mon:action href="javascript:addUser();"><fmt:message key="notifyList.addUser.button.txt" /></mon:action>
            <%
               }
            %>
               
               <display:column title='<%= bundle.getString("user.field.userId.displayName.txt") %>'><c:out value="${user.userId}"/></display:column>
               <display:column title='<%= bundle.getString("user.field.displayNm.displayName.txt") %>'><c:out value="${user.displayNm}"/></display:column>
               <display:column title='<%= bundle.getString("user.field.emailTxt.displayName.txt") %>'><c:out value="${user.emailTxt}"/></display:column>
            <%
               if (!readOnly)
               {
            %>
                  <display:column width='1%' title='<%= bundle.getString("application.remove.txt") %>' align='center' headerClass="nwc">
                     <a href="javascript:removeUser('<c:out value="${user.handleString}" />')"><img 
                        border="0" src="<fmt:message key='application.remove.image' />"  
                        alt="<fmt:message key='application.remove.txt'/>" 
                        title="<fmt:message key='application.remove.txt'/>"/></a></display:column>
            <%
               }
            %>
            </mon:table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

  