<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ScenarioWizardForm" %>

<%
	final Locale locale = request.getLocale();
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final ScenarioWizardForm form = 
		(ScenarioWizardForm)request.getAttribute("scenarioWizardForm");
	request.setAttribute("fresh", form.isFresh());
	
   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
		+ bundle.getString("application.selectAll.tooltip.txt") + "\" />";
%>

<mon:Page template="wizard">
   <mon:Head>
      
      <mon:include js="/script/checkboxRadioUtil.js" />
      
      <script type="text/javascript">    
      
      function viewAssessors(roleHandle, areaHandle) {
         goWizard("viewPositionAssessors"
            + "&roleHandle=" + roleHandle
            + "&areaHandle=" + areaHandle, 
            "previous");
      }
      
      function preview(answerSheetHandle) {
         goWizard("previewAnswerSheet&answerSheetHandle=" + answerSheetHandle, "previous");
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
           
            <input type="hidden" name="positions_isSet" value="true" />
              
            <mon:maintainWizardState/>
                 
            <mon:DimAreaChooser 
               property="location"
               excludedDimensions="RiskEventType"
               readOnly="true"
               feature="Scenario"
            />
                  
            <br/>
              
            <mon:table width="100%" scrollHeight="210px" class="displayTable" cellspacing="0"
                       name="positionContainerList" id="positionContainer">
            <%
               PositionContainer p = (PositionContainer) pageContext.findAttribute("positionContainer");
            %>
               <mon:title><fmt:message key="ScenarioWizard.step.scenarios.txt"/></mon:title>    
              
               <display:column width="1%" title="<%= selColTitle %>">
                  <html:multibox property="positions">
                     <%= p.getHandle() %>
                  </html:multibox>
               </display:column>
            
               <display:column title='<%= bundle.getString("position.displayName.txt") %>'>
                  <%= StringUtil.escapeHTML(PositionContainer.getCaption(p.getRole(), p.getArea(), psession)) %>
               </display:column>
               
               <display:column title='<%= bundle.getString("Assessments.questionnaires.assessors.txt") %>'
                     width="1%" align="center" headerClass="nwc">
                  <a href="javascript:viewAssessors('<%= p.getRole().getHandleString() %>', '<%= p.getArea().getHandleString() %>')"><img 
                     src="<%= request.getContextPath() %>/<fmt:message key="Assessments.viewAssessors.image" />"
                     border="0"/></a>
               </display:column>
            
            </mon:table>
            
            <c:if test="${fresh}">
            <script type="text/javascript">
            new CheckboxGroup("scenarioWizardForm", "positions", "selectAll");
            </script>
            </c:if>      
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
  