<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ScenarioWizardForm" %>

<%
	final Locale locale = request.getLocale();
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final ScenarioWizardForm form = 
		(ScenarioWizardForm)request.getAttribute("scenarioWizardForm");
	request.setAttribute("fresh", form.isFresh());
	
   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
		+ bundle.getString("application.selectAll.tooltip.txt") + "\" />";
%>

<mon:Page template="wizard">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">    
      
      function viewAssessors(roleHandle, areaHandle) {
         goWizard("viewScenarioAssessors"
            + "&roleHandle=" + roleHandle
            + "&areaHandle=" + areaHandle, 
            "previous");
      }
      
      function preview(answerSheetHandle) {
         goWizard("previewAnswerSheet&answerSheetHandle=" + answerSheetHandle, "previous");
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            <input type="hidden" name="positions_isSet" value="true" />
  
            <mon:maintainWizardState/>
                 
            <mon:DimAreaChooser 
               property="location"
               excludedDimensions="RiskEventType"
               readOnly="true"
               feature="Scenario"
            />
                  
            <br/>
              
            <mon:table width="100%" scrollHeight="210px" class="displayTable" cellspacing="0" name="answerSheetList" id="answerSheet">
            <%
               AssessmentAnswerSheet a = (AssessmentAnswerSheet) pageContext.findAttribute("answerSheet");
            %>
               <mon:title><fmt:message key="ScenarioWizard.step.scenarios.txt"/></mon:title>    
               
               <display:column title='<%= bundle.getString("position.displayName.txt") %>'>
                  <%= StringUtil.escapeHTML(a.getCaption(psession)) %>
               </display:column>
               
               <display:column title='<%= bundle.getString("Assessments.questionnaires.assessors.txt") %>'
                     width="1%" align="center" headerClass="nwc">
                  <a href="javascript:viewAssessors('<%= a.getRole(psession).getHandleString() %>', '<%= a.getLocation(psession).getHandleString() %>')"><img 
                     src="<%= request.getContextPath() %>/<fmt:message key="Assessments.viewAssessors.image" />"
                     border="0"/></a>
               </display:column>
               
               <display:column title='<%= bundle.getString("application.preview.txt") %>'
                  width="1%" align="center" headerClass="nwc">
                  <a href="javascript:preview('<%= a.getHandleString() %>')"><img 
                     src="<%= request.getContextPath() %>/<fmt:message key="application.preview.image" />"
                     alt="<fmt:message key="application.preview.txt" />"
                     title="<fmt:message key="application.preview.txt" />"
                     border="0"/></a>
               </display:column>
            
            </mon:table>
            
            <c:if test="${fresh}">
            <script type="text/javascript">
            new CheckboxGroup("scenarioWizardForm", "positions", "selectAll");
            </script>
            </c:if>     
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

  