<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.indicators.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.observations.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<% try {
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   IndicatorAccessModel permissions = (IndicatorAccessModel) request.getAttribute("permissions");
   IndicatorPageModel model = (IndicatorPageModel) request.getAttribute("model");
   String context = request.getContextPath();
   String myHandle = (String) request.getAttribute("handle");

   String createObservationURL = 
      context + 
      "/IndicatorDispatch.do?method=createObservation&handle=" + myHandle;

   String createObservationBody = bundle.getString("IndicatorWizard.createObservation.txt");

   String viewObservationURL = 
      context + 
      "/IndicatorDispatch.do?method=editObservation&handle=" + myHandle;

   String exportObservationsBody = bundle.getString("IndicatorWizard.exportObservations.txt");

   String exportObservationsURL =
      context +
      "/ExportObservation?kriHandle=" + myHandle;
%>

<mon:Page template="wizard">
   <mon:Head>
   
   </mon:Head>
   <mon:Body>      
      <html:form action="/IndicatorWizard">      
         <mon:ToolBar/>
         
         <mon:Content>            
            <html:hidden property="handle" />

            <mon:maintainWizardState/>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.observations" id="obs">
              <mon:title><fmt:message key="IndicatorWizard.observationTable.title.txt" /></mon:title>
            
              <mon:action href='<%= exportObservationsURL %>'><%= exportObservationsBody %></mon:action>
            
              <% if ( model.isOwner() && permissions.userCanCreateObservations() && model.isActive() ) { %>
                <mon:action href='<%= createObservationURL %>'><%= createObservationBody %></mon:action>
              <% } %>
            
              <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />
            
              <display:column property="escapedObservationDate"  
                              title='<%= bundle.getString("kriObservation.field.period.displayName.txt") %>'
                              href="<%= viewObservationURL %>" 
                              paramId="obsHandle" paramProperty="obsHandle"  />
            
              <display:column property="score"  
                              title='<%= bundle.getString("kriObservation.field.score.displayName.txt") %>' />
            
              <display:column property="rangeDescription"  
                              title='<%= bundle.getString("kriObservation.field.range.displayName.txt") %>' />
            
              <display:column property="normalizedScore"  
                              title='<%= bundle.getString("kriObservation.field.normalizedScore.displayName.txt") %>' />
            
              <display:column title='<%= bundle.getString("kriObservation.color.column.displayName.txt") %>'>
            <table width="100%"><tr><td style='<c:out value="${obs.colorStyle}" />'>&nbsp;</td></tr></table>
              </display:column>
            
              <display:column title=''>
                <c:if test="${obs.hasAttachments}">
                  <img border="0" style="border:0px;"
                       src="<%= request.getContextPath() %>/<fmt:message key='KriObservationEditor.hasAttachment.image'/>" 
                       alt="<fmt:message key='KriObservationEditor.hasAttachment.tooltip.txt'/>"
                       title="<fmt:message key='KriObservationEditor.hasAttachment.tooltip.txt'/>" /></c:if>
                <c:if test="${not obs.hasAttachments}">&nbsp;</c:if>
              </display:column>
            
            </mon:table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

<% } catch (Throwable t) { t.printStackTrace(); } %>

