<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.indicators.*" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   IndicatorAccessModel permissions = (IndicatorAccessModel) request.getAttribute("permissions");
   IndicatorPageModel model = (IndicatorPageModel) request.getAttribute("model");
   boolean readOnly = permissions.readOnly();
   String context = request.getContextPath();
%>

<mon:Page template="wizard">
   <mon:Head>
   </mon:Head>
   <mon:Body>      
      <html:form action="/IndicatorWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            
            <html:hidden property="handle" />

            <mon:maintainWizardState/>
            
            <mon:DimAreaChooser 
               property="dimensionalAreaHandle"
               readOnly="true" 
               feature="Indicator"
               everywhereAllowed="true"
               rootVisible="true"
               secureObjectClass="<%= Kri.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>"
               />
            
            <table style="width: 100%">
            <tr id="indicator_rangeMin">
              <td>
                <mon:label styleId="rangeMinLabel"
                     key="kriResponseScale.field.rangeMin.displayName.txt" 
                     property="rangeMin" />:
              </td>
              <td>
                <mon:text property="rangeMin" styleId="rangeMin" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
            
            <tr id="indicator_rangeMid1">
              <td>
                <mon:label styleId="rangeMid1Label"
                     key="kriResponseScale.field.rangeMid1.displayName.txt" 
                     property="rangeMid1" requiredField="${indicatorWizardForm.scaleType == '4'}"/> :
              </td>
              <td>
                <mon:text property="rangeMid1" styleId="rangeMid1" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
            <c:if test="${indicatorWizardForm.scaleType == '4'}">
            
            <tr id="indicator_target">
              <td>
                <mon:label styleId="targetValue"
                     key="kri.field.x_target.displayName.txt" 
                     property="customField(x_target)" />:
              </td>
              <td>
                <mon:text property="customField(x_target)" styleId="targetvalue" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
            
                </c:if>
            
            <tr id="indicator_rangeMid2">
              <td>
                <mon:label styleId="rangeMid2Label"
                     key="kriResponseScale.field.rangeMid2.displayName.txt" 
                     property="rangeMid2" requiredField="${indicatorWizardForm.scaleType == '4'}" />:
              </td>
              <td>  
                <mon:text property="rangeMid2" styleId="rangeMid2" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
           
            <tr id="indicator_rangeMax">
              <td>
                <mon:label styleId="rangeMaxLabel"
                     key="kriResponseScale.field.rangeMax.displayName.txt" 
                     property="rangeMax" />: 
              </td>
              <td>
                <mon:text property="rangeMax" styleId="rangeMax" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
            
            <tr id="bigBadFlg">
              <td>
                <mon:label 
                     key="kriTemplate.range.interpretation.txt" 
                     property="bigBadFlg" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
               <html:select property="bigBadFlg">
                <c:choose>
                  <c:when test="${indicatorWizardForm.scaleType == '4'}">
                     <html:option value="targetedCenter" ><fmt:message key="kriTemplate.range.centerGoodness.txt"/></html:option>
                     <html:option value="targetedOutter" ><fmt:message key="kriTemplate.range.outterGoodness.txt"/></html:option>
                  </c:when>
                  <c:otherwise>
                      <html:option value="false"><fmt:message key="kriTemplate.range.increasingGoodness.txt"/></html:option>
                      <html:option value="true" ><fmt:message key="kriTemplate.range.decreasingGoodness.txt"/></html:option>
                  </c:otherwise>
                </c:choose>
                </html:select>
                </c:if>
                <c:if test="${ permissions.readOnly}">
                  <fmt:message key="${interpretationKey}" />
                </c:if>
              </td>
            </tr>
            
            <tr id="relaxRangeFlg">
              <td>
                <mon:label 
                     key="kriResponseScale.field.relaxRangeFlg.displayName.txt" 
                     property="relaxRangeFlg" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <fieldset class="screen-reader-only">
                <legend><mon:label 
                     key="kriResponseScale.field.relaxRangeFlg.displayName.txt" 
                     property="relaxRangeFlg" /></legend>
                <mon:radio property="relaxRangeFlg" value="true"><fmt:message key="yesno.yes.txt"/></mon:radio>
                <mon:radio property="relaxRangeFlg" value="false"><fmt:message key="yesno.no.txt"/></mon:radio>
                </fieldset>
                </c:if>
                <c:if test="${ permissions.readOnly}">
                  <fmt:message key="${relaxRangeKey}" />
                </c:if>
              </td>
            </tr>
            
            <mon:CustFields 
               propertyKey="kri" 
               readOnly="<%= permissions.readOnly() %>" 
               format="table" 
               inOwnTable="false"
               displayHeader="false"
               groupNo="3"
               />
               
            </table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>


