<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   boolean readOnly = true;

   String owner = (String) request.getAttribute( "owner" );
   String unitOfMeasure = (String) request.getAttribute( "unitOfMeasure" );
   String frequencyDesc = (String) request.getAttribute( "frequencyDesc" );

   String interpretationKey = (String) request.getAttribute( "interpretationKey" );
   String interpretation = bundle.getString( interpretationKey );
%>

<mon:Page template="wizard">
   <mon:Head>
      
   </mon:Head>
   <mon:Body>      
      <html:form action="/KriDefinitionWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:maintainWizardState/>
            
            <mon:DimAreaChooser 
               property="dimensionalAreaHandle"
               readOnly="true" 
               feature="IndicatorDefinition"
               everywhereAllowed="true"
               rootVisible="true"
               secureObjectClass="<%= KriTemplate.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>"
               />
            
            <table id="kriTemplateEditor" border="0" width="100%">
            
            <tr id="activeFlg">
              <td>
                <mon:label 
                     key="kriTemplate.field.activeFlg.displayName.txt" 
                     property="kriTemplateId" />:
              </td>
              <td>
                <%= ApplicationProperties.getProperty( (String) request.getAttribute("isActiveKey"), locale ) %>
              </td>
            </tr>
            
            <tr id="nameTxt">
              <td>
                <mon:label 
                      key="businessObjectLocalization.field.nameTxt.displayName.txt" 
                      property="nameTxt" />:
              </td>
              <td>
                <mon:text property="nameTxt" size="30" maxlength="100"
                     readonly="<%= readOnly %>" />
              </td>
            </tr>
            
            <tr id="kriDefinition_owner">
              <td>
                <mon:label key='kriTemplate.field.owner.displayName.txt'
                     property="owner" separatorVisible="true" />
              </td>
              <td><%= owner %></td>
            </tr>
            
            <tr id="kriDefinition_unitOfMeasure">
              <td>
                <mon:label styleId="unitOfMeasureLabel"
                     key="unitOfMeasure.displayName.txt" 
                     property="unitOfMeasureHandle" />:
              </td>
              <td><%= unitOfMeasure %></td>
            </tr>
            
            <tr id="kriDefinition_kriFrequency">
              <td>
                <mon:label styleId="kriFrequencyLabel"
                     key="kriTemplate.field.kriFrequencyCd.displayName.txt" 
                     property="kriFrequencyCd" />:
              </td>
              <td><%= frequencyDesc %></td>
            </tr>
            
            <tr id="kriDefinition_rangeMin">
              <td>
                <mon:label styleId="rangeMinLabel"
                     key="kriResponseScale.field.rangeMin.displayName.txt" 
                     property="rangeMin" />:
              </td>
              <td>        
                <mon:text property="rangeMin" styleId="rangeMin" size="20" maxlength="20"
                      readonly="<%= readOnly %>"/>
              </td>
            </tr>
            
            <tr id="kriDefinition_rangeMid1">
              <td>
                <mon:label styleId="rangeMid1Label"
                     key="kriResponseScale.field.rangeMid1.displayName.txt" 
                     property="rangeMid1" /> :
              </td>
              <td>
                <mon:text property="rangeMid1" styleId="rangeMid1" size="20" maxlength="20" 
                      readonly="<%= readOnly %>"/>
              </td>
            </tr>
            <c:if test="${kriDefinitionWizardForm.scaleType == '4'}">
            
            <tr id="kriDefinition_target">
              <td>
                <mon:label styleId="targetValue"
                     key="kriTemplate.field.x_target.displayName.txt" 
                     property="customField(x_target)" />:
              </td>
              <td>
                <mon:text property="customField(x_target)" styleId="targetvalue" size="20" maxlength="20" readonly="<%= readOnly %>" />
              </td>
            </tr>
            
                </c:if>
            <tr id="kriDefinition_rangeMid2">
              <td>
                <mon:label styleId="rangeMid2Label"
                     key="kriResponseScale.field.rangeMid2.displayName.txt" 
                     property="rangeMid2" />:
              </td>
              <td>     
                <mon:text property="rangeMid2" size="20" maxlength="20"
                      readonly="<%= readOnly %>"/>
              </td>
            </tr>
            
            <tr id="kriDefinition_rangeMax">
              <td>
                <mon:label styleId="rangeMaxLabel"
                     key="kriResponseScale.field.rangeMax.displayName.txt" 
                     property="rangeMax" />:
              </td>
              <td>  
                <mon:text property="rangeMax" styleId="rangeMax" size="20" maxlength="20" 
                      readonly="<%= readOnly %>"/>
              </td>
            </tr>
            
            <tr id="bigBadFlg">
              <td>
                <mon:label 
                     key="kriTemplate.range.interpretation.txt" 
                     property="bigBadFlg" />:
              </td>
              <td><%= interpretation %></td>
            </tr>
            
            </table>            
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

