<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.*" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.component.AuditTestTableComponent" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil" %>
<%@ page import="com.sas.oprisk.server.logical.DimensionalAreaHandle" %>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext" %>
<%@ page import="com.sas.oprisk.server.logical.TesterPool" %>
<%@ page import="java.util.*" %>

<mon:setBundle />

<%
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   final AuditModel model = (AuditModel)request.getAttribute(AuditAction.ATTR_MODEL);
   final String auditHandle = model != null ? model.getHandleString() : "";
   
   final UIContext uiContext = UIContextUtil.getUIContext(request);
   final String uiContextId = uiContext.getUIContextId();
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
   final boolean readOnly = model != null ? model.isReadOnly() : true;
   
   Boolean canPublishFromCPB = (Boolean)request.getAttribute(AuditTestTableComponent.CAN_PUBLISH_INDIVIDUAL_TEST);
   
%>

<script type="text/javascript">

   function showTestInstance(handle) {
      var path = "/TestInstanceEditor.do?handle=" + handle 
         + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=" + "<%= auditHandle %>";
      document.forms.auditForm.action="<%= request.getContextPath() %>" 
         + "/Audit.do?method=forward" 
         + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=" + "<%= auditHandle %>" 
         + "&path=" + path;
      document.forms.auditForm.submit();
   }
   
   function deleteTest( handle, id) {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
         "audit.scope.deleteTest.confirm.msg.fmt.txt")) %>");
      msg = formatMessage(msg, id);
      if (confirm(msg)) {
         var f = document.forms.auditForm;
         f.action = "<%= request.getContextPath() %>" + "/Audit.do?method=deleteTest" 
            + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=<%= auditHandle %>&testHandle=" + handle;
         f.submit();
      } 
   }
   
   function assignTesters(){
      var values = getSelectedCheckboxValues(document.forms.auditForm, "testHandle");
      if (values.length == 0){
         alert("<fmt:message key='audit.validation.noTestSelected.msg.txt'/>");
      }
      else {
         openModal(
            "<%= request.getContextPath() %>" 
            + "/AuditAssignTesters.do?method=view" 
            + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=<%= auditHandle %>" 
            + "&uid=<%= uiContextId %>"
            + "&tests=" + values,
            "potentialTestersPopup", 
            "width=680,height=480,scrollbars,resizable,status");
      }
   }
   
   function deleteMultipleTests(){
      var values = getSelectedCheckboxValues(document.forms.auditForm, "testHandle");
      if (values.length == 0){
         alert("<fmt:message key='audit.validation.noTestSelected.msg.txt'/>");
      }
      else {
         var msg = unescape("<%= ParsingUtils.escape(
              bundle.getString("audit.scope.deleteMultiTest.confirm.msg.txt")) 
         %>");
         if (confirm(msg)){
            var f = document.forms.auditForm;
            f.action = "<%= request.getContextPath() %>" + "/Audit.do?method=deleteTest" 
               + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=<%= auditHandle %>&testHandle=" + values;
            f.submit();
         }
      }
   }
   
   function doAssignAuditors(userHandle, testHandle){
         var f = document.forms.auditForm;
         f.selectedAuditors.value = userHandle;
         f.selectedTests.value = testHandle;
         f.action="<%= request.getContextPath() %>" 
            + "/Audit.do?method=assignAuditors" 
            + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=" + "<%= auditHandle %>";
         f.submit();
   }
   
   function publishTests(handle){
      var f = document.forms.auditForm;
      f.selectedTests.value = handle;
      f.action="<%= request.getContextPath() %>" 
         + "/Audit.do?method=publishTests" 
         + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=" + "<%= auditHandle %>";
      f.submit();
   }
   
   function showTestsContextMenu(handle, id, canPublish) {
      var menu = new TableMenu();
      menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='audit.scope.publishTest.image'/>", "<fmt:message key='audit.scope.publishTest.title.txt'/>", "javascript:publishTests('" + handle + "')", canPublish));      
      menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.delete.image'/>","<fmt:message key='application.delete.txt'/>","javascript:deleteTest('" + handle + "', unescape('" + escape(id) + "'))"));
      menu.render();
      return false;
   }
   
</script>

<input type="hidden" name="selectedTests" />
<input type="hidden" name="selectedAuditors" />

<c:if test="${uiContext.neverBeenSaved}">   
   <span class="infoMessage"><img align="absmiddle" src="<%= request.getContextPath() %>/images/MessageInform_16.gif">
   <fmt:message key="audit.viewTestsAfterSave.txt" /></span>
</c:if>
<c:if test="${not uiContext.neverBeenSaved}">   
<mon:tableComponent entryName="tests" id="test" wizCursor="refresh"  >
   <mon:title><fmt:message key="testDefinition.section.controls.txt"/></mon:title>
   <% 
   AuditScopeTestEntry testEntry = (AuditScopeTestEntry)pageContext.findAttribute("test");
      boolean isPublished = testEntry == null ? false : 
      							testEntry.isPublished();
       String poolStr = testEntry == null ? "" : testEntry.getAssignedAuditors();
      String status = testEntry == null ? "" : testEntry.getLatestStatus();
      String testPlanId = testEntry == null ? "" : testEntry.getTestPlanId();
      Boolean canIndPub = Boolean.FALSE;
      if (canPublishFromCPB != null && canPublishFromCPB.booleanValue()){
         canIndPub = Boolean.valueOf(!isPublished);
      }
   %>
   
   <%
      if (!readOnly){ 
   %>
      <mon:action href="javascript:assignTesters()"><fmt:message key="audit.scope.action.assignTesters.txt" /></mon:action>&nbsp;|&nbsp;
      <mon:action href="javascript:deleteMultipleTests()"><fmt:message key="audit.scope.action.deleteTests.txt" /></mon:action>
      
      <mon:fixedColumn width="10" title="<%= selColTitle %>">
         <% if (isPublished) { %>
            <input type="checkbox" name="testHandle" value="<c:out value="${test.handle}" />" disabled="disabled" />
         <% } else { %>
            <input type="checkbox" name="testHandle" value="<c:out value="${test.handle}" />" />
         <% } %>
      </mon:fixedColumn>
      
      <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%" >
         &nbsp;<a href="#" onclick="return showTestsContextMenu('<c:out value="${test.handle}" />', '<%= StringUtil.escapeJSForHTMLAttribute(testPlanId) %>', <%= canIndPub %>)">
               <img border="0" src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"/>
         </a>&nbsp;
      </mon:fixedColumn>
      
   <% } %>
</mon:tableComponent>
<c:if test="${hasInvisibleTests}">
   <mon:InfoMessage>
      <fmt:message key="linkedBusinessObjects.hasInvisibleItems.txt"/>
   </mon:InfoMessage>
</c:if>

<script type="text/javascript">
   new CheckboxGroup("auditForm", "testHandle", "selectAll");
</script>
</c:if> 