<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.controlProfile.ControlProfileEntry" %>
<%@ page import="com.sas.oprisk.monitor.web.table.QueryParameters" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.tests.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.controlProfile.CertificationCellFormatter" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   final Boolean canUserCreateCert = (Boolean)request.getAttribute("canUserCreateCert");
   
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("lastTestMeasures",   new TestMeasureCellFormatter(mc)); 
   formatters.put("lastTestConclusions", new TestConclusionCellFormatter(mc));
   formatters.put("lastCertificate", new CertificationCellFormatter(mc));
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createControlInstance() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ControlInstance.do"
               + "?method=create";
         //f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createMultipleControlsCertification(){
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/MultipleControlsCertificationEdit.do"
               + "?method=create";
         f.submit();
      }
      
      
      function deleteControlInstance(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "ControlInstance.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goControlInstance("delete", handle, false);
         }
      }
      
      function goControlInstance(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ControlInstance.do"
               + "?method=" + method
               + "&fromControlTesting=true"
               + "&handle=" + handle;
         document.forms.queryForm.submit();
      }
      
      function createTestDefinition(handle){
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/TestDefinitionEdit.do"
               + "?method=createWithControlInstance&handle=" + handle;
         f.submit();
      }
      
      function linkTestDefinitions(handle){
         openModal(
            "<%= request.getContextPath() %>" 
            + "/LinkTestDefinitionEdit.do?method=view&handle="
            + handle + "&isReadOnly=true&isPopup=true",
            "LinkTestDefinitionPopup", 
            "width=650,height=450,scrollbars,resizable,status");
      }
      
      function createCertification(handle){
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ControlCertificationEdit.do"
               + "?method=create" + "&handle=" + handle;
         f.submit();
      }
      
      function showContextMenu(handle, name, isPartial, canCreateCert, canDeleteControl) {
         var menu = new TableMenu();
         var canCreateTestDef = <c:out value="${canCreateTestDef}" />;
         var canUpdateTestDef = <c:out value="${canUpdateTestDef}" />;
         
      
             menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
               "<fmt:message key='application.createNew.image'/>",
               "<fmt:message key='controlTesting.createTestDefinition.title'/>",
               "javascript:createTestDefinition('" + handle + "')", canCreateTestDef && ! isPartial ));
      
             menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
               "<fmt:message key='application.createNew.image'/>",
               "<fmt:message key='controlTesting.linkTestDefinition.title'/>",
               "javascript:linkTestDefinitions('" + handle + "')", canUpdateTestDef && ! isPartial ));
      
             menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
               "<fmt:message key='application.createNew.image'/>",
               "<fmt:message key='controlInstance.createCertification.txt'/>",
               "javascript:createCertification('" + handle + "')", canCreateCert && ! isPartial ));
         
             menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<fmt:message key='application.delete.image'/>", 
               "<fmt:message key='application.button.delete.txt'/>", 
               "javascript:deleteControlInstance('" + handle + "', '" + name + "')", canDeleteControl ));
         
         menu.render();
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body> 
   <%
   Boolean canDeleteControl = (Boolean)request.getAttribute("canDeleteControl");
   %>     
      <html:form action="/ControlProfileQuery">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:tableComponent id="controlInstanceEx" columnFormatters="<%= formatters %>"  >
            <mon:title><fmt:message key="Control.title.txt"/></mon:title>
         <%
         
             final ControlTestingControlInstance controlInstanceEx = (ControlTestingControlInstance)pageContext.findAttribute("controlInstanceEx");
              
             if (controlInstanceEx != null) {
               ControlInstance controlInstance = ControlInstance.object.fetch(controlInstanceEx.getControlInstRk(), psession);
               final String ctrlInstNm = ParsingUtils.escape(controlInstanceEx.getControlInstNm());
               final Boolean isPartial = new Boolean(controlInstanceEx.isPartial(psession));
               final Boolean canCreateCert = controlInstanceEx.getCanCreateCertifications(psession); 
               final String ctrlInstHandleString = controlInstanceEx.getHandleString();
               boolean bCanDeleteThisControl = canDeleteControl == null ? true : canDeleteControl.booleanValue();
               bCanDeleteThisControl &=     !controlInstance.hasReferencesInAssessment(psession) 
                                        && !controlInstance.hasReferencesInTestDefinition(psession)
                                        && !controlInstance.hasReferencesInTest(psession) 
                                        && !controlInstance.hasReferencesInAudit(psession);
               Boolean canDeleteThisControl = new Boolean(bCanDeleteThisControl);
               pageContext.setAttribute("isPartial", isPartial);
               pageContext.setAttribute("canCreateCert", canCreateCert);      
               
         %>
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
               &nbsp;<a href="#" onclick="return showContextMenu('<%= ctrlInstHandleString %>', '<%= ctrlInstNm %>', <%= isPartial %>, <%= canCreateCert %>, <%= canDeleteThisControl %>)"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                   alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                   title="<fmt:message key='application.rowActions.tooltip.txt'/>"
               /></a>&nbsp;
            </mon:fixedColumn>
         
         <%
            }
         %>
            <c:if test="${canCreateControl}">
               <mon:action href="javascript:createControlInstance();"><fmt:message key='controlInstance.create.txt'/></mon:action>
            </c:if>    
            <c:if test="${canUserCreateCert}">
               <mon:action href="javascript:createMultipleControlsCertification();"><fmt:message key='controlTesting.createMultipleControlsCertification.title.txt'/></mon:action>
            </c:if>
          
         </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
