<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ include file="/tiles/taglibs.jsp" %>

<mon:setBundle />

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   final Boolean readOnlyBoolean = (Boolean)request.getAttribute("readOnly");
   final boolean readOnly = (readOnlyBoolean != null)? readOnlyBoolean.booleanValue() : true ;
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAllPolicies\" title=\"" 
         + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
   final String exportUrl = request.getContextPath() + "/TestDefinitionEdit.do?method=export&entryId=businessPolicies";
%>

<mon:include js="/script/checkboxRadioUtil.js" />

<script type="text/javascript">
   function addPolicies() {      
      openModal(
            "<%= request.getContextPath() %>" 
            + "/BusinessPolicyChooserQuery.do?tdHandle="
            + document.forms[0].handle.value,
            "businessPoliciesPopup", 
            "width=680,height=480,scrollbars,resizable,status");
   }

   function addSelectedPolicies(selectionArray) {
      // store selection array in hidden field
      document.forms.testDefinitionCPBForm.policiesToAddOrRemove.value = selectionArray;
      
      // submit form and add selected controlds
      doTestDef("modifyPolicies", "add");
   }

   function removePolicy(handle, name) {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString("testDefinition.removePolicy.confirm.message.fmt.txt")) %>");
      msg = formatMessage(msg, name);
      if (confirm(msg)) {
         document.forms.testDefinitionCPBForm.policiesToAddOrRemove.value = handle;
         doTestDef("removePolicy", "remove");
      }
   }  
</script>

<input type="hidden" name="policiesToAddOrRemove" />
<mon:tableComponent entryName="businessPolicies" id="policy" exportXlsUrl="<%= exportUrl %>" wizCursor="refresh" >
    <%
      final BusinessPolicyEx entry = (BusinessPolicyEx)pageContext.findAttribute("policy");
      String policyName = "";
      if(entry != null)
         policyName = entry.getName();
    %>
   <!-- This title tag is not actually used. The title is specified in Custom Page XML label tag -->
   <mon:title><fmt:message key="testDefinition.section.businessPolicy.txt"/></mon:title>
   <% if (!readOnly) { %>
      <mon:action href='javascript:addPolicies()'><fmt:message key='testDefinition.title.businessPolicy.add.txt'/></mon:action>&nbsp;|&nbsp;
      <mon:fixedColumn width='1%' title='<%= bundle.getString("application.remove.txt") %>' before="false" >
         <a href="javascript:removePolicy('<c:out value='${policy.handleString}'/>', '<%= StringUtil.escapeJSForHTMLAttribute(policyName) %>')" >
            <img border="0" src="<fmt:message key='application.remove.image' />"  
               alt="<fmt:message key='application.remove.txt'/>" 
               title="<fmt:message key='application.remove.txt'/>"/>
         </a>
      </mon:fixedColumn>                
                      
   <% } %>
</mon:tableComponent>
