<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
%>

<mon:Page template="popup">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
         parent.allowParentToClose = function() {
            // Since this was called from an onClose() event, start a timer that will
            // re-sync the currentDialog variable when the new window is loaded.
               this.window.setTimeout(resyncCurrentDialog, 1000);
         
            return false;
         }
      
         function resyncCurrentDialog() {
            if ((typeof(opener.currentDialog) != 'undefined') &&
                  (opener.currentDialog == null)) 
            {
                  opener.setModalDialog(window);
                  return;
            }
         
         // parent window isn't ready, wait for a bit and try again 
            this.window.setTimeout(resyncCurrentDialog, 1000);
      }
         //public
         function doAddSelections(bClose) {
            var selections = addAndContinue();     
            if (selections == null) {
               alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
            } else {
               //invoke the parent's[TestDefinition] javascript method to add the selected controls in it's page.
               window.opener.addSelectedControls(selections);
               if (bClose) { 
                 window.close(); 
               }
            }
         }
         
         //private
         function addAndContinue() {
            //getSelectedCheckboxValues method defined in the checkboxRadioUtil.js
            var values = getSelectedCheckboxValues(document.forms[0], "controlHandle");
            return (values.length == 0) ? null : values;
         }
         
         //shows the control instance in a new popup window as readonly. The new window closes once "Done" viewing.
         function showControlInstance(handle) {    
            openModal(
                  "<%= request.getContextPath() %>" 
                  + "/ControlInstance.do?method=select&handle="
                  + handle + "&readOnly=true&popup=true",
                  "controlInstancePopup", 
                  "width=650,height=450,scrollbars,resizable,status");
            }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ControlInstancesQuery">      
         
         <mon:Content>
             <input type="hidden" name="tdHandle" value="<%= StringUtil.escapeHTML(request.getParameter("tdHandle")) %>"/>

             <mon:tableComponent id="controlInstances" wizCursor="refresh">
                <mon:title><fmt:message key="testDefinition.section.controls.txt"/></mon:title>       
                <mon:fixedColumn width="10" title="<%= selColTitle %>">
                  <input type="checkbox" name="controlHandle" value="<c:out value="${controlInstances.taggedPointerHandle}" />" />
                </mon:fixedColumn>
             </mon:tableComponent>
             
             <script type="text/javascript">
               new CheckboxGroup("queryForm", "controlHandle", "selectAll");
             </script>
         </mon:Content>   
         
         <mon:PopupButtonBar>
            <mon:Button name="add" onclick="doAddSelections(false)">
               <fmt:message key='application.button.add.txt' />
            </mon:Button>
         
            <mon:Button name="addAndClose" onclick="doAddSelections(true)">
               <fmt:message key='application.button.addAndClose.txt' />
            </mon:Button>

            <mon:Button name="close" onclick="window.close();">
               <fmt:message key='closeButton.txt' />
            </mon:Button>          
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>

