<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
%>

<mon:Page template="popup">
   <mon:Head>
      <mon:title><fmt:message key="controlTesting.linkTestDefinitions.title.txt"/></mon:title> 
      <script type="text/javascript">
         <mon:include js="/script/checkboxRadioUtil.js" />
         parent.allowParentToClose = function() {
           // Since this was called from an onClose() event, start a timer that will
           // re-sync the currentDialog variable when the new window is loaded.
              this.window.setTimeout(resyncCurrentDialog, 1000);
         
           return false;
         }
      
         function resyncCurrentDialog() {
           if ((typeof(opener.currentDialog) != 'undefined') &&
             (opener.currentDialog == null)) 
              {
                    opener.setModalDialog(window);
                    return;
              }
         
           // parent window isn't ready, wait for a bit and try again 
              this.window.setTimeout(resyncCurrentDialog, 1000);
                     }
                     
         //public
         function doAddSelections(bClose) {
            var selections = addAndContinue();     
            if (selections == null) {
               alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
            } else {
               //invoke the parent's[controlprofiles] javascript method to add the link to selected test definitions.
               linkSelectedTestDefinitions(selections, bClose);
               if (bClose) { 
                 window.close(); 
               }
            }
         }
         
         //private
         function addAndContinue() {
            //getSelectedCheckboxValues method defined in the checkboxRadioUtil.js
            var values = getSelectedCheckboxValues(document.forms[0], "testDefinitionHandle");
            return (values.length == 0) ? null : values;
         }
         
         //shows the test definition in a new popup window as readonly. The new window closes once "Done" viewing.
         function showTestDefinition(handle) {     
            openModal(
                  "<%= request.getContextPath() %>" 
                  + "/TestDefinitionEdit.do?method=select&handle="
                  + handle + "&isReadOnly=true&isPopup=true",
                  "TestDefinitionPopup", 
                  "width=750,height=550,scrollbars,resizable,status");
            }
      
         function linkSelectedTestDefinitions(selections, bClose) {     
            var f = document.forms.queryForm;
            f.action =
               "<%= request.getContextPath() %>/LinkTestDefinitionEdit.do"
                  + "?method=link&testDefinitionsToLink=" + selections + "&bClose=" + bClose;
            f.submit();
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/LinkTestDefinitionEdit">          
         <mon:Content>
            <!-- input type="hidden" name="handle" value="<c:out value="${uiContext.handle}" />" /--> 
         <!-- input type="hidden" name="tdHandle" value="<%= StringUtil.escapeHTML(request.getParameter("tdHandle")) %>"/-->
             <input type="hidden" name="ciHandle" value="<%=(String)request.getAttribute("ciHandle")%>"/>
         
             <mon:tableComponent id="testDefinitions" >
                <mon:title><fmt:message key="controlCertification.linkTestDefinitions.table.title.txt"/></mon:title>       
                <mon:fixedColumn width="10" title="<%= selColTitle %>">
                  <input type="checkbox" name="testDefinitionHandle" value="<c:out value="${testDefinitions.handle}" />" />
                </mon:fixedColumn>
             </mon:tableComponent>
             
             <script type="text/javascript">
               new CheckboxGroup("queryForm", "testDefinitionHandle", "selectAll");
             </script>
         </mon:Content>   
         <mon:PopupButtonBar>
            <mon:Button name="addButton" onclick="doAddSelections(false)">
               <fmt:message key='application.button.add.txt' />
            </mon:Button>
            <mon:Button name="addAndCloseButton" onclick="doAddSelections(true)">
               <fmt:message key='application.button.addAndClose.txt' />
            </mon:Button>
            <mon:Button name="closeButton" onclick="window.close()">
               <fmt:message key='closeButton.txt' />
            </mon:Button>
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>

