<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.server.dataload.*" %>
<%@ page import="com.sas.oprisk.framework.server.dataload.metadata.*" %>
<%@ page import="com.sas.oprisk.server.dataload.metadata.*" %>
<%@ page import="com.sas.oprisk.framework.server.dataload.*" %>

<%!
private String buildLocaleSpecificSampleLink( HttpServletRequest request, String loaderName )
{
   String ctx = request.getContextPath();
   String sampleServlet = com.sas.oprisk.monitor.web.dataload.actions.SampleSpreadsheetServlet.NAME;
   return ctx + "/" + sampleServlet + "?loader=" + StringUtil.encodeURLValue(loaderName);
}

private String buildLocaleIndependentSampleLink( HttpServletRequest request, String loaderName )
{
   return buildLocaleSpecificSampleLink( request, loaderName) + "&ignoreLocale=true";
}
%>

<%
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   
   Loader loader = (Loader) request.getAttribute( "model" );
   String loaderName = request.getParameter( "loader" );
   String localName = loader.getLocalLoaderName( locale );

   String l1 = buildLocaleSpecificSampleLink(request, loaderName);
   String l2 = buildLocaleIndependentSampleLink(request, loaderName);

   String msg = ApplicationProperties.getMessage("dataload.sampleSpreadsheet.message.txt", locale,
      new Object[] {l1, l2} );
%>

<mon:Page template="popup">
   <mon:Head>
      <script type="text/javascript">

      function cancelPopup( ) {
         window.close();
      }
      
      </script>
   </mon:Head>
   <mon:Body>                  
         <mon:Content>
            <h2><%= StringUtil.escapeHTML(localName) %></h2>

            <p><%= msg %></p>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.model.sortedColumns" id="col">
               <mon:title><fmt:message key="dataload.registry.details.table.txt"/></mon:title>
               
               <display:column property="id" 
                     title='<%= bundle.getString("dataload.registry.details.key.txt") %>' />
            
               <display:column title='<%= bundle.getString("dataload.registry.details.localName.txt") %>'>
            <%
                    Column column = (Column) col;
                    String localColumnName = ColumnIdentifier.localColumnName( column.getId(), locale );
            %>
                  <%= StringUtil.escapeHTML(localColumnName) %>
                  </display:column>
                  
            </mon:table>
         </mon:Content> 
         <mon:PopupButtonBar>
            <mon:Button name="okButton" onclick="cancelPopup();">
               <fmt:message key='application.ok.txt' />
            </mon:Button>
         </mon:PopupButtonBar>    
   </mon:Body>
</mon:Page>

