<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceSession" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.treechooser.SearchTreeAction" %>
<%@ page import="com.sas.oprisk.monitor.web.table.TableComponentTag" %>

<%-- ****************************************************************** --%>
<%-- DimensionViewer.jsp --%>
<%-- ****************************************************************** --%>

<%    
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final String scopeHandle = (String) request.getAttribute("scopeHandle");
   final DimensionalPoint scopeDomain = (DimensionalPoint) request.getAttribute("scopeDomain");
   final Boolean isModal = (Boolean) request.getAttribute("isModal");
   final Boolean canAdd = (Boolean) request.getAttribute("canAdd");
   final DimensionalArea deletableArea = DimRelationElement.object.areaWhereUserCan(Do.DELETE, psession);
   final DimensionalArea updatableArea = DimRelationElement.object.areaWhereUserCan(Do.UPDATE, psession);
   String pathSeparator = com.sas.oprisk.server.util.PathUtils.getPaddedPathSeparator();
   
   String busObjTypeName = BusinessObjectTypeInfo.DIM_RELATION_ELEMENT.getBusinessObjectTypeName(); 
   Map customFieldMap = CustomFieldDescriptorManager.getCustFieldDescriptorsMap(busObjTypeName);
   Map nodeCustomFieldValueMap = (Map)request.getAttribute("relationNodeCustFieldMap");
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
      function doRefresh() {
         var f = document.forms.dimensionBrowserForm;
         f.method.value = '<% 
            if (isModal.booleanValue()) out.print("viewRelationsModal");
            else out.print("viewRelations"); %>';
         f.submit();
      }
      
      function traverse(dp) {
         var f = document.forms.dimensionBrowserForm;
         f.dimensionalPoint.value = dp;
         doRefresh();
      }
      
      function owner(dre) {
         var f = document.forms.dimensionBrowserForm;
         f.action = 'Dimension.do?method=viewOwnersModal&dimRelationElement=' + dre;
         f.submit();
      }
      
      function addMapping() {
         var f = document.forms.dimensionBrowserForm;
         f.method.value = 'addMappingModal';
         f.submit();
      }
      
      function removeSelectedMappings() {
         var f = document.forms.dimensionBrowserForm;
         if (!hasAnySelectedCheckboxes(f, 'selectedForDeletionMappings')) {
            alert("<fmt:message key='DimensionRelations.mustSelectOne.txt'/>");
            return;
         }
         if (confirm("<fmt:message key='DimensionRelations.removeSelected.confirm.txt'/>")) {
            f.method.value = 'removeSelectedMappings';
            f.submit();
         }
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/Dimension">  
         
         <mon:Content>
            <input type="hidden" name="method" />
   
            <html:hidden property="dimRelationElement" />
            <html:hidden property="handle" />
            <html:hidden property="parentHandle" />
            <html:hidden property="dimension" />
            <html:hidden property="isModal" />
         
         
            <mon:DimPointChooser 
               property="dimensionalPoint"
               feature="Mappings"
               secureObjectClass="<%= DimRelationElement.class.getName() %>"
                 secureAction="<%= Do.READ.getValue() %>"
               selectMethod="doRefresh"
               readOnly="<%= isModal.booleanValue() %>"
               rootVisible="true" />
               
            <p/>
            <p/>
         
            <table border="0">
            <tr>
             <td colspan="2">
               <fmt:message key="DimensionRelations.relationType.txt"/>&nbsp;
             </td>
            </tr>
            <tr>
             <td>
               <mon:select property="relation" onchange="doRefresh()">
                  <html:options name="request" 
                     collection="relationTypes" 
                     property="value" 
                     labelProperty="label" />
               </mon:select>
             </td>
             <td>
               &nbsp;&nbsp;
               <html:multibox onclick="doRefresh()" 
                  property="showInherited">true</html:multibox>&nbsp;
               <fmt:message key="DimensionRelations.showInherited.txt"/>
             </td>
            </tr>
            </table>
            
            <p/>
            <p/>
            
            <!-- Mappings -->
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.relationNodes" id="elt">
               <mon:title><fmt:message key="DimensionRelations.codomainNodes.txt"/></mon:title>
         
               <c:if test="${canCreate}">
                  <mon:action href="javascript:addMapping()"><fmt:message key='DimensionRelations.add.link.txt'/></mon:action>&nbsp;|&nbsp;
               </c:if>
         <%
               if (elt != null) {
         %>
                  <c:if test="${canDelete}">
                  <mon:action href="javascript:removeSelectedMappings()"><fmt:message key='DimensionRelations.removeSelected.title'/></mon:action>
                  </c:if>
         <%
                  final String delimiter = "<br/>";
                  final DimRelationElement dimRelElement = (DimRelationElement) elt;
                  final boolean isExcluded = dimRelElement.isExcluded();
                  final User owner = dimRelElement.getOwner(psession);
                  final DimensionalPoint domain = dimRelElement.getDomain(psession);
                  final DimensionalPoint legalDomain = dimRelElement.getDomainWithLegalDimsOnly(psession);
                  final DimensionalPoint codomain = dimRelElement.getCodomain(psession);
                  final DimensionalPoint drePoint = dimRelElement.getDimensionalPoint(psession);
                  final Double relativeWeight = dimRelElement.getRelativeWeight();
                  final String externalId = codomain.getExternalId();
                  // can edit this dre?
                  pageContext.setAttribute("canEdit", Boolean.valueOf(drePoint.isUnder(updatableArea)));
         %>    
               <display:column width='20'>
         <%       if (isExcluded) {
         %>         <img border="0" src="<fmt:message key='application.excludedMapping.image'/>"
                         alt="<fmt:message key='application.excludedMapping.tooltip.txt'/>" 
                         title="<fmt:message key='application.excludedMapping.tooltip.txt'/>"/>
         <%       } else if (drePoint.getHandleString().equals(scopeHandle) ||
                        domain.getHandleString().equals(scopeHandle)) {
                  if (drePoint.isUnder(deletableArea)) {
         %>         <html:multibox property="selectedForDeletionMappings">
                      <c:out value='${elt.handleString}'/>
                    </html:multibox>
         <%       } else { 
         %>         <img border="0" src="<fmt:message key='application.identifiedMapping.image'/>"
                         alt="<fmt:message key='application.identifiedMapping.tooltip.txt'/>" 
                         title="<fmt:message key='application.identifiedMapping.tooltip.txt'/>"/>
         <%       }                
                  } else if (!scopeDomain.getHandleString().equals(legalDomain.getHandleString()) &&
                              (  ConfigDataProperties.useMappingStrategyRollup() || scopeDomain.isUnder(legalDomain))) { 
         %>          <img border="0" src="<fmt:message key='application.inheritedMapping.image'/>"
                         alt="<fmt:message key='application.inheritedMapping.tooltip.txt'/>" 
                         title="<fmt:message key='application.inheritedMapping.tooltip.txt'/>"/>
         <%       } else {
                  // don't show an icon at all
         %>&nbsp;<%
                  }
         %>
               </display:column>
               
               <!-- Display Relative Weight -->
               <display:column title='<%= bundle.getString("dimRelationElement.field.relativeWeight.displayName.txt") %>'>
                  <%= (relativeWeight != null) ?  relativeWeight.toString() : "&nbsp;" %>
               </display:column>
               
               <!-- Display External Id -->
               <display:column title='<%= bundle.getString("application.id.txt") %>'>
                  <%= (externalId != null) ?  StringUtil.escapeHTML(externalId) : "" %>
               </display:column>
         
               <!-- Domain / Dimensional Point -->
               <display:column title='<%= bundle.getString("dimRelationElement.field.dimensionalPoint.displayName.txt") %>'>
         <%
               if (!(domain.getHandleString().equals(scopeHandle))) {
         %>       
                  <%= StringUtil.escapeHTML(domain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter) %>
         <%    } else {
                  out.print(StringUtil.escapeHTML(domain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter));
               }
         %>    </display:column>
               
               <!-- Codomain / Name -->
               <display:column title='<%= bundle.getString("businessObjectLocalization.field.nameTxt.displayName.txt") %>'>
                  <%= StringUtil.escapeHTML(codomain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter) %>
               </display:column>
               
         <%
                  Iterator customFieldIter = customFieldMap.values().iterator();
                  while (customFieldIter.hasNext())
                  {
                     FieldDescriptor fd = (FieldDescriptor)customFieldIter.next();
                     String customFieldLabelKey =
                        busObjTypeName + ".field." + fd.getName() + ".displayName.txt";
                     String customFieldValue = "";
                     if (nodeCustomFieldValueMap != null)
                     {
                        Object obj = TableComponentTag.getRawCustomFieldValue(
                           nodeCustomFieldValueMap, dimRelElement, fd, locale, false);
                        if (obj != null)
                           customFieldValue = obj.toString();
                     }
         %>    
               <display:column title='<%= ApplicationProperties.getProperty(customFieldLabelKey, locale) %>'>
                  <%= StringUtil.isEmpty(customFieldValue) ? "&nbsp;" : StringUtil.escapeHTML(customFieldValue) %>
               </display:column>
         <%    
                  }
         %>
               
               <display:column title='<%= bundle.getString("ControlWizard.step.owner.txt") %>'>
         <%
                  if (owner != null) { 
         %>          
                  <c:if test="${canEdit}">
                  <a href="javascript:owner('<%= dimRelElement.getHandleString() %>')">
                     <img border="0" align="absmiddle" src="images/user.png"/>&nbsp;</c:if><%= StringUtil.escapeHTML(owner.getFriendlyName(locale)) %><c:if test="${canEdit}"></a></c:if>
         <%       } else {
         %>          <c:if test="${canEdit}">
                     <a href="javascript:owner('<%= dimRelElement.getHandleString() %>')">
                     <img border="0" align="absmiddle" src="images/adduser.png"/></a></c:if>
         <%       }
         %>
               </display:column>
               
         <%      
               }
         %>
            </mon:table>
            
            <p/>
            <p/>
            
            <c:if test="${isModal}">
               <div class="commandButtons">
               <input type="button" style="width: 100"
                class="button"
                onmouseover="this.className='button buttonRollover'"
                onmouseout="this.className='button'"
                value="<fmt:message key='application.ok.txt' />"
                onclick="breadcrumb('dimensionBrowserForm', 2)" />
              </div> 
            </c:if>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>