<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.split.*" %>

<mon:setBundle />

<mon:include js="/script/checkboxRadioUtil.js" />

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);

   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
		+ bundle.getString("application.selectAll.tooltip.txt") + "\" />";

   String KEEP_KEY = SplitWizardState.KEEP_KEY;
   String MOVE_KEY = SplitWizardState.MOVE_KEY;
   String COPY_KEY = SplitWizardState.COPY_KEY;
   
   String keepString = ParsingUtils.escape( bundle.getString( KEEP_KEY ) );
   String copyString = ParsingUtils.escape( bundle.getString( COPY_KEY ) );
   String moveString = ParsingUtils.escape( bundle.getString( MOVE_KEY ) );

%>

<script type="text/javascript">
  var actionLabels = [];
  actionLabels['<%= KEEP_KEY %>'] = unescape('<%= keepString %>');
  actionLabels['<%= COPY_KEY %>'] = unescape('<%= copyString %>');
  actionLabels['<%= MOVE_KEY %>'] = unescape('<%= moveString %>');

function updateAction(checkbox,action) {
  // fix the hidden form field
  var handle = checkbox.value;
  var newValue = handle + '=' + action;
  //array syntax doesn't work in IE
  //document.forms.splitWizardForm.elements[handle].value = newValue;
  var hiddenField = document.getElementById(handle);
  hiddenField.value = newValue;

  // fix the cell contents
  var elt = document.getElementById(handle+'_cell');
  elt.innerHTML = actionLabels[action];
}

function updateActions() {
  var actionList = document.getElementById('actionList');
  action = actionList.value;
  if (action == "") return;
  var inputs = document.forms.splitWizardForm.elements;
  for (var idx = 0; idx < inputs.length; idx++) {
    var f = inputs[idx];

//  find by type works fine for firefox but not IE.
//  var fieldType = getType(f);
//  if ( (fieldType == "checkbox") && (f.checked) ) {

    var name = f.name;
    if ( ( name == 'ignored' ) && ( f.checked ) ) {
      updateAction(f,action);
      f.checked = false;
    }
    else if ( name == 'selectAll' ) {
      f.checked = false;
    }
  }

  actionList.selectedIndex = 0;
}
</script>

<html:form action="/SplitWizard" >
  
<mon:maintainWizardState/>

<mon:table width="100%" scrollHeight="275px" class="displayTable" cellspacing="0" name="requestScope.wizardState.causeInstanceState.causeInstanceEntries" id="causeInstance">
  <mon:title><fmt:message key="SplitWizard.causeInstanceTable.title.txt" /></mon:title>

  <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />

  <display:column width="1%" title="<%= selColTitle %>">
	<html:multibox property="ignored"><c:out value='${causeInstance.encodedHandle}'/></html:multibox>
	<input type='hidden' id='<c:out value="${causeInstance.encodedHandle}"/>' name="causeInstanceActions" value='<c:out value="${causeInstance.encodedString}"/>' />
  </display:column>

  <display:column title='<%= bundle.getString("SplitWizard.causeInstanceTable.action.column.txt") %>'>
    <span id='<c:out value="${causeInstance.encodedHandle}" />_cell'><fmt:message key="${causeInstance.actionKey}" /></span>
  </display:column>

  <display:column title='<%= bundle.getString("SplitWizard.causeInstanceTable.name.column.txt") %>'><c:out value="${causeInstance.name}"/></display:column>

  <display:column title='<%= bundle.getString("SplitWizard.causeInstanceTable.context.column.txt") %>'><c:out value="${causeInstance.context}"/></display:column>

</mon:table>

<p>&nbsp;</p>

<p>
<fmt:message key="SplitWizard.causeInstanceTable.markSelected.label.txt" />
<select id='actionList' onchange='updateActions();'>
  <option>&nbsp;</option>
  <option value='<%= MOVE_KEY %>'><fmt:message key="SplitWizard.causeInstanceTable.move.option.txt"/></option>
  <option value='<%= COPY_KEY %>'><fmt:message key="SplitWizard.causeInstanceTable.copy.option.txt"/></option>
  <option value='<%= KEEP_KEY %>'><fmt:message key="SplitWizard.causeInstanceTable.keep.option.txt"/></option>
</select>
</p>

<script type="text/javascript">
new CheckboxGroup("splitWizardForm", "ignored", "selectAll");
</script>

</html:form>