<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.split.*" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);

   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
		+ bundle.getString("application.selectAll.tooltip.txt") + "\" />";

   String KEEP_KEY = SplitWizardState.KEEP_KEY;
   String MOVE_KEY = SplitWizardState.MOVE_KEY;
   String COPY_KEY = SplitWizardState.COPY_KEY;
   
   String keepString = ParsingUtils.escape( bundle.getString( KEEP_KEY ) );
   String copyString = ParsingUtils.escape( bundle.getString( COPY_KEY ) );
   String moveString = ParsingUtils.escape( bundle.getString( MOVE_KEY ) );

%>

<mon:Page template="wizard">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <script type="text/javascript">
        var actionLabels = [];
        actionLabels['<%= KEEP_KEY %>'] = unescape('<%= keepString %>');
        actionLabels['<%= COPY_KEY %>'] = unescape('<%= copyString %>');
        actionLabels['<%= MOVE_KEY %>'] = unescape('<%= moveString %>');
      
      function updateAction(checkbox,action) {
        // fix the hidden form field
        var handle = checkbox.value;
        var newValue = handle + '=' + action;
        //array syntax doesn't work in IE
        //document.forms.splitWizardForm.elements[handle].value = newValue;
        var hiddenField = document.getElementById(handle);
        hiddenField.value = newValue;
      
        // fix the cell contents
        var elt = document.getElementById(handle+'_cell');
        elt.innerHTML = actionLabels[action];
      }
      
      function updateActions() {
        var actionList = document.getElementById('actionList');
        action = actionList.value;
        if (action == "") return;
        var inputs = document.forms.splitWizardForm.elements;
        for (var idx = 0; idx < inputs.length; idx++) {
          var f = inputs[idx];
      
      //  find by type works fine for firefox but not IE.
      //  var fieldType = getType(f);
      //  if ( (fieldType == "checkbox") && (f.checked) ) {
      
          var name = f.name;
          if ( ( name == 'ignored' ) && ( f.checked ) ) {
            updateAction(f,action);
            f.checked = false;
          }
          else if ( name == 'selectAll' ) {
            f.checked = false;
          }
        }
      
        actionList.selectedIndex = 0;
      }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/SplitWizard">      
         <mon:ToolBar/>
         
         <mon:Content>            
            <mon:maintainWizardState/>
            
            <mon:table width="100%" scrollHeight="275px" class="displayTable" cellspacing="0" name="requestScope.wizardState.supportiveQuestionnaireState.supportiveQuestionnaireEntries" id="supportiveQuestionnaire">
              <mon:title><fmt:message key="SplitWizard.supportiveQuestionnaireTable.title.txt" /></mon:title>
            
              <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />
            
              <display:column width="1%" title="<%= selColTitle %>">
               <html:multibox property="ignored"><c:out value='${supportiveQuestionnaire.encodedHandle}'/></html:multibox>
               <input type='hidden' id='<c:out value="${supportiveQuestionnaire.encodedHandle}"/>' name="supportiveQuestionnaireActions" value='<c:out value="${supportiveQuestionnaire.encodedString}"/>' />
              </display:column>
            
              <display:column title='<%= bundle.getString("SplitWizard.supportiveQuestionnaireTable.action.column.txt") %>'>
                <span id='<c:out value="${supportiveQuestionnaire.encodedHandle}" />_cell'><fmt:message key="${supportiveQuestionnaire.actionKey}" /></span>
              </display:column>
            
              <display:column title='<%= bundle.getString("SplitWizard.supportiveQuestionnaireTable.name.column.txt") %>'><c:out value="${supportiveQuestionnaire.name}"/></display:column>
            
              <display:column title='<%= bundle.getString("SplitWizard.supportiveQuestionnaireTable.context.column.txt") %>'><c:out value="${supportiveQuestionnaire.context}"/></display:column>
            
            </mon:table>
            
            <p>&nbsp;</p>
            
            <p>
            <fmt:message key="SplitWizard.supportiveQuestionnaireTable.markSelected.label.txt" />
            <select id='actionList' onchange='updateActions();'>
              <option>&nbsp;</option>
              <option value='<%= MOVE_KEY %>'><fmt:message key="SplitWizard.supportiveQuestionnaireTable.move.option.txt"/></option>
              <option value='<%= COPY_KEY %>'><fmt:message key="SplitWizard.supportiveQuestionnaireTable.copy.option.txt"/></option>
              <option value='<%= KEEP_KEY %>'><fmt:message key="SplitWizard.supportiveQuestionnaireTable.keep.option.txt"/></option>
            </select>
            </p>
            
            <script type="text/javascript">
            new CheckboxGroup("splitWizardForm", "ignored", "selectAll");
            </script>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
