<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorRequest" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.IncidentModel" %>
<%@ page import="com.sas.oprisk.server.logical.DimensionalArea" %>
<%@ page import="java.util.*" %>
<%     
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   IncidentModel model = (IncidentModel)request.getAttribute("model");
   Boolean readOnly = (Boolean)request.getAttribute("readOnly");
   String handle = model.getHandle();
   final MonitorContext mcontext = MonitorRequest.getMonitorContext(request);
   Boolean canAddFailedControl = (Boolean)request.getAttribute("canAddFailedControl");
   
   String exportUrl = request.getContextPath() + "/IncidentWizardFailedControlsQuery.do?opRiskEventHandle=" + handle + "&entryId=failedControls";   
   String exportUrlForEffectFailedControls = request.getContextPath() + "/IncidentWizardFailedControlsQuery.do?opRiskEventHandle=" + handle + "&entryId=effectFailedControls";
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = model.getDeleteConfirmationMessage(psession);
%>
<%@ taglib uri="http://www.sas.com/oprisk/monitor/tags" prefix="mon" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<mon:Page>
<%-- BEGIN PAGE --%>

   <mon:Head>
   <%-- BEGIN HEAD --%>
<script type="text/javascript">
function wizardInit() {
   // override wizardInit so that buttons are not disabled
}

function addFailedControl() {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=createFailedControl";
   f.submit();
}

function removeFailedControl(handle) {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=removeFailedControl&controlHandle=" + handle;
   f.submit();
}

function removeEffectFailedControl(handle) {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=removeEffectFailedControl&controlHandle=" + handle;
   f.submit();
}

function editFailedControl(handle) {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=editFailedControl&controlHandle=" + handle;
   f.submit();
}

function editEffectFailedControl(handle) {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=editEffectFailedControl&controlHandle=" + handle;
   f.submit();
}

function selectControlInstance() {
   openModal(
      "<%= request.getContextPath() %>" 
         + "/LinkToControlInstanceChooserQuery.do?riHandle="
         + document.forms[0].handle.value,
      "controlInstancePopup", 
      "width=680,height=480,scrollbars,resizable,status");
}

function addControlInstance() {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=addFailedControl";
   f.submit();
}

function mapControlInstance(handle) {
   var f = document.forms.incidentWizardForm;
   f.action = "<%= request.getContextPath() %>/IncidentWizard.do?method=createFailedControl&controlHandle=" + handle;
   f.submit();
}
</script>
   <%-- END HEAD --%>
   </mon:Head>
   
   <mon:Body>
   <%-- BEGIN BODY --%>
      
      <html:form action="/IncidentWizard">
      
      <mon:ToolBar>
      <%-- BEGIN TOOL BAR --%>
      <%-- END TOOL BAR --%>
      </mon:ToolBar>
      
      <mon:Content>
      <%-- BEGIN CONTENT --%>
   <input type="hidden" name="eventHandle" value="<%= StringUtil.escapeHTML(handle) %>" />

   <html:hidden property="opRiskEventId" />
   <html:hidden property="opRiskEventRk" />
   <html:hidden property="referenceNo" />
   <html:hidden property="validationStateCd" />
   <html:hidden property="eventTypeCd" />
   <html:hidden property="handle" />
   <html:hidden property="activeFlg" />
   <html:hidden property="thresholdExceededMsg" />
   
      <script type="text/javascript">
          function confirmGoWizard(methodName, buttonName) {
            <% if (!changeReasonRequired) { %>
            if (methodName == 'delete'){
               return confirm(unescape("<%= deleteConfirmMsg %>"));
            }
            else {
               return true;
            }
            <% } else {%>
            return true;
            <% } %>
          }
      </script>
     
    <mon:maintainWizardState />
    <div id="incident_failedControls">
    <mon:tableComponent id="control" entryName="failedControls" exportXlsUrl="<%= exportUrl %>" wizCursor="failedControls" >    
      <mon:title><fmt:message key="IncidentWizard.incident.failedControls.label.txt"/></mon:title>
      <c:if test="${ !requestScope.model.readOnly && requestScope.canAddFailedControl }">
          <mon:action href="javascript:addControlInstance();"><fmt:message key='incident.investigate.addFailedControl.txt' /></mon:action>
      </c:if>
      <c:if test="${!requestScope.model.readOnly && canDeleteFailedControl}">
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.delete.txt") %>' >
                <a href="javascript:removeFailedControl('<c:out value='${control.handle}' />')" ><img 
                   src="<fmt:message   key='application.delete.image' />" border="0"
                   alt="<fmt:message   key='application.delete.tooltip.txt' />"
                   title="<fmt:message key='application.delete.tooltip.txt' />" /></a>            
      </mon:fixedColumn>
      </c:if>
    </mon:tableComponent>
    <c:if test="${hasInvisibleFailedControls}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
    </c:if>
    </div>
   <br/>
   <br/>
   <div id="incident_effectFailedControls">
    <mon:tableComponent id="control" entryName="effectFailedControls" exportXlsUrl="<%= exportUrlForEffectFailedControls %>" wizCursor="failedControls" >        
      <mon:title><fmt:message key="IncidentWizard.effect.failedControls.label.txt"/></mon:title>
      <c:if test="${!requestScope.model.readOnly && canDeleteFailedControl}">
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.delete.txt") %>' >
                <a href="javascript:removeEffectFailedControl('<c:out value='${control.handle}' />')" ><img 
                   src="<fmt:message   key='application.delete.image' />" border="0"
                   alt="<fmt:message   key='application.delete.tooltip.txt' />"
                   title="<fmt:message key='application.delete.tooltip.txt' />" /></a>            
      </mon:fixedColumn>
      </c:if>
    </mon:tableComponent>
    <c:if test="${hasInvisibleFailedControlsForEffects}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
    </c:if>
    </div>
      <%-- END CONTENT --%>
      </mon:Content>
   
      </html:form>
      
   <%-- END BODY --%>
   </mon:Body>
   
<%-- END PAGE --%>
</mon:Page>