<%@ page import="java.util.*"%>
<%@ page import="java.io.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.framework.themes.client.Image" %>

<%@ page errorPage="pageError.jsp" %>

<%@ include file="/tiles/taglibs.jsp" %>
<%@taglib uri='http://www.sas.com/taglib/sas-uis' prefix='sas-uis' %>

<mon:setBundle />
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--****************************************************************************-->
<!-- Copyright (c) 2008 by SAS Institute Inc., Cary, NC, USA.                   -->
<!-- All Rights Reserved.                                                       -->
<!--****************************************************************************-->
<!-- NAME:     popup.jsp                                                        -->
<!-- VERSION:  4.1                                                              -->
<!-- DESCRIPTION:  jsp that's used in the popup windows.                        -->
<!--                                                                            -->
<!-- PRODUCT:  SAS(r) OpRisk Monitor                                            -->
<!--****************************************************************************-->


<mon:html>
<head>

   <sas:InitializeComponents/>
   <sas:StyleSheet styleNames="SAS Style,orm,orm_IE,custom,CPB,CPBDialog,CPBSpellChecker"/>
   <sas-uis:Timeout dialog="true"/> 
   
<%
   final ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   String title = (String)pageContext.findAttribute("title");
   if (!Boolean.FALSE.equals(pageContext.findAttribute("titleIsKey"))) {
      try {
         if (title != null)
         {
            title = bundle.getString(title);
         }
      } catch (MissingResourceException mre) {
         title = "???" + title + "???";
      }
   }
   
   request.setAttribute("displayTitle", title);
%>
   <title><%= StringUtil.escapeHTML(title, "&") %></title>
   
   <tiles:insert attribute="modalScriptIncludes" />
   <tiles:insert attribute="styleAndScriptIncludes" />
   
   <%-- Hooks for other head includes --%>
   <tiles:insert attribute="include-head" />
   <mon:include js="/components/table/QueryFilter.js" />
   <mon:include js="/components/table/QueryEditor.js" />
   <mon:include js="/components/table/Customizer.js" />
   <mon:include flush="true" />
</head>

<body onload="monitorInit()" class="central" style="font-size: 12px;"
  dir='<%= LayoutDirection.getLayoutDirection(request) %>'>

<table cellpadding="0" cellspacing="0" style="width: 100%;">
<tr>
   <td><jsp:include page="bannerMenuBar.jsp" /></td>
</tr>
<tr>
   <td>
      <div id="content">
         <c:if test="${hasMenu}">
      	   <h1><%= StringUtil.escapeHTML(title, "&") %></h1>
         </c:if>
         <tiles:insert attribute="contentActions" />
      
         <c:if test="${hasMenu}">
            <div style="height:15px;"></div>	   
         </c:if>
         <tiles:insert attribute="messages" />
         <tiles:insert attribute="content" />
      
         <div id="footer">
            <tiles:insert attribute="footer" />
         </div>
      </div>
   </td>
</tr>
</table>

<script type="text/javascript">
window.hide = function()
{
   window.close();
}
</script>
</body>

</mon:html>