<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final User currentUser = (User) psession.getUser();
   boolean canCreate = SecurityUtils.canDoSomewhere(Do.CREATEOUTSIDE, FinancialImpact.object, psession);
   boolean canDeleteEffect   = SecurityUtils.canDoSomewhere(Do.DELETE, FinancialImpact.object, psession);
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = ParsingUtils.escape(bundle.getString("incident.deleteWarning.fmt.txt"));
   String objectStr = ParsingUtils.escape(bundle.getString("financialImpact.directRecovery.displayName.txt"));

%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

         function createDirectRecovery() {
            var f = document.forms[0];
            f.action =
               "<%= request.getContextPath() %>/IncidentRecovery.do"
                  + "?method=create&recovery=direct";
            f.location.value = f.TCArea.value;
            f.submit();
         }
         
         function addDirectRecovery() {
            var f = document.forms[0];
            f.action = "<%= request.getContextPath() %>/DirectRecovery.do" + "?method=create&recovery=direct";
            f.location.value = f.TCArea.value;
            f.submit();
         }
         
         function deleteDirectRecovery(name, handle){
            <% if (!changeReasonRequired) { %>
            var msg = formatMessage(
                  unescape('<%= deleteConfirmMsg %>'), 
                  unescape('<%= objectStr %>'),
                  unescape(name)
                  );
            if (!confirm(msg)) {
               return;
            }
            <% } %>
            doDirectRecovery('delete', handle);
         }
         
         function doDirectRecovery(method, handle) {
            document.forms.queryForm.action = "<%= request.getContextPath() %>/DirectRecovery.do" + "?method=" + method + "&handle=" + handle;
            document.forms.queryForm.submit();
         }
      
         function doLink(url) {
            var f = document.forms.queryForm;
            f.action = url;
            f.submit();
         }
               
         function linkToIncident(handle) {
            openModal("<%= request.getContextPath() %>/LinkToIncidentQuery.do?"
               + "financialImpactHandle=" + handle + "&recovery=direct",
          "link_popup", "width=1100,height=500,scrollbars,resizable");
         }
      
         function moveToIncident(handle) {
            openModal("<%= request.getContextPath() %>/LinkToIncidentQuery.do?"
               + "financialImpactHandle=" + handle + "&recovery=direct",
          "move_popup", "width=1100,height=500,scrollbars,resizable");
         }
      
         function showContextMenu(handle, sharedLossFlg, impactName) {
            var menu = new TableMenu();
            if (sharedLossFlg == "true") {
                menu.addMenuItem(
                        new MenuItem(MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.move.image'/>", 
                           "<fmt:message key='moveButton.txt'/>", 
                         "javascript:moveToIncident('" + handle + "')", 
                           true));
            } else {
                menu.addMenuItem(
                        new MenuItem(MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.link.image'/>", 
                           "<fmt:message key='application.link.txt'/>", 
                      "javascript:linkToIncident('" + handle + "')", 
                           true));
            }
      
            <% if (canDeleteEffect) { %>      
               menu.addMenuItem(
                new MenuItem(MenuItem.prototype.action,
                   "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                   "<fmt:message key='application.delete.txt'/>", 
                     "javascript:deleteDirectRecovery('" + impactName + "', '" + handle + "')",
                   true));
            <% } %>
             
            menu.render();
            return false;
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/DirectRecoveryQuery">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:tableComponent id="directRecovery">
            <% if (canCreate) { %>
               <mon:action href='javascript:addDirectRecovery();'>
                  <fmt:message key='incident.recovery.createDirectRecovery.txt'/>
               </mon:action>
            <% } %>
            
            <%
               RecoveryEvent impact = (RecoveryEvent)pageContext.findAttribute("directRecovery");
               if (impact != null) {
                  Set confidentialFields = ConfidentialFieldRegistry.getConfidentialFields(impact, psession);
                  String impactName = impact.getImpactShortDesc();
                  if (confidentialFields.contains("IMPACTSHORTDESC")) {
                     impactName = "*";
                  }
            %>
            
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
               &nbsp;
               <a href="#" onclick="return showContextMenu('<c:out value='${directRecovery.handleString}'/>', '<c:out value='${directRecovery.sharedLossFlg}'/>', '<%= ParsingUtils.escape(impactName) %>')">
                  <img border="0"
                     src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  />
               </a>
               &nbsp;
            </mon:fixedColumn>
            <% } %>
      
         </mon:tableComponent>
         
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
