<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final User currentUser = (User) psession.getUser();
   boolean canCreateEffect = SecurityUtils.canDoSomewhere(Do.CREATEOUTSIDE, FinancialImpact.object, psession);
   boolean canDeleteEffect   = SecurityUtils.canDoSomewhere(Do.DELETE, FinancialImpact.object, psession);
   boolean canUpdateEffect   = SecurityUtils.canDoSomewhere(Do.UPDATE, FinancialImpact.object, psession);
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = ParsingUtils.escape(bundle.getString("incident.deleteWarning.fmt.txt"));
   String objectStr = ParsingUtils.escape(bundle.getString("financialImpact.financialEffect.displayName.txt"));
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">
         function createEffect() {
            var f = document.forms[0];
            f.action = "<%= request.getContextPath() %>/IncidentDirectEffect.do" + "?method=create";
            f.location.value = f.TCArea.value;
            f.submit();
         }
      
         function addFinancialEffect() {
            var f = document.forms[0];
            f.action = "<%= request.getContextPath() %>/FinancialEffect.do" + "?method=create";
            f.location.value = f.TCArea.value;
            f.submit();
         }
         
         function deleteFinancialEffect(name, handle){
        	   <% if (!changeReasonRequired) { %>
        	   var msg = formatMessage(
        			   unescape('<%= deleteConfirmMsg %>'), 
        			   unescape('<%= objectStr %>'),
        			   unescape(name)
        			   );
        	   if (!confirm(msg)) {
        		   return;
        	   }
        	   <% } %>
        	   doFinancialEffect('delete', handle);
         }
         
         function doFinancialEffect(method, handle) {
            document.forms.queryForm.action = "<%= request.getContextPath() %>/FinancialEffect.do"
                  + "?method=" + method
                  + "&handle=" + handle;
            document.forms.queryForm.submit();
         }
      
         function doLink(url) {
            var f = document.forms.queryForm;
            f.action = url;
            f.submit();
         }
         
         function linkToIncident(handle) {
            openModal("<%= request.getContextPath() %>/LinkToIncidentQuery.do?"
               + "financialImpactHandle=" + handle,
          "link_popup", "width=1100,height=500,scrollbars,resizable");
         }
      
         function moveToIncident(handle) {
            openModal("<%= request.getContextPath() %>/LinkToIncidentQuery.do?"
               + "financialImpactHandle=" + handle,
          "move_popup", "width=1100,height=500,scrollbars,resizable");
         }
      
         
         function showContextMenu(handle, sharedLossFlg, allowDelinking, impactName) {
            var menu = new TableMenu();
      
            <% if (canUpdateEffect) { %>      
               if (sharedLossFlg == "true") {
            if (allowDelinking == "true") {
                 menu.addMenuItem(
                              new MenuItem(MenuItem.prototype.action,
                                 "<%= request.getContextPath() %>/" + "<fmt:message key='application.move.image'/>", 
                                 "<fmt:message key='moveButton.txt'/>", 
                               "javascript:moveToIncident('" + handle + "')", 
                                 true));
            }  
               } else {
                   menu.addMenuItem(
                           new MenuItem(MenuItem.prototype.action,
                              "<%= request.getContextPath() %>/" + "<fmt:message key='application.link.image'/>", 
                              "<fmt:message key='application.link.txt'/>", 
                         "javascript:linkToIncident('" + handle + "')", 
                              true));
               }
            <% } %>
      
            <% if (canDeleteEffect) { %>      
               menu.addMenuItem(
                new MenuItem(MenuItem.prototype.action,
                   "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                   "<fmt:message key='application.delete.txt'/>", 
                     "javascript:deleteFinancialEffect('" + impactName + "', '" + handle + "')", 
                     (allowDelinking == "true")));
            <% } else { %>
               menu.addMenuItem(
                   new MenuItem(MenuItem.prototype.action,
                      "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                      "<fmt:message key='application.delete.txt'/>", 
                      "javascript:deleteFinancialEffect('" + impactName + "', '" + handle + "')", 
                     false));      
            <% } %>
            
            menu.render();
            return false;
         }
         
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/EffectQuery">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:tableComponent id="effect">
            <% if (canCreateEffect) { %>
               <mon:action href='javascript:addFinancialEffect();'>
                  <fmt:message key='incident.effect.createDirectEffect.txt'/>
               </mon:action>
            <% } %>
      
      
            <%
               LossGainEvent impact = (LossGainEvent)pageContext.findAttribute("effect");
               if (impact != null) {
                  Set confidentialFields = ConfidentialFieldRegistry.getConfidentialFields(impact, psession);
                  String impactName = impact.getImpactShortDesc();
                  if (confidentialFields.contains("IMPACTSHORTDESC")) {
                     impactName = "*";
                  }
            %>
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
               &nbsp;
               <a href="#" onclick="return showContextMenu('<c:out value='${effect.handleString}'/>', '<c:out value='${effect.sharedLossFlg}'/>', '<c:out value='${effect.allowDelinking}'/>', '<%= ParsingUtils.escape(impactName) %>')">
                  <img border="0"
                     src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  />
               </a>
               &nbsp;
            </mon:fixedColumn>
            <% } %>
      
         </mon:tableComponent>
      
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
