<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ScenarioTemplateWizardForm" %>

<%
	final ScenarioTemplateWizardForm form = (ScenarioTemplateWizardForm)
		request.getAttribute("form");
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final String sourceSystem = MonitorContext.getMonitorContext(request).getSourceSystemDescription(
		form.getSourceSystemCd(), request.getLocale(), psession);
%>

<mon:Page template="wizard">
   <mon:Head>
      
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioTemplateWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
              <mon:maintainWizardState/>
     
              <mon:DimAreaChooser 
               property="dimensionalArea"
               feature="ScenarioTemplate"
               readOnly="true" />
              
               <p/>
               
               <table width="100%">
                 <tr>
            <td><fmt:message key="questionnaireTemplate.field.scenTempltTypeCd.displayName.txt" />:</td>
            <td>
                    
                       <c:if test="${form.approach == 'BKT'}">
                           <fmt:message key="ScenarioTemplateWizard.approach.bucket.txt" />
                       </c:if>
                       <c:if test="${form.approach == 'REV'}">
                           <fmt:message key="ScenarioTemplateWizard.approach.story.txt" />
                       </c:if>
            </td>
                 </tr>
                 <tr>   
                     <td><fmt:message key="questionnaireTemplate.field.activeFlg.displayName.txt" />:</td>
                     <td>
                       <c:choose>
                       <c:when test="${form.active}">
                           <fmt:message key="yesno.yes.txt" />
                       </c:when>
                       <c:otherwise>
                           <fmt:message key="yesno.no.txt" />
                       </c:otherwise>
                       </c:choose>
            </td>
                 </tr>
                 <tr>   
                    <td><fmt:message key="businessObjectLocalization.field.nameTxt.displayName.txt"/>:</td>
                    <td><c:out value="${form.name}" /></td>
                 </tr>
                 <tr>   
                    <td><fmt:message key="ScenarioTemplateWizard.templateId.label.txt" />:</td>
                    <td><c:out value="${form.scenarioTemplateId}" /></td>
                 </tr>
                 <tr>
                    <td><fmt:message key="businessObjectLocalization.field.descTxt.displayName.txt"/>:</td>
                    <td><c:out value="${form.description}" /></td>
                 </tr>
                 <tr>
                    <td><fmt:message key="questionnaireTemplate.field.sourceSystemCd.displayName.txt" />:</td>
                    <td><%= StringUtil.escapeHTML(sourceSystem) %></td>
                 </tr>
                 <tr>
                    <td><fmt:message key="questionnaireTemplate.field.currCd.displayName.txt" />:</td>
                    <td><c:out value="${form.currencyCd}"/></td>
                 </tr>
                 <tr>
                    <td><fmt:message key="ScenarioTemplateWizard.field.includeNonFinImpact.txt" />:</td>
                    <td>
                       <c:choose>
                       <c:when test="${form.includeNonFinImp}">
                           <fmt:message key="yesno.yes.txt" />
                       </c:when>
                       <c:otherwise>
                           <fmt:message key="yesno.no.txt" />
                       </c:otherwise>
                       </c:choose>
            </td>
                 </tr>
              </table>
              
              <p/>
              <fieldset>
              <legend><fmt:message key="ScenarioTemplateWizard.summary.createNow.txt" /></legend>
              <html:radio property="sendNow" value="true"/><fmt:message key="yesno.yes.txt"/>
              <html:radio property="sendNow" value="false"/><fmt:message key="yesno.no.txt"/>
              </fieldset>
         <br/>
         
         <div class="instructions">
         <fmt:message key="ScenarioTemplateWizard.summary.createLater.txt" />
         </div>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
  