<%@ page import="com.sas.oprisk.monitor.web.validation.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%    
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final ValidationModel model = (ValidationModel)request.getAttribute("model");
   boolean readOnly = model.isReadOnly();
   String template =  readOnly ? "default" : "details";
%>

<mon:Page template="<%= template %>">
   <mon:Head>
      <script type="text/javascript">

      function go( method ) {
         var f = document.forms.validationForm;
         f.method.value = method;
         f.submit();
      }
      
      function doStage(method, handle) {
         var f = document.forms.validationForm;
         f.action = "<%= request.getContextPath() %>/ValidationStage.do";
         f.method.value = method;
         if (handle) {
            f.handle.value = handle;
         }
         f.submit();
      }
      
      function doCreateStage(stageTypeCd) {
         var f = document.forms.validationForm;
         f.action = "<%= request.getContextPath() %>/ValidationStage.do?stageTypeCd="+stageTypeCd;
         f.method.value = 'create';
         f.submit();
      }
      function locationSelected() {
         go("view");
         return false;
      }
      
      function deleteStage(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
               "validationStage.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            doStage("delete", handle);
         }
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/Validation">   
    
         <mon:ToolBar>
<%
   if (!readOnly)
   {
%>
               <c:if test="${model.canEdit}">
                  <mon:Button name="actionButtonSave" onclick="go('save')">
                     <fmt:message key="application.button.save.txt" />
                  </mon:Button>
                  
                  <mon:Button name="actionButtonCancel" onclick="go('view')">
                     <fmt:message key="application.button.cancel.txt" />
                  </mon:Button>                  
               </c:if>
               <c:if test="${not model.canEdit}">
                  <mon:Button name="actionButtonCancel" onclick="go('view')">
                     <fmt:message key="application.button.done.txt" />
                  </mon:Button>                 
               </c:if>
<%
   }
%>
         </mon:ToolBar>
         <mon:Content>
            <input type="hidden" name="method" />
            <input type="hidden" name="handle" />
            <html:hidden property="validationType" />
            <html:hidden property="interestType" />

            <mon:DimPointChooser 
               property="location"
               feature="<%= model.getLocationFeature() %>"
               selectMethod="locationSelected"
               rootVisible="true"
               readOnly="<%= !model.isReadOnly() %>"
               forFiltering="true"
               everywhereAllowed="true"
            />
            
            <br/>
            <c:if test='${model.readOnly}'>
               <h2><fmt:message key='validation.currentStages.title'/></h2>
            </c:if>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" 
               name="requestScope.model.stages" id="stage">
               <mon:title><fmt:message key="validation.stages.txt"/></mon:title>    
               
               <c:if test='${model.readOnly}'>
                  <c:if test='${model.canEdit}'>
                     <mon:action href="javascript:go('edit')">
                        <c:if test='${not empty model.localValidationSequence}'>
                           <fmt:message key='validation.button.editStages.txt'/>
                        </c:if>
                        <c:if test='${empty model.localValidationSequence}'>
                           <fmt:message key='validation.button.createStages.txt'/>
                        </c:if>
                     </mon:action>
                 </c:if>
               </c:if>
               <c:if test='${not model.readOnly and model.canEdit}'>
                  <c:if test='${model.stageTypesEnabled}'>
                     <mon:action href="javascript:doCreateStage('MGT')"> <fmt:message key='validation.button.addStage.management.txt' /></mon:action>
                     <mon:action href="javascript:doCreateStage('RSK')"> <fmt:message key='validation.button.addStage.risk.txt' /></mon:action>
                  </c:if>
                  <c:if test='${!model.stageTypesEnabled}'>
                     <mon:action href="javascript:doStage('create')"><fmt:message key='validation.button.addStage.txt'/></mon:action>
                  </c:if>
               </c:if>
              
               <display:column title='<%= bundle.getString("validationStage.column.number.displayName.txt") %>'>
                  <c:out value="${stage_rowNum}"/>
               </display:column>
                     
               <display:column title='<%= bundle.getString("validationStage.column.name.displayName.txt") %>'>
                  <c:if test='${not model.readOnly}'>
                     <a href="javascript:doStage('edit', '<c:out value="${stage.handle}" />')">
                  </c:if>
                  <c:out value="${stage.name}"/>
                  <c:if test='${not model.readOnly}'>
                     </a>
                  </c:if>
               </display:column>
               
               <display:column title='<%= bundle.getString("validationStage.field.validationStageId.displayName.txt") %>'><c:out value="${stage.validationStageId}"/></display:column>
                     
               <display:column title='<%= bundle.getString("validationStage.field.sourceSystemCd.displayName.txt") %>'><c:out value="${stage.sourceSystem}"/></display:column>
                     
               <c:if test="${model.interestTypesEnabled}">
                  <display:column title='<%= bundle.getString("userSelectWorkflowStage.action.stage.appliesToImpactTypes.txt") %>'><c:out value="${stage.interestTypes}"/></display:column>
               </c:if>
                     
               <c:if test="${model.stageTypesEnabled}">
                  <display:column title='<%= bundle.getString("userSelectWorkflowStage.action.stage.stageType.txt") %>'><c:out value="${stage.stageType}"/></display:column>
               </c:if>
                     
               <c:if test="${model.thresholdsEnabled}">
                  <display:column title='<%= bundle.getString("workflowStage.field.minThreshold.displayName.txt") %>'
                        property="minThreshold" />
                  <display:column title='<%= bundle.getString("workflowStage.field.maxThreshold.displayName.txt") %>'
                        property="maxThreshold" />
               </c:if>
               
               <%--
               <c:if test="${model.keyControlEnabled && model.soxRelatedEnabled}">
                  <display:column title='<%= bundle.getString("testDefinition.field.measure.displayName.txt") %>'><c:out value="${stage.controlTestingAppliesTo}"/></display:column>
               </c:if>
               --%>
               
               <c:if test="${model.keyControlEnabled}">
                  <display:column title='<%= bundle.getString("controlInstance.field.keyFlg.displayName.txt") %>'><c:out value="${stage.keyControl}"/></display:column>
               </c:if>
               
               <c:if test="${model.soxRelatedEnabled}">
                  <display:column title='<%= bundle.getString("controlInstance.field.soxFlg.displayName.txt") %>'
                        property="soxRelated" />
               </c:if>
               
                 
               
               <display:column title='<%= bundle.getString("validationStage.column.validators.displayName.txt") %>'>
                  <c:out value="${stage.validators}"/>
               </display:column>
            
               <%-- action columns --%>      
               <c:if test="${not model.readOnly and model.canEdit}">
                  <c:set var="first" value="${stage_rowNum == 1}"/>
                  <c:set var="last" value="${stage_rowNum == requestScope.model.numStages}"/>
               
                  <display:column width='1%' title='<%= bundle.getString("application.order.tooltip.txt") %>' align='center' headerClass="nwc">
                     <c:if test="${first}">
                        <img border="0" src="<fmt:message key='application.moveup.disabled.image' />" />&nbsp;
                     </c:if>
                     <c:if test="${not first}">
                        <a href="javascript:doStage('moveUp', '<c:out value="${stage.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.moveup.image' />" 
                           alt="<fmt:message key='application.moveup.tooltip.txt'/>" 
                           title="<fmt:message key='application.moveup.tooltip.txt'/>"/></a>&nbsp;
                     </c:if>
                     <c:if test="${last}">
                        <img border="0" src="<fmt:message key='application.movedown.disabled.image' />" />
                     </c:if>
                     <c:if test="${not last}">
                        <a href="javascript:doStage('moveDown', '<c:out value="${stage.handle}" />')"><img 
                           border="0" src="<fmt:message key='application.movedown.image' />" 
                           alt="<fmt:message key='application.movedown.tooltip.txt'/>" 
                           title="<fmt:message key='application.movedown.tooltip.txt'/>"/></a>
                     </c:if>
                  </display:column>
               
                  <display:column width='1%' title='<%= bundle.getString("application.delete.tooltip.txt") %>' align='center' headerClass="nwc">
            <%
               // double escape because it is going in an href
               String stageName = ParsingUtils.escape(ParsingUtils.escape(
                  ((ValidationModel.StageBean)stage).getName()));
            %>      
                     <a href="javascript:deleteStage('<c:out value="${stage.handle}" />', '<%= stageName %>')"><img 
                        border="0" src="<fmt:message key='application.delete.image' />" 
                        alt="<fmt:message key='application.delete.tooltip.txt'/>" 
                        title="<fmt:message key='application.delete.tooltip.txt'/>"/></a>
                  </display:column>
               </c:if>
            </mon:table>
            
            <c:if test='${model.readOnly}'>
               <%@ include file="SubsequentStages.jspf" %>
            </c:if>
                        
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

