<%@ page import="com.sas.oprisk.monitor.web.validation.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%    
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final ValidationStageModel model = (ValidationStageModel)request.getAttribute("model");
   boolean readOnly = false;

   String selectedResponsesStr = "";
   final String[] selectedResponsesArr = model.getSelectedResponses();
   if (selectedResponsesArr != null){
       for (int i = 0; i < selectedResponsesArr.length; i++){
          String selResp = selectedResponsesArr[i];
          selectedResponsesStr += selResp + ",";
       }
   }
   
   final boolean testConclusionEnabled = model.isTestConclusionEnabled();
   final String measureRk = testConclusionEnabled ? model.getMeasure() : "";
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript"
         src='<%= request.getContextPath()%>/dwr/interface/ControlTestingService.js'></script>
      <script type="text/javascript"
         src='<%= request.getContextPath()%>/dwr/engine.js'></script>
      <script type="text/javascript"
         src='<%= request.getContextPath()%>/dwr/util.js'></script>
      
      <script type="text/javascript">
      
      function go( method ) {
         var f = document.forms.validationStageFormEx;
         f.method.value = method;
         f.submit();
      }
      
      function doSave() {
         var f = document.forms.validationStageFormEx;
         f.action = "<%= request.getContextPath() %>/ValidationStageSave.do";
         f.method.value = "save";
         f.submit();
      }
      
      function doCancel() {
         var f = document.forms.validationStageFormEx;
         f.action = "<%= request.getContextPath() %>/Validation.do";
         f.method.value = "edit";
         f.submit();
      }
      
      function addUser() {
         popupAnchor = "#users";
         var f = document.forms.validationStageFormEx;
         openModal("<%= request.getContextPath() %>/UserQueryForValidationStage.do"
            + "?area=<c:out value='${model.area}' />"
            + "&validationType=" + f.validationType.value
                      + "&stageTypeCd=" + f.stageTypeCd.value,
            "validators_popup", "width=750,height=500,scrollbars,resizable");
      }
      
      function removeUser(user) {
         beginWait();
         var f = document.forms.validationStageFormEx;
         f.user.value = user;
         go("removeUser");
      }
      
      function userSelected(user) {
         beginWait();
         var f = document.forms.validationStageFormEx;
         f.user.value = user;
         go("addUser");
      }
      
      function updateConclusions( responses ){
         var selectedResponses = "<%= selectedResponsesStr %>";
         var result = "";
            
         if (responses && (responses !== undefined)) {
            for (var i=0; i < responses.length; i++){
               if (selectedResponses.indexOf(responses[i].value + ",") != -1 ){
                  result += "<input type='checkbox' name='selectedResponses' value=\"" + responses[i].value + "\" checked=\"checked\" />" + responses[i].label + "<br/>";
               }
               else {
                  result += "<input type='checkbox' name='selectedResponses' value=\"" + responses[i].value + "\" />" + responses[i].label + "<br/>";
               }
                  
            }
         }
         document.getElementById('testConclusionTd').innerHTML = result;
      }
      
      function measureChanged( measureRk ) {
         if (<%= testConclusionEnabled %>){
            var metaData = {
               callback: updateConclusions,
               timeout:0,
               errorHandler:function(errMsg) {alert(errMsg);}
            }
            ControlTestingService.getMeasureResponses(measureRk, metaData);
         
            return true;
         }
      }
      
      function monitorInit() {
         measureChanged("<%= measureRk %>");
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ValidationStage">      
         <mon:ToolBar>
            <c:choose>
               <c:when test="${model.readOnly }">
                  <mon:Button name="actionButtonCancel" onclick="doCancel()">
                     <fmt:message key="application.button.done.txt" />
                  </mon:Button>                
               </c:when>
               <c:otherwise>
                  <mon:Button name="actionButtonSave" onclick="doSave()">
                     <fmt:message key="application.ok.txt" />
                  </mon:Button>
                  <mon:Button name="actionButtonCancel" onclick="doCancel()">
                     <fmt:message key="application.button.cancel.txt" />
                  </mon:Button>                              
               </c:otherwise>              
            </c:choose>           
         </mon:ToolBar>
         
         <mon:Content>
            <input type="hidden" name="method" />
            <input type="hidden" name="user" />
            <html:hidden property="location" />
            <html:hidden property="validationType" />
            <html:hidden property="interestType" />
            
            <html:hidden property="handle" />
            <html:hidden property="validationStageRk" />
            <html:hidden property="orderNo" />
            <html:hidden property="localValidationSequence" />
            <html:hidden property="fresh" />
            
            <c:if test="${not empty validationStageFormEx.addedValidators}">
               <mon:hidden property="addedValidators" />
            </c:if>
            <c:if test="${not empty validationStageFormEx.removedValidators}">
               <mon:hidden property="removedValidators" />
            </c:if>
            <c:if test="${not empty validationStageFormEx.existedValidators}">
               <mon:hidden property="existedValidators" />
            </c:if>
            
            <mon:DimPointChooser 
               property="location"
               rootVisible="true"
               readOnly="true"
            />
            
            <br/>
            
            <table border="0">
               <tr>
                  <th class="fieldlabel">
                     <mon:label key='businessObjectLocalization.field.nameTxt.displayName.txt'
                        property='name' separatorVisible="true" />
                  </th>
                  <td class="field"><mon:text property='name' maxlength="200" 
                     disabled='<%= model.isReadOnly() %>' /></td>
               </tr>
               <tr>
                  <th class="fieldlabel">
                     <mon:label key='validationStage.field.validationStageId.displayName.txt'
                       property='validationStageId' separatorVisible="true" />
                  </th>
                  <td class="field"><mon:text property='validationStageId' maxlength="32" 
                     disabled='<%= model.isReadOnly() %>' /></td>
               </tr>
               <tr>
                  <th class="fieldlabel">
                     <mon:label key='validationStage.field.sourceSystemCd.displayName.txt'
                        property="sourceSystemCd" separatorVisible="true" />
                  </th>
                  <td class="field">
                     <mon:select property="sourceSystemCd" disabled='<%= model.isReadOnly() %>' >
                        <html:optionsCollection
                           name="model" property="sourceSystemCds"
                           label="description" value="code" />
                     </mon:select>
                  </td>
               </tr>
               
               <tr><td>&nbsp;</td></tr>   
               
               <c:if test='${model.interestTypesEnabled}'>
                  <tr>
                    <th class="fieldlabel">
                     <mon:label key='userSelectWorkflowStage.action.stage.appliesToImpactTypes.txt'
                        property="selectedInterestTypes" separatorVisible="true" />
                    </th>
                    <td>
                     <c:forEach var="interest" items="${model.interestTypes}">
                        <html:multibox
                              property="selectedInterestTypes">
                           <c:out value="${interest.value}"/>
                        </html:multibox>
                        <font class="text">
                           <fmt:message key='${interest.displayNameKey}'/>
                        </font>
                     </c:forEach>
                        <input type="hidden" name="selectedInterestTypes" value="" />
                    </td>
                  </tr>
               </c:if>
               <c:if test='${!model.interestTypesEnabled}'>
                  <html:hidden property="interestTypeCd" />
               </c:if>   
                  
               <c:if test='${model.stageTypesEnabled}'>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label key='userSelectWorkflowStage.action.stage.stageType.txt'
                                  property="stageTypeCd" separatorVisible="true" />
                     </th>
                     <td id="stageTypeTd">
                        <fmt:message key='${validationStageFormEx.stageTypeCdDisplayNameKey}' />
                     </td>
                  </tr>
               </c:if>
               <html:hidden property="stageTypeCd" />
               
               <c:if test='${model.thresholdsEnabled}'>
                  <tr>
                <th class="fieldlabel">
                      <mon:label key='workflowStage.field.minThreshold.displayName.txt'
                     property="minThreshold" separatorVisible="true" />
                </th>
                     <td>
                   <html:text property="minThreshold" size="10" />
                 </td>
               </tr>
               <tr>
                 <th class="fieldlabel">
                  <mon:label key='workflowStage.field.maxThreshold.displayName.txt'
                     property="maxThreshold" separatorVisible="true" />
                 </th>
                 <td>
                   <html:text property="maxThreshold" size="10" />
                 </td>
               </tr>
               </c:if>
               <c:if test='${!model.thresholdsEnabled}'>
                  <html:hidden property="minThreshold" />
                  <html:hidden property="maxThreshold" />
               </c:if>
               
               
               <c:if test='${model.keyControlEnabled}'>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label key='userSelectWorkflowStage.action.stage.keyControl.displayName.txt'
                                  property="keyControlFlg" separatorVisible="true" />
                     </th>
                     <td id="keyControlTd">
                        <mon:select property="keyControlFlg">
                           <html:optionsCollection name="model" 
                                 property="availableKeyControl" /> 
                        </mon:select>
                     </td>
                  </tr>
               </c:if>
               <html:hidden property="keyControlFlg" />
               
               <c:if test='${model.soxRelatedEnabled}'>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label key='userSelectWorkflowStage.action.stage.soxRelated.displayName.txt'
                                  property="soxRelatedFlg" separatorVisible="true" />
                     </th>
                     <td id="soxRelatedTd">
                        <mon:select property="soxRelatedFlg">
                           <html:optionsCollection name="model" 
                                 property="availableSoxRelated" />
                        </mon:select>
                     </td>
                  </tr>
               </c:if>
               <html:hidden property="soxRelatedFlg" />
               
               <c:if test='${model.controlTestingMeasureEnabled}'>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label key='userSelectWorkflowStage.action.stage.ctrlTestMeasure.displayName.txt'
                                  property="measure" separatorVisible="true" />
                     </th>
                     <td id="controlTestingMeasureTd">
                        <jsp:include page="/tiles/controlTesting/library/measureChooserFormField.jsp" flush="true"><jsp:param name="readOnly" value="<%= readOnly %>"/></jsp:include>
                     </td>
                  </tr>
               </c:if>
               
               <c:if test='${model.testConclusionEnabled}'>
                  <tr>
                     <th class="fieldlabel">
                        <mon:label key='userSelectWorkflowStage.action.stage.testConclusion.displayName.txt'
                                  property="testConclusion" separatorVisible="true" />
                     </th>
                     <td id="testConclusionTd"></td>
                  </tr>
               </c:if>
               
               
               
               
               
            </table>
            
            <br/>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="model.validators" id="user">
               <mon:title><fmt:message key="validationStage.validators.txt"/></mon:title>    
               
               <c:if test="${not model.readOnly}">
                  <mon:action href="javascript:addUser()"><fmt:message key='validationStage.button.addValidator.txt'/></mon:action>
               </c:if>
              
               <display:column title='<%= bundle.getString("user.field.userId.displayName.txt") %>'><c:out value="${user.userId}"/></display:column>
                     
               <display:column title='<%= bundle.getString("user.field.displayNm.displayName.txt") %>'><c:out value="${user.displayNm}"/></display:column>
               
               <display:column title='<%= bundle.getString("user.field.emailTxt.displayName.txt") %>'><c:out value="${user.emailTxt}"/></display:column> 
                  
               <c:if test="${not model.readOnly}">
                  <display:column width='1%' title='<%= bundle.getString("application.remove.txt") %>' align='center' headerClass="nwc">
                     <a href="javascript:removeUser('<c:out value="${user.handleString}" />')"><img 
                        border="0" src="<fmt:message key='application.remove.image' />"  
                        alt="<fmt:message key='application.remove.txt'/>" 
                        title="<fmt:message key='application.remove.txt'/>"/></a>
                  </display:column>
               </c:if>
            </mon:table>            
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

